; Assembler demo: 100 sample (=1ms) delay line

; Constants
size 	equ 	100 			; Size of buffer = delay value in samples
Fs	equ 	1e5 			; Sampling frequency

; Y data memory:
	org y:
buffer 	dsm 	size 		; Reserve a buffer for modulo(size) addressing
; Program memory:
	org p:
main 					; Program starts here
	jsr 	init 			; Call initialization routine for pointer register
loop 	ada 	Fs 			; Wait for a sample
	move	y:(r0),a 		; Read oldest data in buffer,
	move 	a,x:da2 		; write it to DA2
	move 	x:ad1,a 		; Read ADC1 result
	move 	a,y:(r0)+ 		; write it over oldest data, then increment pointer modulo(buffer)
	move	a,x:da1 		; write it also to DA1 for oscilloscope display
	jmp loop 			; wait and process next sample

; Initialization routine

init 	move 	#buffer,r0 		; r0 points at the begining of buffer
	move 	#size-1,m0 		; m0=size-1 implies modulo(size) addressing
	clr a 			; A = 0. Here, we shall clear the buffer before the main loop starts
	rep #size 			; Repeat following instruction 100 times
	move a,y:(r0)+ 		; Write 0 at address (R0), then increment R0, modulo buffer
	rts 				; Now R0 points Buffer again. Return to main program

