; EPILOGUE of program (compiler mode: ASM + Startup)



; ---------------- INITIALIZATIONS ----------------------
	org	p:	
inits	movec	#0,vba		; Define vector table base address at 0
	movec	#$1b00,ep		; Define Extension stack address ...
	bset	#16,omr		;      ... and memory field (y:)
	bset	#20,omr		; Enable E-stack
	bsr	inipll		; initialize Phase locked loop
	bsr	inics			; Initialize Chip Selects
	bsr     inisci		; Initialize Serial Port
  if	@def(ada_flag)
	bsr	iniada		; Initialize Timer0 for AD/DA conversions
	if	interruptible
	movep	#$0003C0,x:iprp	; activate timer interrupts + SCI Interrupts
	else
	movep	#$000300,x:iprp	; activate timer interrupts 
	endif
	andi	#$fc,mr		; unmask interrupts
	nop
  endif
	rts

	if	interruptible
scirxerr
	reset
	movec	#0,sp
	jmp debugger
	endif

;	nolist

;---------------------------------------------------------		
; Standard Mu.Psi PLL configuration

pen	set	1	; PLL active
df	set	0	; divide factor 0..7 => 1..128 (for power saving)
mf	set	pll_num-1	;  coding 
pd	set	pll_den-1	; pdf coding
pstp	set	0	; stop clock while in STOP state
cod	set	0	; clkout output active

	if	pen
fdsp	gset	fext*pll_num/(pll_den*@pow(2,df))
	else
fdsp	gset	fext/2.
	endif	
	
;; PCTL	=	pd3..pd0 cod pen pstp xtld xtlr df2 df1 df0 mf11...mf0
;;		   pd    cod pen pstp  1    0       df          mf

inipll	move	#>pd*$100000+cod*$80000+pen*$40000+pstp*$20000+$10000+df*$1000+mf,a
	move	a,x:pctl
	rts
;	nolist
	msg	' >>> DSP Clock  = ',@cvi(fdsp/1000.),' kHz'
;	list

;---------------------------------------------------------------------------

;; AA0 Chip Select programmation  (AD/DA selection)
;;
;; 1111 1111 1111 1100 0    0  1    0    0    0    01	= fffc21 
;; xxxx xxxx xxxx xxxx x    x  x    x    x    x    xx
;; <--- bac  ---> bnc  bpac 0  byen bxen bpen baap bat

inics	movep	#$fffc21,x:aar0
	rts

;----------------------------------------------------------------------
; init serial port
	if 	interruptible
inisci  movep   #$010302,x:scr 	; enable RX error IRQ 
	else	
inisci  movep   #$0302,x:scr
	endif
        movep   #$c000,x:sccr
        movep   #7,x:pcre
	rts  
;----------------------------------------------------------------------
;	list  
  if	@def(ada_flag)

; init AD/DA sampling task
iniada
ada_ws	set	@cvi(fdsp*4.e-8)
	if	ada_ws<1
ada_ws	set	1
	endif
	movep	#>$3FFFE0+ada_ws,x:bcr
;
; periode = 2*tcpr/fdsp
; x x tcf tof x x x x pce x do di dir x trm inv tc3..tc0 x tcie toie te
; 0 0  1   1  0 0 0 0  0  0 0  0  0   0  1   0   0111    0  1    0    1
;     3      .   0    .    0     .      2      .   7   .      5

nper_t0	set	@cvi(fdsp/(2.*desired_fs))
nwdt_t0 set	nper_t0/2

	movep	#-nper_t0,x:tlr0
	movep	#0,x:tcpr0
	movep	#$300A75,x:tcsr0
	brclr	#20,x:tcsr0,*	; wait for TOF
	movep	#-nwdt_t0,x:tcpr0
	rts



; ------------------------------------------------------------------
; ADA interrupt routine

irqtim0
	movep	y:$fffffe,x:ad1
	movep	y:$ffffff,x:ad2
	movep	x:da1,y:$fffffe
	movep	x:da2,y:$ffffff
	bset	#21,x:tcsr0
	bset	#0,x:ada_flag
	rti


; Timer Interrupt vector

	org	p:$24	
vec_ada	jsr	irqtim0

  endif