	nolist
virqa	equ	$10
virqb	equ	$12
virqc	equ	$14
virqd	equ	$16



; 
hdr	equ	$ffffc9	; ps- host port gpio data register
hddr	equ	$ffffc8	; ps- host port gpio direction register
pcrc	equ	$ffffbf	; port c control register
prrc	equ	$ffffbe	; port c direction register
pdrc	equ	$ffffbd	; port c gpio data register
pcrd	equ	$ffffaf	; port d control register
prrd	equ	$ffffae	; port d direction data register
pdrd	equ	$ffffad	; port d gpio data register
pcre	equ	$ffff9f	; port e control register
prre	equ	$ffff9e	; port e direction register
pdre	equ	$ffff9d	; port e data register
ogdb	equ	$fffffc	; once gdb register 

;------------------------------------------------------------------------

hcr	equ	$ffffc2	; host control register
hsr	equ	$ffffc3	; host status rgister
hpcr	equ	$ffffc4	; host polarity control register
hbar	equ	$ffffc5	; host base address register
hrx	equ	$ffffc6	; host receive register
htx	equ	$ffffc7	; host transmit register


;------------------------------------------------------------------------

stxh	equ	$ffff97	; sci transmit data register (high)
stxm	equ	$ffff96	; sci transmit data register (middle)
stxl	equ	$ffff95	; sci transmit data register (low)
srxh	equ	$ffff9a	; sci receive data register (high)
srxm	equ	$ffff99	; sci receive data register (middle)
srxl	equ	$ffff98	; sci receive data register (low)
stxa	equ	$ffff94	; sci transmit address register
scr	equ	$ffff9c	; sci control register
ssr	equ	$ffff93	; sci status register
sccr	equ	$ffff9b	; sci clock control register

;------------------------------------------------------------------------

tx0	equ	$ffffbc	; ssi0 transmit data register 0
tx00	equ	$ffffbc	; ssi0 transmit data register 0
tx01	equ	$ffffbb	; ssi0 transmit data register 1
tx02	equ	$ffffba	; ssi0 transmit data register 2
tsr0	equ	$ffffb9	; ssi0 time slot register
rx0	equ	$ffffb8	; ssi0 receive data register
ssisr0 equ	$ffffb7	; ssi0 status register
crb0	equ	$ffffb6	; ssi0 control register b
cra0	equ	$ffffb5	; ssi0 control register a
tsma0	equ	$ffffb4	; ssi0 transmit slot mask register a
tsmb0	equ	$ffffb3	; ssi0 transmit slot mask register b
rsma0	equ	$ffffb2	; ssi0 receive slot mask register a
rsmb0	equ	$ffffb1	; ssi0 receive slot mask register b

	
tx1	equ	$ffffac	; ssi1 transmit data register 0
tx10	equ	$ffffac	; ssi1 transmit data register 0
tx11	equ	$ffffab	; ssi1 transmit data register 1
tx12	equ	$ffffaa	; ssi1 transmit data register 2
tsr1	equ	$ffffa9	; ssi1 time slot register
rx1	equ	$ffffa8	; ssi1 receive data register
ssisr1	equ	$ffffa7	; ssi1 status register
crb1	equ	$ffffa6	; ssi1 control register b
cra1	equ	$ffffa5	; ssi1 control register a
tsma1	equ	$ffffa4	; ssi1 transmit slot mask register a
tsmb1	equ	$ffffa3	; ssi1 transmit slot mask register b
rsma1	equ	$ffffa2	; ssi1 receive slot mask register a
rsmb1	equ	$ffffa1	; ssi1 receive slot mask register b

;------------------------------------------------------------------------

iprc	equ	$ffffff	; interrupt priority register core
iprp	equ	$fffffe	; interrupt priority register peripheral

;------------------------------------------------------------------------

tcsr0	equ	$ffff8f	; timer0 control/status register	
tlr0	equ	$ffff8e	; timer0 load reg	
tcpr0	equ	$ffff8d	; timer0 compare register
tcr0	equ	$ffff8c ; timer0 count register


tcsr1	equ	$ffff8b	; timer1 control/status register	
tlr1	equ	$ffff8a	; timer1 load reg	
tcpr1	equ	$ffff89	; timer1 compare register
tcr1	equ	$ffff88	; timer1 count register

tcsr2	equ	$ffff87	; timer2 control/status register	
tlr2	equ	$ffff86	; timer2 load reg	
tcpr2	equ	$ffff85	; timer2 compare register
tcr2	equ	$ffff84	; timer2 count register
tplr	equ	$ffff83 ; timer prescaler load register
tpcr	equ	$ffff82	; timer prescalar count register

;------------------------------------------------------------------------

dstr	equ	$fffff4	; dma status register
dor0	equ	$fffff3	; dma offset register 0
dor1	equ	$fffff2	; dma offset register 1
dor2	equ	$fffff1	; dma offset register 2
dor3	equ	$fffff0	; dma offset register 3

dsr0	equ	$ffffef	; dma0 source address register
ddr0	equ	$ffffee	; dma0 destination address register 
dco0	equ	$ffffed	; dma0 counter
dcr0	equ	$ffffec	; dma0 control register 

dsr1	equ	$ffffeb	; dma1 source address register
ddr1	equ	$ffffea	; dma1 destination address register 
dco1	equ	$ffffe9	; dma1 counter
dcr1	equ	$ffffe8	; dma1 control register

dsr2	equ	$ffffe7	; dma2 source address register
ddr2	equ	$ffffe6	; dma2 destination address register 
dco2	equ	$ffffe5	; dma2 counter
dcr2	equ	$ffffe4	; dma2 control register
 
dsr3	equ	$ffffe3	; dma3 source address register
ddr3	equ	$ffffe2	; dma3 destination address register 
dco3	equ	$ffffe1	; dma3 counter
dcr3	equ	$ffffe0	; dma3 control register

dsr4	equ	$ffffdf	; dma4 source address register
ddr4	equ	$ffffde	; dma4 destination address register 
dco4	equ	$ffffdd	; dma4 counter
dcr4	equ	$ffffdc	; dma4 control register 

dsr5	equ	$ffffdb	; dma5 source address register
ddr5	equ	$ffffda	; dma5 destination address register 
dco5	equ	$ffffd9	; dma5 counter
dcr5	equ	$ffffd8	; dma5 control register

;------------------------------------------------------------------------

pctl	equ	$fffffd	; pll control register

;------------------------------------------------------------------------

bcr	equ	$fffffb	; bus control register
dcr	equ	$fffffa	; dram control register
aar0	equ	$fffff9	; address attribute register 0 
aar1	equ	$fffff8	; address attribute register 1 
aar2	equ	$fffff7	; address attribute register 2 
aar3	equ	$fffff6	; address attribute register 3 
idr	equ	$fffff5	; id register

	list
	