;; FILTERBANK
;; Bandpass Filter Bank
;; Bank of 2nd order filters with equal Q and equal gain at resonance
;; Resonant frequencies are regularily spaced in 
;; geometric sequence between Freq_low and Freq_High
;; Number of filters is determined by output array size

filterbank	macro	name,flow,fhigh,gain
name\_m	set	fhigh/flow
name\_e	set	1./(name\_size-1)
name\_k	set	@pow(name\_m,name\_e)
name\_q	set	@sqt(name\_k)/(name\_k-1.0)
name\_f	set	flow
nmax	set	name\_size-1
	dupf	num,0,nmax
 section vars global
name\num\_in	equ	name\_in
 endsec
 section far global 
name\num		equ	name+num
 endsec
	iir2	name\num,bp,name\_f,name\_q,Hz
name\_f	set	name\_f*name\_k
	endm
	endm
