	opt	ic	; ignore case in symbol constants
	nolist
;**************************************************************************
;***
;***	Copyright 2007, Freescale, Inc.  All rights reserved.
;***
;**************************************************************************
;***
;***	Equates for 56720/56721
;***
;***	Please note:  Not all equates below are usable with all device
;***	options for the 56720/56721.  Please consult the particular 
;***	reference manual for more information.
;***
;**************************************************************************  

	; Only include this file once.
	if @DEF(INCLUDED_EQUATES_INC)
	; File has already been included so no need to include again.
	else
INCLUDED_EQUATES_INC	equ	1

;===========================================================


I_VEC   EQU $0
YIO     EQU $FFFFC0



; =====  X SPACE  =========================================
DSP_CORE    EQU $FFFFC0

; =============== Interrupt Control =======================
INT_BASE      EQU $FFFFF9      ;X space: Interrupt base
; =========================================================
; PIC
; =========================================================
IPRC        EQU INT_BASE+$6 ;X space: Core Interrupt Priority Register
IPRP        EQU INT_BASE+$5 ;X space: Peripheral Interrupt Priority Register

; =========================================================
; PIC1
; =========================================================

IPRC1       EQU INT_BASE+$2 ;X space: Core Interrupt Priority Register
IPRP1       EQU INT_BASE+$1 ;X space: Peripheral Interrupt Priority Register

; ================ CIM ====================================
OGDB          EQU $FFFFFC
CIBASE      EQU $FFFFF5
CHIDR       EQU CIBASE
COIDR       EQU CIBASE+$1
DMAS        EQU CIBASE+$3

; =============== DMA ======================================
DMA_BASE_ADDR    EQU $FFFFD0
; ==========================================================

; =============== DMA Usual Control ================================
DSTR        EQU DMA_BASE_ADDR+$24 ;X space: DMA Status Register
DOR0        EQU DMA_BASE_ADDR+$23 ;X space: DMA Offset Register 0
DOR1        EQU DMA_BASE_ADDR+$22 ;X space: DMA Offset Register 1
DOR2        EQU DMA_BASE_ADDR+$21 ;X space: DMA Offset Register 2
DOR3        EQU DMA_BASE_ADDR+$20 ;X space: DMA Offset Register 3

; =============== DMA Channel 0 ================================
DSR0        EQU DMA_BASE_ADDR+$1F ;X space: DMA Source Address Register
DDR0        EQU DMA_BASE_ADDR+$1E ;X space: DMA Destination Address Register
DCO0        EQU DMA_BASE_ADDR+$1D ;X space: DMA Counter
DCR0        EQU DMA_BASE_ADDR+$1C ;X space: DMA Control Register

; =============== DMA Channel 1 ================================
DSR1        EQU DMA_BASE_ADDR+$1B ;X space: DMA Source Address Register
DDR1        EQU DMA_BASE_ADDR+$1A ;X space: DMA Destination Address Register
DCO1        EQU DMA_BASE_ADDR+$19 ;X space: DMA Counter
DCR1        EQU DMA_BASE_ADDR+$18 ;X space: DMA Control Register

; =============== DMA Channel 2 ================================
DSR2        EQU DMA_BASE_ADDR+$17 ;X space: DMA Source Address Register
DDR2        EQU DMA_BASE_ADDR+$16 ;X space: DMA Destination Address Register
DCO2        EQU DMA_BASE_ADDR+$15 ;X space: DMA Counter
DCR2        EQU DMA_BASE_ADDR+$14 ;X space: DMA Control Register

; =============== DMA Channel 3 ================================
DSR3        EQU DMA_BASE_ADDR+$13 ;X space: DMA Source Address Register
DDR3        EQU DMA_BASE_ADDR+$12 ;X space: DMA Destination Address Register
DCO3        EQU DMA_BASE_ADDR+$11 ;X space: DMA Counter
DCR3        EQU DMA_BASE_ADDR+$10 ;X space: DMA Control Register

; =============== DMA Channel 4 ================================
DSR4        EQU DMA_BASE_ADDR+$0F ;X space: DMA Source Address Register
DDR4        EQU DMA_BASE_ADDR+$0E ;X space: DMA Destination Address Register
DCO4        EQU DMA_BASE_ADDR+$0D ;X space: DMA Counter
DCR4        EQU DMA_BASE_ADDR+$0C ;X space: DMA Control Register

; =============== DMA Channel 5 ================================
DSR5        EQU DMA_BASE_ADDR+$0B ;X space: DMA Source Address Register
DDR5        EQU DMA_BASE_ADDR+$0A ;X space: DMA Destination Address Register
DCO5        EQU DMA_BASE_ADDR+$09 ;X space: DMA Counter
DCR5        EQU DMA_BASE_ADDR+$08 ;X space: DMA Control Register

; =============== DMA Channel 6 ================================
DSR6        EQU DMA_BASE_ADDR+$07 ;X space: DMA Source Address Register
DDR6        EQU DMA_BASE_ADDR+$06 ;X space: DMA Destination Address Register
DCO6        EQU DMA_BASE_ADDR+$05 ;X space: DMA Counter
DCR6        EQU DMA_BASE_ADDR+$04 ;X space: DMA Control Register

; =============== DMA Channel 7 ================================
DSR7        EQU DMA_BASE_ADDR+$03 ;X space: DMA Source Address Register
DDR7        EQU DMA_BASE_ADDR+$02 ;X space: DMA Destination Address Register
DCO7        EQU DMA_BASE_ADDR+$01 ;X space: DMA Counter
DCR7        EQU DMA_BASE_ADDR+$00 ;X space: DMA Control Register

; ============== DMA control register bit-fields ==========
CT_DE EQU  $17        ; DMA channel enable
DIE   EQU  $16        ; DMA interrupt enable
DTM2  EQU  $15        ; DMA txfer mode
DTM1  EQU  $14
DTM0  EQU  $13
DPR1  EQU  $12        ; DMA channel priority
DPR0  EQU  $11
DCON  EQU  $10        ; DMA continuous mode enable
DRS4  EQU  $0F        ; DMA request source
DRS3  EQU  $0E
DRS2  EQU  $0D
DRS1  EQU  $0C
DRS0  EQU  $0B
D3D   EQU  $0A        ; three-dimensional mode
DAM5  EQU  $09        ; DMA address mode
DAM4  EQU  $08
DAM3  EQU  $07
DAM2  EQU  $06
DAM1  EQU  $05
DAM0  EQU  $04
DDS1  EQU  $03        ; DMA destination space
DDS0  EQU  $02
DSS1  EQU  $01        ; DMA source space
DSS0  EQU  $00

; ================= DMA status register bit-fields ==========
DCH2  EQU  $0B
DCH1  EQU  $0A
DCH0  EQU  $09
DACT  EQU  $08
DTD7  EQU  $07
DTD6  EQU  $06
DTD5  EQU  $05
DTD4  EQU  $04
DTD3  EQU  $03
DTD2  EQU  $02
DTD1  EQU  $01
DTD0  EQU  $00

; ================= DMA request sources definition ==========
DRS_IRQA       EQU $00
DRS_IRQB       EQU $01
DRS_IRQC       EQU $02
DRS_IRQD       EQU $03 ;IRQA~D are for DMA channels 0-5 only 
DRS_0DONE      EQU $04 ;DMA Transfer done for DMA channels 
DRS_1DONE      EQU $05 
DRS_2DONE      EQU $06 
DRS_3DONE      EQU $07 
DRS_4DONE      EQU $08 
DRS_5DONE      EQU $09 
DRS_6DONE      EQU $00 ;for DMA Channel 6-7 only 
DRS_7DONE      EQU $01 ;for DMA Channel 6-7 only 
DRS_ESAI02_RX  EQU $0B 
DRS_ESAI02_TX  EQU $0C 
DRS_SHI_HTXE   EQU $0D ;SHI Transmit Empty 
DRS_SHI_FIFONE EQU $0E ;SHI FIFO not Empty 
DRS_SHI_FIFOF  EQU $0F ;SHI FIFO Full 
DRS_HDI_RX     EQU $10 ;HDI Receiving Full 
DRS_HDI_TX     EQU $11 ;HDI Transmit Empty 
DRS_TIMER0     EQU $12 
DRS_TIMER1     EQU $13 
DRS_TIMER2     EQU $14 
DRS_ESAI13_RX  EQU $15 
DRS_ESAI13_TX  EQU $16 
DRS_SPDIF_TX   EQU $17 
DRS_SPDIF_RX   EQU $18 
DRS_ASRC_RX0   EQU $1A 
DRS_ASRC_RX1   EQU $1B 
DRS_ASRC_RX2   EQU $1C 
DRS_ASRC_TX0   EQU $1D 
DRS_ASRC_TX1   EQU $1E 
DRS_ASRC_TX2   EQU $1F

; =============== HDI24 ==================================
DSP_CORE_X_HDI EQU $FFFFC0
; ========================================================
HCR   EQU DSP_CORE_X_HDI+$2 ; X Space: Host Control Register 
HSR   EQU DSP_CORE_X_HDI+$3 ; X Space: Host Status Register 
HPCR  EQU DSP_CORE_X_HDI+$4 ; X Space: Host Port Control Register
HBAR  EQU DSP_CORE_X_HDI+$5 ; X Space: Host Base Address Register
HORX  EQU DSP_CORE_X_HDI+$6 ; X Space: Host Receive Register 
HOTX  EQU DSP_CORE_X_HDI+$7 ; X Space: Host Transmit Register
HDDR  EQU DSP_CORE_X_HDI+$8 ; X Space: Host Data Direction Register
HDR   EQU DSP_CORE_X_HDI+$9 ; X Space: Host Data Register
HDDR1 EQU DSP_CORE_X_HDI+$A ; X Space: Host Data Direction Register
HDR1  EQU DSP_CORE_X_HDI+$B ; X Space: Host Data Register

; =============== Port C & Port C_1==============================
ESAI      EQU $FFFFA0
PCRC       EQU ESAI+$1F ;X space: Port C & Port C_1 Control Register
PRRC       EQU ESAI+$1E ;X space: Port C & Port C_1 Data Direction Register
PDRC       EQU ESAI+$1D ;X space: Port C & Port C_1 Data Register

SL    EQU  $3         ; Mask interupt priority for ESAI & ESAI_2
SL_1  EQU  $C00       ; Mask interupt priority for ESAI_1 & ESAI_3

;
; =============== ESAI & ESAI_2 ==================================
RSMB     EQU ESAI+$1C ;X space: ESAI & ESAI_2 Receive Slot Mask Register B
RSMA     EQU ESAI+$1B ;X space: ESAI & ESAI_2 Receive Slot Mask Register A
TSMB     EQU ESAI+$1A ;X space: ESAI & ESAI_2 Transmit Slot Mask Register B
TSMA     EQU ESAI+$19 ;X space: ESAI & ESAI_2 Transmit Slot Mask Register A
RCCR     EQU ESAI+$18 ;X space: ESAI & ESAI_2 Receive Clock Control Register
RCR      EQU ESAI+$17 ;X space: ESAI & ESAI_2 Receive Control Register
TCCR     EQU ESAI+$16 ;X space: ESAI & ESAI_2 Transmit Clock Control Register
TCR      EQU ESAI+$15 ;X space: ESAI & ESAI_2 Transmit Control Register
SAICR    EQU ESAI+$14 ;X space: ESAI & ESAI_2 Common Control Register
SAISR    EQU ESAI+$13 ;X space: ESAI & ESAI_2 Status Register
;
RX3      EQU ESAI+$0B ;X space: ESAI & ESAI_2 Receive Data Register 3
RX2      EQU ESAI+$0A ;X space: ESAI & ESAI_2 Receive Data Register 2
RX1      EQU ESAI+$09 ;X space: ESAI & ESAI_2 Receive Data Register 1
RX0      EQU ESAI+$08 ;X space: ESAI & ESAI_2 Receive Data Register 0
;
TSR      EQU ESAI+$06 ;X space: ESAI & ESAI_2 Time Slot Register
TX5      EQU ESAI+$05 ;X space: ESAI & ESAI_2 Transmit Data Register 5
TX4      EQU ESAI+$04 ;X space: ESAI & ESAI_2 Transmit Data Register 4
TX3      EQU ESAI+$03 ;X space: ESAI & ESAI_2 Transmit Data Register 3
TX2      EQU ESAI+$02 ;X space: ESAI & ESAI_2 Transmit Data Register 2
TX1      EQU ESAI+$01 ;X space: ESAI & ESAI_2 Transmit Data Register 1
TX0      EQU ESAI+$00 ;X space: ESAI & ESAI_2 Transmit Data Register 0

;------------------------------------------------------------------------
; ESAI & ESAI_2 Interrupts
;------------------------------------------------------------------------

I_SIRD   EQU  I_VEC+$30   ; ESAI & ESAI_2 Receive Data
I_SIRED  EQU  I_VEC+$32   ; ESAI & ESAI_2 Receive Even Data
I_SIRDE  EQU  I_VEC+$34   ; ESAI & ESAI_2 Receive Data With Exception Status
I_SIRLS  EQU  I_VEC+$36   ; ESAI & ESAI_2 Receive Last Slot
I_SITD   EQU  I_VEC+$38   ; ESAI & ESAI_2 Transmit Data
I_SITED  EQU  I_VEC+$3A   ; ESAI & ESAI_2 Transmit Even Data
I_SITDE  EQU  I_VEC+$3C   ; ESAI & ESAI_2 Transmit Data With Exception Status
I_SITLS  EQU  I_VEC+$3E   ; ESAI & ESAI_2 Transmit Last Slot

;------------------------------------------------------------------------
; ESAI_1 & ESAI_3 Interrupts
;------------------------------------------------------------------------
I_SIRD_1   EQU  I_VEC+$70   ; ESAI_1 & ESAI_3 Receive Data
I_SIRED_1  EQU  I_VEC+$72   ; ESAI_1 & ESAI_3 Receive Even Data
I_SIRDE_1  EQU  I_VEC+$74   ; ESAI_1 & ESAI_3 Receive Data With Exception Status
I_SIRLS_1  EQU  I_VEC+$76   ; ESAI_1 & ESAI_3 Receive Last Slot
I_SITD_1   EQU  I_VEC+$78   ; ESAI_1 & ESAI_3 Transmit Data
I_SITED_1  EQU  I_VEC+$7A   ; ESAI_1 & ESAI_3 Transmit Even Data
I_SITDE_1  EQU  I_VEC+$7C   ; ESAI_1 & ESAI_3 Transmit Data With Exception Status
I_SITLS_1  EQU  I_VEC+$7E   ; ESAI_1 & ESAI_3 Transmit Last Slot

; ======================================================
; GPIO_PORT_H
; ======================================================
GPIO_PORT_H_BASE  EQU $FFFF98
PDRH     EQU GPIO_PORT_H_BASE
PRRH     EQU GPIO_PORT_H_BASE+$1
PCRH     EQU GPIO_PORT_H_BASE+$2

; =============== SHI 0 ===================================
SHI_0       EQU $FFFF90
HRX0      EQU SHI_0+$04 ;X space: SHI 0 Receive FIFO
HTX0      EQU SHI_0+$03 ;X space: SHI 0 Transmit Register
HSAR0     EQU SHI_0+$02 ;X space: SHI 0 Slave Address Register
HCSR0     EQU SHI_0+$01 ;X space: SHI 0 Control/Status Register
HCKR0     EQU SHI_0+$00 ;X space: SHI 0 Clock Control Register
DMA_SHI_TX  EQU $0D
DMA_SHI_RXNE EQU $0E
DMA_SHI_RXFF EQU $0F 
; =============== SHI 1 ===================================
SHI_1       EQU $FFFF90
HRX1      EQU SHI_1+$04 ;X space: SHI 1 Receive FIFO
HTX1      EQU SHI_1+$03 ;X space: SHI 1 Transmit Register
HSAR1     EQU SHI_1+$02 ;X space: SHI 1 Slave Address Register
HCSR1     EQU SHI_1+$01 ;X space: SHI 1 Control/Status Register
HCKR1     EQU SHI_1+$00 ;X space: SHI 1 Clock Control Register
DMA_1_SHI_TX  EQU $0D
DMA_1_SHI_RXNE EQU $0E
DMA_1_SHI_RXFF EQU $0F 

;============ SHI_0&SHI_1 Control Status Reg bits
HEN	 EQU	 0 	; SHI enable     
HI2C	 EQU	 1 	; I2C mode
HM0	 EQU     2 	; Host mode 
HM1	 EQU     3 	; Host mode
HCKFR  EQU 	 4 	; Clock freeze
HFIFO	 EQU 	 5 	; FIFO enable
HMST	 EQU 	 6 	; Master
HRQE0	 EQU 	 7 	; Request enable
HRQE1	 EQU 	 8 	; Request enable
HIDLE	 EQU 	 9 	; Idle
HBIE	 EQU 	 10	; Bus error int enable
HTIE	 EQU 	 11	; Transmit in enable
HRIE0	 EQU 	 12	; Receive int enable
HRIE1	 EQU 	 13	; Receive int enable
HTUE	 EQU 	 14	; Transmit underrun error
HTDE   EQU 	 15	; Transmit data empty
HRNE   EQU     17	; Receive FIFO not empty
HRFF   EQU     19	; Receive FIFO full
HROE   EQU     20	; Receive overrun error
HBER   EQU     21	; Bus Error
HBUSY  EQU     22	; Busy
;------------------------------------------------------------------------
; SHI_0&SHI_1 Interrupts
;------------------------------------------------------------------------
I_KTD    EQU  I_VEC+$40   ; SHI Transmit Data 
I_KTUE   EQU  I_VEC+$42   ; SHI Transmit Underrun Error
I_KRFNE  EQU  I_VEC+$44   ; SHI Receive FIFO Not Empty
I_KRFF   EQU  I_VEC+$48   ; SHI Receive FIFO Full
I_KROE   EQU  I_VEC+$4A   ; SHI Receive Overrun Error
I_KBE    EQU  I_VEC+$4C   ; SHI Bus Error

; ===================================
; TEC
;====================================
DSP_CORE_X_TEC EQU $FFFF80
; ===================================
TPCR  EQU DSP_CORE_X_TEC+$2 ; X Space: Timer Prescaler Counter Register
TPLR  EQU DSP_CORE_X_TEC+$3 ; X Space: Timer Prescaler Load Register
TCR2  EQU DSP_CORE_X_TEC+$4 ; X Space: Timer2 Count Register
TCPR2 EQU DSP_CORE_X_TEC+$5 ; X Space: Timer2 Compare Register
TLR2  EQU DSP_CORE_X_TEC+$6 ; X Space: Timer2 Load Register
TCSR2 EQU DSP_CORE_X_TEC+$7 ; X Space: Timer2 Control Status Register
TCR1  EQU DSP_CORE_X_TEC+$8 ; X Space: Timer1 Count Register
TCPR1 EQU DSP_CORE_X_TEC+$9 ; X Space: Timer1 Compare Register
TLR1  EQU DSP_CORE_X_TEC+$A ; X Space: Timer1 Load Register
TCSR1 EQU DSP_CORE_X_TEC+$B ; X Space: Timer1 Control Status Register
TCR0  EQU DSP_CORE_X_TEC+$C ; X Space: Timer0 Count Register
TCPR0 EQU DSP_CORE_X_TEC+$D ; X Space: Timer0 Compare Register
TLR0  EQU DSP_CORE_X_TEC+$E ; X Space: Timer0 Load Register
TCSR0 EQU DSP_CORE_X_TEC+$F ; X Space: Timer0 Control Status Register

; ====================================
; CGM
; ====================================
CHIP_CGBASE    EQU $FFFF7C
;=====================================
; =============== Chip Configuration Registers Block.======
CGPCTL    EQU CHIP_CGBASE+$1 
                  ;X space: PLL Control Register.
CGASCDR   EQU CHIP_CGBASE+$2 
                  ;X space: ASRC divider Config Register.
CGSPCDR   EQU CHIP_CGBASE+$3 
                  ;X space: SPDIF divider Config Register.
CGSPENA   EQU CHIP_CGBASE+$0 
                  ;X space: Shared perapheral clock gate enables.

;;=============== SPDIF ==================================
;;
SPDIF EQU   $FFFF60
SCR   EQU   SPDIF+$0      ; SPDIF config
SRCD  EQU   SPDIF+$1      ; SPDIF CD text control
SRPC  EQU   SPDIF+$2      ; SPDIF phase config
SIE   EQU   SPDIF+$3      ; SPDIF interrupt enable
SIS   EQU   SPDIF+$4      ; SPDIF interrupt status
SIC   EQU   SPDIF+$4      ; SPDIF interrupt clear
SRL   EQU   SPDIF+$5      ; SPDIF receive left
SRR   EQU   SPDIF+$6      ; SPDIF receive right
SRCSH EQU   SPDIF+$7      ; SPDIF receive C channel high
SRCSL EQU   SPDIF+$8      ; SPDIF receive C channel low
SRU   EQU   SPDIF+$9      ; SPDIF receive U channel
SRQ   EQU   SPDIF+$a      ; SPDIF receive Q channel
STL   EQU   SPDIF+$b      ; SPDIF transmit left channel
STR   EQU   SPDIF+$c      ; SPDIF transmit right channel
STCSH EQU   SPDIF+$d      ; SPDIF transmit C channel high
STCSL EQU   SPDIF+$e      ; SPDIF transmit C channel low
STUH  EQU   SPDIF+$f      ; SPDIF transmit U channel high
STUL  EQU   SPDIF+$10     ; SPDIF transmit U channel low
SRFM  EQU   SPDIF+$11     ; SPDIF frequency measurement
STC   EQU   SPDIF+$14     ; SPDIF transmit clcock control status
;;
;; =============== Port F ==================================
;;
PDRF  EQU   SPDIF+$15     ;Y space: Port F Data Register
PRRF  EQU   SPDIF+$16     ;Y space: Port F Data Direction Register
PCRF  EQU   SPDIF+$17     ;Y space: Port F Control Register
;;

;=====X Space =====

EMC_BASE       EQU    $FFFE00

EMC_LCRRH     EQU    EMC_BASE+$6B ; EMC Clock ratio register high part 
EMC_LCRRL	EQU    EMC_BASE+$6A ; EMC Clock ratio register low part 
EMC_LBCRH	EQU    EMC_BASE+$69 ; EMC Configuration register high part 
EMC_LBCRL	EQU    EMC_BASE+$68 ; EMC Configuration register low part 

; Reserved from EMC_BASE+$67 to EMC_BASE+$62
EMC_LTEARH	EQU    EMC_BASE+$61 ; EMC Transfer error address register high part 
EMC_LTEARL	EQU    EMC_BASE+$60 ; EMC Transfer error address register low part 
EMC_LTEATRH	EQU    EMC_BASE+$5F ; EMC Transfer error attributes register high part 
EMC_LTEATRL	EQU    EMC_BASE+$5E ; EMC Transfer error attributes register low part 
EMC_LTEIRH	EQU    EMC_BASE+$5D ; EMC Transfer error interrupt register high part 
EMC_LTEIRL	EQU    EMC_BASE+$5C ; EMC Transfer error interrupt register low part 
EMC_LTEDRH	EQU    EMC_BASE+$5B ; EMC Transfer error disable register high part 
EMC_LTEDRL	EQU    EMC_BASE+$5A ; EMC Transfer error disable register low part 
EMC_LTESRH	EQU    EMC_BASE+$59 ; EMC Transfer error status register high part 
EMC_LTESRL	EQU    EMC_BASE+$58 ; EMC Transfer error status register low part 
	
; Reserved from EMC_BASE+$57 to EMC_BASE+$54
	
EMC_LSRTH	EQU    EMC_BASE+$53 ; SDRAM refresh timer high part 
EMC_LSRTL	EQU    EMC_BASE+$52 ; SDRAM refresh timer low part 
EMC_LURTH	EQU    EMC_BASE+$51 ; EMC UPM refresh timer high part 
EMC_LURTL	EQU    EMC_BASE+$50 ; EMC UPM refresh timer low part 
; Reserved from EMC_BASE+$4F to EMC_BASE+$4C
	
EMC_LSDMRH	EQU    EMC_BASE+$4B ; EMC SDRAM mode register high part 
EMC_LSDMRL	EQU    EMC_BASE+$4A ; EMC SDRAM mode register low part 
	
; Reserved from EMC_BASE+$49 to EMC_BASE+$46

EMC_MDRH	EQU    EMC_BASE+$45 ; EMC UPM data register high part 
EMC_MDRL	EQU    EMC_BASE+$44 ; EMC UPM data register low part 
EMC_MRTPRH	EQU    EMC_BASE+$43 ; EMC Memory refresh timer prescaler register high part
EMC_MRTPRL	EQU    EMC_BASE+$42 ; EMC Memory refresh timer prescaler register low part 
; Reserved from EMC_BASE+$41 to EMC_BASE+$3E

EMC_MCMRH	EQU    EMC_BASE+$3D ; EMC UPMC mode register high part  
EMC_MCMRL	EQU    EMC_BASE+$3C ; EMC UPMC mode register low part 
EMC_MBMRH	EQU    EMC_BASE+$3B ; EMC UPMB mode register high part 
EMC_MBMRL	EQU    EMC_BASE+$3A ; EMC UPMB mode register low part 
EMC_MAMRH	EQU    EMC_BASE+$39 ; EMC UPMA mode register high part 
EMC_MAMRL	EQU    EMC_BASE+$38 ; EMC UPMA mode register low part 

; Reserved from EMC_BASE+$37 to EMC_BASE+$36
	
EMC_MARH	EQU    EMC_BASE+$35 ; EMC UPM address register high part 
EMC_MARL	EQU    EMC_BASE+$34 ; EMC UPM address register low part 
; Reserved from EMC_BASE+$33 to EMC_BASE+$20

EMC_ORH7	EQU    EMC_BASE+$1F ; EMC Options register 7 high part 
EMC_ORL7	EQU    EMC_BASE+$1E ; EMC Options register 7 low part  
EMC_BRH7	EQU    EMC_BASE+$1D ; EMC Base register 7 high part 
EMC_BRL7	EQU    EMC_BASE+$1C ; EMC Base register 7 low part 
EMC_ORH6	EQU    EMC_BASE+$1B ; EMC Options register 6 high part 
EMC_ORL6	EQU    EMC_BASE+$1A ; EMC Options register 6 low part  
EMC_BRH6	EQU    EMC_BASE+$19 ; EMC Base register 6 high part 
EMC_BRL6	EQU    EMC_BASE+$18 ; EMC Base register 6 low part 
EMC_ORH5	EQU    EMC_BASE+$17 ; EMC Options register 5 high part 
EMC_ORL5	EQU    EMC_BASE+$16 ; EMC Options register 5 low part  
EMC_BRH5	EQU    EMC_BASE+$15 ; EMC Base register 5 high part 
EMC_BRL5	EQU    EMC_BASE+$14 ; EMC Base register 5 low part 
EMC_ORH4	EQU    EMC_BASE+$13 ; EMC Options register 4 high part 
EMC_ORL4	EQU    EMC_BASE+$12 ; EMC Options register 4 low part  
EMC_BRH4	EQU    EMC_BASE+$11 ; EMC Base register 4 high part 
EMC_BRL4	EQU    EMC_BASE+$10 ; EMC Base register 4 low part 
EMC_ORH3	EQU    EMC_BASE+$0F ; EMC Options register 3 high part 
EMC_ORL3	EQU    EMC_BASE+$0E ; EMC Options register 3 low part  
EMC_BRH3	EQU    EMC_BASE+$0D ; EMC Base register 3 high part 
EMC_BRL3	EQU    EMC_BASE+$0C ; EMC Base register 3 low part 
EMC_ORH2	EQU    EMC_BASE+$0B ; EMC Options register 2 high part 
EMC_ORL2	EQU    EMC_BASE+$0A ; EMC Options register 2 low part  
EMC_BRH2	EQU    EMC_BASE+$09 ; EMC Base register 2 high part 
EMC_BRL2	EQU    EMC_BASE+$08 ; EMC Base register 2 low part 
EMC_ORH1	EQU    EMC_BASE+$07 ; EMC Options register 1 high part 
EMC_ORL1	EQU    EMC_BASE+$06 ; EMC Options register 1 low part  
EMC_BRH1	EQU    EMC_BASE+$05 ; EMC Base register 1 high part 
EMC_BRL1	EQU    EMC_BASE+$04 ; EMC Base register 1 low part 
EMC_ORH0	EQU    EMC_BASE+$03 ; EMC Options register 0 high part 
EMC_ORL0	EQU    EMC_BASE+$02 ; EMC Options register 0 low part  
EMC_BRH0	EQU    EMC_BASE+$01 ; EMC Base register 0 high part 
EMC_BRL0	EQU    EMC_BASE+$00 ; EMC Base register 0 low part 


;==========================================================
; Y memory map
;==========================================================


;==========================================================
;
;  Chip Configuration Registers
;
;==========================================================
CHIP_CFG_BASE     EQU   $FFFFE0

CHIP_CFG_ARCR   EQU CHIP_CFG_BASE+$00
CHIP_CFG_PSRC   EQU CHIP_CFG_BASE+$01
CHIP_CFG_ODBC   EQU CHIP_CFG_BASE+$02 
CHIP_CFG_EPSC   EQU CHIP_CFG_BASE+$03
CHIP_CFG_PMC    EQU CHIP_CFG_BASE+$04
CHIP_CFG_LPSC   EQU CHIP_CFG_BASE+$05
CHIP_CFG_EMBC   EQU CHIP_CFG_BASE+$06 
CHIP_CFG_RSVR   EQU CHIP_CFG_BASE+$07  

;==========================================================
;
;  spmb_misc_regs Registers
;
;==========================================================

ERROR       EQU $FFFFC8  ;Y space: ICC error and EMC error status Register
EICCR       EQU $FFFFCA  ;Y space: ESAI Internal Clock Control Register


; =========================================================
; PORT A
; =========================================================
GPIO_PORT_A_BASE     EQU  $FFFFF0
; ========================================================= 

PDRA       EQU GPIO_PORT_A_BASE
PRRA       EQU GPIO_PORT_A_BASE+$1
PCRA       EQU GPIO_PORT_A_BASE+$2
PDRA_1     EQU GPIO_PORT_A_BASE+$4
PRRA_1     EQU GPIO_PORT_A_BASE+$5
PCRA_1     EQU GPIO_PORT_A_BASE+$6

; =========================================================
; PORT G
; =========================================================
GPIO_PORT_G_BASE     EQU  $FFFFF8
; ========================================================= 
PDRG       EQU GPIO_PORT_G_BASE
PRRG       EQU GPIO_PORT_G_BASE+$1
PCRG       EQU GPIO_PORT_G_BASE+$2
PDRG_1     EQU GPIO_PORT_G_BASE+$4
PRRG_1     EQU GPIO_PORT_G_BASE+$5
PCRG_1     EQU GPIO_PORT_G_BASE+$6

IRQAEN    EQU    $20      ;Enable GPIO PORTG5/IRQA function.
IRQBEN    EQU    $40      ;Enable GPIO PORTG6/IRQB function.
IRQCEN    EQU    $80      ;Enable GPIO PORTG7/IRQC function.
IRQDEN    EQU    $100    ;Enable GPIO PORTG8/IRQD function.
IRQEN     EQU    $1e0     ;Enable GPIO PORTG[5:8]/IRQ[A-D] function.

; ======================================================
; ICC
; =======================================================
ICC EQU $FFFFD0
ICPR2 EQU ICC+$00
ICPR1 EQU ICC+$01
ICAR4 EQU ICC+$02
ICCR4 EQU ICC+$03
ICDR4 EQU ICC+$04
ICAR3 EQU ICC+$05
ICCR3 EQU ICC+$06
ICDR3 EQU ICC+$07
ICCR2 EQU ICC+$08
ICDR2 EQU ICC+$09
ICCR1 EQU ICC+$0A
ICDR1 EQU ICC+$0B




;; =============== Watchdog Timer ======+====================
WDT            EQU $FFFFC0
WSR          EQU WDT+$3 ;Y    space: Watchdog Service Register
WCNTR        EQU WDT+$2 ;Y    space: Watchdog Count Register
WMR          EQU WDT+$1 ;Y    space: Watchdog modulus Register
WCR          EQU WDT+$0 ;Y    space: Watchdog control register

; ===========================================================
; PATCH
; ===========================================================
PATCH_BASE_ADDR    EQU $FFFFA0
;============================================================
CPI7        EQU PATCH_BASE_ADDR+$0F ;Y space: Patch Instruction Register 7
CPI6        EQU PATCH_BASE_ADDR+$0E ;Y space: Patch Instruction Register 6
CPI5        EQU PATCH_BASE_ADDR+$0D ;Y space: Patch Instruction Register 5
CPI4        EQU PATCH_BASE_ADDR+$0C ;Y space: Patch Instruction Register 4
CPI3        EQU PATCH_BASE_ADDR+$0B ;Y space: Patch Instruction Register 3
CPI2        EQU PATCH_BASE_ADDR+$0A ;Y space: Patch Instruction Register 2
CPI1        EQU PATCH_BASE_ADDR+$09 ;Y space: Patch Instruction Register 1
CPI0        EQU PATCH_BASE_ADDR+$08 ;Y space: Patch Instruction Register 0

; ===============CORE PATCH Address ================================
CPA7        EQU PATCH_BASE_ADDR+$07 ;Y space: Patch Address Register 7
CPA6        EQU PATCH_BASE_ADDR+$06 ;Y space: Patch Address Register 6
CPA5        EQU PATCH_BASE_ADDR+$05 ;Y space: Patch Address Register 5
CPA4        EQU PATCH_BASE_ADDR+$04 ;Y space: Patch Address Register 4
CPA3        EQU PATCH_BASE_ADDR+$03 ;Y space: Patch Address Register 3
CPA2        EQU PATCH_BASE_ADDR+$02 ;Y space: Patch Address Register 2
CPA1        EQU PATCH_BASE_ADDR+$01 ;Y space: Patch Address Register 1
CPA0        EQU PATCH_BASE_ADDR+$00 ;Y space: Patch Address Register 0

;; =============== Port E & Port E_1 ==================================
ESAI_1        EQU $FFFF80
PCRE        EQU ESAI_1+$1F ;Y space: Port E & Port E_1 Control Register
PRRE        EQU ESAI_1+$1E ;Y space: Port E & Port E_1 Data Direction Register
PDRE        EQU ESAI_1+$1D ;Y space: Port E & Port E_1 Data Register
;;
;; =============== ESAI_1 & ESAI_3 ==================================
RSMB_1       EQU ESAI_1+$1C ;Y space: ESAI_1 & ESAI_3 Receive Slot Mask Register B
RSMA_1       EQU ESAI_1+$1B ;Y space: ESAI_1 & ESAI_3 Receive Slot Mask Register A
TSMB_1       EQU ESAI_1+$1A ;Y space: ESAI_1 & ESAI_3 Transmit Slot Mask Register B
TSMA_1       EQU ESAI_1+$19 ;Y space: ESAI_1 & ESAI_3 Transmit Slot Mask Register A
RCCR_1       EQU ESAI_1+$18 ;Y space: ESAI_1 & ESAI_3 Receive Clock Control Register
RCR_1        EQU ESAI_1+$17 ;Y space: ESAI_1 & ESAI_3 Receive Control Register
TCCR_1       EQU ESAI_1+$16 ;Y space: ESAI_1 & ESAI_3 Transmit Clock Control Register
TRCR_1       EQU ESAI_1+$15 ;Y space: ESAI_1 & ESAI_3 Transmit Control Register
SAICR_1      EQU ESAI_1+$14 ;Y space: ESAI_1 & ESAI_3 Common Control Register
SAISR_1      EQU ESAI_1+$13 ;Y space: ESAI_1 & ESAI_3 Status Register
;;
RX3_1        EQU ESAI_1+$0B ;Y space: ESAI_1 & ESAI_3 Receive Data Register 3
RX2_1        EQU ESAI_1+$0A ;Y space: ESAI_1 & ESAI_3 Receive Data Register 2
RX1_1        EQU ESAI_1+$09 ;Y space: ESAI_1 & ESAI_3 Receive Data Register 1
RX0_1        EQU ESAI_1+$08 ;Y space: ESAI_1 & ESAI_3 Receive Data Register 0
;;
TSR_1        EQU ESAI_1+$06 ;Y space: ESAI_1 & ESAI_3 Time Slot Register
TX5_1        EQU ESAI_1+$05 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 5
TX4_1        EQU ESAI_1+$04 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 4
TX3_1        EQU ESAI_1+$03 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 3
TX2_1        EQU ESAI_1+$02 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 2
TX1_1        EQU ESAI_1+$01 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 1
TX0_1        EQU ESAI_1+$00 ;Y space: ESAI_1 & ESAI_3 Transmit Data Register 0

; =========================================================
; ASRC
; =========================================================
ASRC_BASE_ADDR  EQU  $FFFC00
;
ASRCTR    EQU  ASRC_BASE_ADDR+$00   ;; Y SPACE; ASRC CONTROL REGISTER
ASRIER    EQU  ASRC_BASE_ADDR+$01   ;; Y SPACE; INTERRUPT ENABLE REGISTER
ASRIEM    EQU  ASRC_BASE_ADDR+$02   ;; Y SPACE; INTERRUPT ENABLE MASK REGISTER FOR BOTH CORES
ASRCNCR   EQU  ASRC_BASE_ADDR+$03   ;; Y SPACE; CHANNEL NUMBER CONFIGURATION REGISTER
ASRCFG    EQU  ASRC_BASE_ADDR+$04   ;; Y SPACE; FILTER CONFIGURATION STATUS REGISTER
ASRCSR    EQU  ASRC_BASE_ADDR+$05   ;; Y SPACE; ASRC CLOCK SOURCE REGISTER
ASRCDR1   EQU  ASRC_BASE_ADDR+$06   ;; Y SPACE; ASRC CLOCK DIVIDER REGISTER 1
ASRCDR2   EQU  ASRC_BASE_ADDR+$07   ;; Y SPACE; ASRC CLOCK DIVIDER REGISTER 2
ASRSTR    EQU  ASRC_BASE_ADDR+$08   ;; Y SPACE; ASRC STATUS REGISTER
ASRRA     EQU  ASRC_BASE_ADDR+$09   ;; Y SPACE; RATIO PAIR A REGISTER
ASRRB     EQU  ASRC_BASE_ADDR+$0A   ;; Y SPACE; RATIO PAIR B REGISTER
ASRRC     EQU  ASRC_BASE_ADDR+$0B   ;; Y SPACE; RATIO PAIR C REGISTER
ASRMAA    EQU  ASRC_BASE_ADDR+$0C   ;; Y SPACE; ASRC MEMORY ACCESS ADDRESS REGISTER
ASRMAD    EQU  ASRC_BASE_ADDR+$0D   ;; Y SPACE; ASRC MEMORY ACCESS DATA REGISTER
ASRDCR    EQU  ASRC_BASE_ADDR+$0E   ;; Y SPACE; ASRC DEBUG CONTROL REGISTER
ASRDCR1   EQU  ASRC_BASE_ADDR+$0F   ;; Y SPACE; ASRC DEBUG CONTROL REGISTER 1

ASRPM1    EQU  ASRC_BASE_ADDR+$10   ;; Y SPACE; PARAMETER REGISTER 1
ASRPM2    EQU  ASRC_BASE_ADDR+$11   ;; Y SPACE; PARAMETER REGISTER 2
ASRPM3    EQU  ASRC_BASE_ADDR+$12   ;; Y SPACE; PARAMETER REGISTER 3
ASRPM4    EQU  ASRC_BASE_ADDR+$13   ;; Y SPACE; PARAMETER REGISTER 4
ASRPM5    EQU  ASRC_BASE_ADDR+$14   ;; Y SPACE; PARAMETER REGISTER 5
ASRQFIFO1 EQU  ASRC_BASE_ADDR+$15   ;; Y SPACE; ASRC TASKQUE FIFO REGISTER 1
ASRQFIFO2 EQU  ASRC_BASE_ADDR+$16   ;; Y SPACE; ASRC TASKQUE FIFO REGISTER 2
ASRCCR    EQU  ASRC_BASE_ADDR+$17   ;; Y SPACE; CHANNEL COUNTER REGISTER

ASRDIA    EQU  ASRC_BASE_ADDR+$18   ;; Y SPACE; ASRC DATA INPUT REGISTER FOR PAIR A
ASRDOA    EQU  ASRC_BASE_ADDR+$19   ;; Y SPACE; ASRC DATA OUTPUT REGISTER FOR PAIR A
ASRDIB    EQU  ASRC_BASE_ADDR+$1A   ;; Y SPACE; ASRC DATA INPUT REGISTER FOR PAIR B
ASRDOB    EQU  ASRC_BASE_ADDR+$1B   ;; Y SPACE; ASRC DATA OUTPUT REGISTER FOR PAIR B
ASRDIC    EQU  ASRC_BASE_ADDR+$1C   ;; Y SPACE; ASRC DATA INPUT REGISTER FOR PAIR C
ASRDOC    EQU  ASRC_BASE_ADDR+$1D   ;; Y SPACE; ASRC DATA OUTPUT REGISTER FOR PAIR C;




; =========================================================
; PGCR and STIDR 
; =========================================================

ESCCR EQU $FFFFCA ;; Y Space: ESAI Clock control Register
PGCR  EQU $FFFFC9  ;; Y Space: Dedicated Peripherals Gated Clock Control Register
STIDR EQU $FFFFC8 ;; Y Space: Software Triggered Interrupt Data Register



;       control and status bits in OMR

CDP    EQU     $300            ; mask for CORE_DMA priority bits in OMR
MA     EQU     0               ; Operating Mode A
MB     EQU     1               ; Operating Mode B
MC     EQU     2               ; Operating Mode C
MD     EQU     3               ; Operating Mode D
EBD    EQU     4               ; External Bus Disable bit in OMR
SD     EQU     6               ; Stop Delay
MS     EQU     7               ; Master Memory Switch Mode
CDP0   EQU     8               ; bit 0 of priority bits in OMR
CDP1   EQU     9               ; bit 1 of priority bits in OMR
BEN    EQU     10              ; Burst Enable
TAS    EQU     11              ; TA Synchronize Select
BRT    EQU     12              ; Bus Release Timing
XYS    EQU     16              ; Stack Extension space select bit in OMR.
EUN    EQU     17              ; Extensed stack UNderflow flag in OMR.
EOV    EQU     18              ; Extended stack OVerflow flag in OMR.
WRP    EQU     19              ; Extended WRaP flag in OMR.
SEN    EQU     20              ; Stack Extension Enable bit in OMR.
MSW0   EQU     21              ; Memory Switch Mode 0          
MSW1   EQU     22              ; Memory Switch Mode 1

;       control and status bits in SR
IPL1   EQU      9               ;Enable 2nd prioroty bit.
IPL0   EQU      8               ;Enable 1st priority bit.
SA     EQU     17              ; Sixteen_Bit Arithmetic Mode Bit in SR.
CE     EQU     19              ; Instruction Cache Enable Bit in SR.
CP0    EQU     22              ; Core Priority Bit 0 in SR
CP1    EQU     23              ; Core Priority Bit 1 in SR 
  
;       Timer Control/Status Register Bit Flags

TE     EQU     0               ; Timer Enable
TOIE   EQU     1               ; Timer Overflow Interrupt Enable
TCIE   EQU     2               ; Timer Compare Interrupt Enable
TC     EQU     $F0             ; Timer Control Mask (TC0_TC3)
INV    EQU     8               ; Inverter Bit
TRM    EQU     9               ; Timer Restart Mode
DIR    EQU     11              ; Direction Bit
DI     EQU     12              ; Data Input
DO     EQU     13              ; Data Output
PCE    EQU     15              ; Prescaled Clock Enable
XTLD   EQU     16              ; XTAL Disable Bit
TOF    EQU     20              ; Timer Overflow Flag
TCF    EQU     21              ; Timer Compare Flag
DE     EQU    23              ; DMA Channel Enable bit 
;       Timer Prescaler Register Bit Flags

PS    EQU  $600000     ; Prescaler Source Mask
PS0   EQU  21
PS1   EQU  22

;   Timer Control Bits
TC0    EQU     4               ; Timer Control 0
TC1    EQU     5               ; Timer Control 1
TC2    EQU     6               ; Timer Control 2
TC3    EQU     7               ; Timer Control 3

T0L    EQU     $300            ; TIMER Interrupt Priority Level Mask
T0L0   EQU     8               ; TIMER Interrupt Priority Level (low)
T0L1   EQU     9               ; TIMER Interrupt Priority Level (high)

;------------------------------------------------------------------------
; Non_Maskable interrupts
;------------------------------------------------------------------------
I_RESET  EQU  I_VEC+$00   ; Hardware RESET
I_STACK  EQU  I_VEC+$02   ; Stack Error
I_ILL    EQU  I_VEC+$04   ; Illegal Instruction
I_DBG    EQU  I_VEC+$06   ; Debug Request      
I_TRAP   EQU  I_VEC+$08   ; Trap
I_NMI    EQU  I_VEC+$0A   ; Non Maskable Interrupt


I_OBUS_ERRROR   EQU  I_VEC+$0C   ; Obus transfer Error 
I_DMA_SI        EQU  I_VEC+$0E   ; DMA stall interrupt 

;------------------------------------------------------------------------
; Interrupt Request Pins
;------------------------------------------------------------------------
I_IRQA   EQU  I_VEC+$10   ; IRQA
I_IRQB   EQU  I_VEC+$12   ; IRQB
I_IRQC   EQU  I_VEC+$14   ; IRQC
I_IRQD   EQU  I_VEC+$16   ; IRQD

;------------------------------------------------------------------------
; DMA Interrupts
;------------------------------------------------------------------------
I_DMA0   EQU  I_VEC+$18   ; DMA Channel 0
I_DMA1   EQU  I_VEC+$1A   ; DMA Channel 1
I_DMA2   EQU  I_VEC+$1C   ; DMA Channel 2
I_DMA3   EQU  I_VEC+$1E   ; DMA Channel 3
I_DMA4   EQU  I_VEC+$20   ; DMA Channel 4
I_DMA5   EQU  I_VEC+$22   ; DMA Channel 5
I_DMA6   EQU  I_VEC+$24   ; DMA Channel 6
I_DMA7   EQU  I_VEC+$26   ; DMA Channel 7

;-----------------------------------------------------------------------
; ICC Interrupts
;-----------------------------------------------------------------------
I_ICCNM    EQU  I_VEC+$28   ; Inter-Core Non-Maskable Interrupt
I_ICCINT EQU I_VEC+$2A   ; Inter-Core Maskable Interrupt
I_ICCACK EQU I_VEC+$2C   ; Inter-Core Maskable acknowledge interrupt
I_ICCERR EQU I_VEC+$FE   ; Inter-Core Error Interrupt

I_SW     EQU I_VEC+$FC  ; software trigger interrupt

;------------------------------------------------------------------------
; ESAI/ESAI_2
;------------------------------------------------------------------------
I_ESAI02_RD     EQU   I_VEC+$30  ;ESAI/ESAI_2 Receive Data
I_ESAI02_RED    EQU   I_VEC+$32  ;ESAI/ESAI_2 Receive Even Data
I_ESAI02_RDE    EQU   I_VEC+$34  ;ESAI/ESAI_2 Receive Data With Execption
I_ESAI02_RLS    EQU   I_VEC+$36  ;ESAI/ESAI_2 Receive Last Slot 
I_ESAI02_TD     EQU   I_VEC+$38  ;ESAI/ESAI_2 Transmit Data
I_ESAI02_TED    EQU   I_VEC+$3a  ;ESAI/ESAI_2 Transmit Even Data
I_ESAI02_TDE    EQU   I_VEC+$3c  ;ESAI/ESAI_2 Transmit Data With Execption
I_ESAI02_TLS    EQU   I_VEC+$3e  ;ESAI/ESAI_2 Transmit Last Slot


;------------------------------------------------------------------------
; SHI/SHI_1
;------------------------------------------------------------------------
;I_SHI_T        EQU   I_VEC+$40    ;SHI/SHI_1 Transmit
;I_SHI_TUE      EQU   I_VEC+$42    ;SHI/SHI_1 Transmit Underrun Error
;I_SHI_RFNE     EQU   I_VEC+$44    ;SHI/SHI_1 Receive FIFO Not Empty
;I_SHI_RFF      EQU   I_VEC+$48    ;SHI/SHI_1 Receive FIFO full
;I_SHI_ROE      EQU   I_VEC+$4a    ;SHI/SHI_1 Receive Overrun Error
;I_SHI_BE       EQU   I_VEC+$4c    ;SHI/SHI_1 Bus Error

;------------------------------------------------------------------------
; Timer Interrupts
;------------------------------------------------------------------------
I_TIM0C  EQU  I_VEC+$54   ; TIMER 0 compare
I_TIM0OF EQU  I_VEC+$56   ; TIMER 0 overflow
I_TIM1C  EQU  I_VEC+$58   ; TIMER 1 compare
I_TIM1OF EQU  I_VEC+$5A   ; TIMER 1 overflow
I_TIM2C  EQU  I_VEC+$5C   ; TIMER 2 compare
I_TIM2OF EQU  I_VEC+$5E   ; TIMER 2 overflow

;------------------------------------------------------------------------
; HDI24/HDI24_1
;------------------------------------------------------------------------
I_HDI_HRDF     EQU    I_VEC+$60    ;HDI24/HDI24_1 HOST Receive Data Full
I_HDI_HTDE     EQU    I_VEC+$62    ;HDI24/HDI24_1 HOST Transmitter Datat Empty
I_HDI_HC       EQU    I_VEC+$64    ;HDI24/HDI24_1 HOST Command


;------------------------------------------------------------------------
; ESAI_1/3
;------------------------------------------------------------------------
I_ESAI13_RD     EQU   I_VEC+$70  ;ESAI/ESAI_2 Receive Data
I_ESAI13_RED    EQU   I_VEC+$72  ;ESAI/ESAI_2 Receive Even Data
I_ESAI13_RDE    EQU   I_VEC+$74  ;ESAI/ESAI_2 Receive Data With Execption
I_ESAI13_RLS    EQU   I_VEC+$76  ;ESAI/ESAI_2 Receive Last Slot
I_ESAI13_TD     EQU   I_VEC+$78  ;ESAI/ESAI_2 Transmit Data
I_ESAI13_TED    EQU   I_VEC+$7a  ;ESAI/ESAI_2 Transmit Even Data
I_ESAI13_TDE    EQU   I_VEC+$7c  ;ESAI/ESAI_2 Transmit Data With Execption
I_ESAI13_TLS    EQU   I_VEC+$7e  ;ESAI/ESAI_2 Transmit Last Slot


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SPDIF Interrupts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

I_VEC_SPDIF    EQU   I_VEC+$A0  ;;SPDIF  Basic interrupt address
;; Transmit
I_STUNOV  EQU   I_VEC_SPDIF+$0	;; SPDIF Transmit FIFO Underrun/Overrun
I_STRESYN EQU   I_VEC_SPDIF+$2	;; SPDIF Transmit FIFO Resync
I_STUE    EQU   I_VEC_SPDIF+$4       ;; SPDIF Transmit U Channel Empty
I_STUU    EQU   I_VEC_SPDIF+$6       ;; SPDIF Transmit U Channel Underrun
I_STUNB   EQU   I_VEC_SPDIF+$8       ;; SPDIF Transmit U Channel Next Byte
I_STXE    EQU   I_VEC_SPDIF+$A       ;; SPDIF Transmit FIFO empty

;; Receive
I_SRCN	  EQU   I_VEC+$80	;; SPDIF Receiver change in C channel value
I_SRVNG	  EQU   I_VEC+$82       ;; SPDIF Receiver validity bit no good
I_SRIS    EQU   I_VEC+$84       ;; SPDIF Receiver found illegal symbol
I_SRPBE   EQU   I_VEC+$86       ;; SPDIF Receiver parity bit error
I_SRURF   EQU   I_VEC+$88       ;; SPDIF Receiver U channel receive full
I_SRURO	  EQU   I_VEC+$8A       ;; SPDIF Receiver U channel reg overrun
I_SRQRF   EQU   I_VEC+$8C       ;; SPDIF Receiver Q channel receive full
I_SRQRO	  EQU   I_VEC+$8E       ;; SPDIF Receiver Q channel reg overrun
I_SRUS    EQU   I_VEC+$90       ;; SPDIF Receiver U/Q sync found
I_SRUCE   EQU   I_VEC+$92       ;; SPDIF Receiver U/Q channel framing error
I_SRIO    EQU   I_VEC+$94       ;; SPDIF Receiver input fifo overrun/underrun
I_SRIR    EQU   I_VEC+$96	;; SPDIF Receiver input fifo resync
I_SRLL	  EQU   I_VEC+$98	;; SPDIF Receiver loss of lock
I_SRIF	  EQU   I_VEC+$9A       ;; SPDIF Receiver input fifo full
I_SRGL	  EQU	I_VEC+$9C	;; SPDIF Receiver gain of lock

; =========================================================
; ASRC INTERRUPTS
; =========================================================
I_VEC_ASRC       EQU    I_VEC+$B0

I_ASRC_ADIEA     EQU    I_VEC_ASRC+$0
I_ASRC_ADIEB     EQU    I_VEC_ASRC+$2
I_ASRC_ADIEC     EQU    I_VEC_ASRC+$4
I_ASRC_ADOEA     EQU    I_VEC_ASRC+$6
I_ASRC_ADOEB     EQU    I_VEC_ASRC+$8
I_ASRC_ADOEC     EQU    I_VEC_ASRC+$A
I_ASRC_AOLIE     EQU    I_VEC_ASRC+$C
I_ASRC_AFPWE     EQU    I_VEC_ASRC+$E

; ===============================================================

;------------------------------------------------------------------------
; INTERRUPT ENDING ADDRESS
;------------------------------------------------------------------------
I_INTEND EQU  I_VEC+$FF   ; last address of interrupt vector space

	 endif
	list
