;; FIBULA application epilogue
;; IRQ-HRX spi commands:
;; RT I/O
;; 0 = NOP  1,a = read   2,a,d = write   4,a,n = read multiple (DMA)
;; 5,a = read-and-clear 
;; +8 or +16 (bits 3-4) = +0:Xfield +8:Yfield +16:Pfield
;; 32 (bit 5) = Read-clear DSPSTATUS
;; DEBUG
;; 64 (bit 6) Sample running pgm status
;; 65 = restore-GO
;; 66 = do step
;; 68 = Stop
;; 72 = get DEBUG status
;; PROMPROG
;; 128
;;	nolist

	dmar	spi
	var	trap_savx0
	var	trap_savr0
	var	trap_savm0
	var	spi_savx0
	var	spi_savr0
	var	spi_savm0
	var	spi_curcd
	var	spi_curad
	var	trapped_instr,0
	var	hcsrdata,0
	var	hrxd,0

	section	irq
	global	irqhrx,irqhrxeovrn,irqhrxefifo,irqhbuserr,blinkerr

	org	p:
irqhrxeovrn
	movep	x:HCSR0,x:hcsrdata
	movep	x:HRX0,x:hrxd
	rti
irqhrxefifo
	movep	x:HCSR0,x:hcsrdata
	movep	x:HRX0,x:hrxd
	rti
irqhbuserr
	rti

irqhrx
	move		r0,x:spi_savr0
	move		m0,x:spi_savm0
	move		x0,x:spi_savx0


	movep	x:HRX0,r0
	jcf		spi_waiad,irqhrx3
	jcf		spi_waidat,irqhrx5
	jcf		spi_wainb,irqhrx7
	brset	#7,r0,irqhrxend
; 	brset	#6,r0,dbug
	brset	#5,r0,irqhrxstat	
	brclr	#0,r0,irqhrx0
	flagset	spi_waiad
	bclr		#2,r0
	bcc		<irqhrx2
	flagset	spi_postclr
	bra		<irqhrx2

irqhrxstat
;	movep		y:dspstatus,x:HTX0
	move		#0,r0
	flagtog		statrd
	bcs		irqhrxstat1
	move		#$800000,r0	; Bit 23 clignotant indique comm ok
irqhrxstat1
	move		r0,y:dspstatus
	flagset		statusread
	bra		<irqhrxend
	
irqhrx0
	brclr		#1,r0,irqhrx1
	flagset	spi_waidat
	flagset	spi_waiad
	bra		<irqhrx2
irqhrx1	
	brclr		#2,r0,irqhrxend
	flagset	spi_wainb
	flagset	spi_waiad
irqhrx2
	flagclr	spi_yf
	flagclr	spi_pf
	brclr	#4,r0,irqhrx2a
	flagset	spi_pf
	bra		<irqhrxend
irqhrx2a
	brclr		#3,r0,irqhrxend
	flagset	spi_yf

irqhrxend
	move		x:spi_savr0,r0
	move		x:spi_savm0,m0
	move		x:spi_savx0,x0
	rti


irqhrx3
	str0		spi_curad
	jf		spi_wainb,irqhrxend
	jnf		spi_pf,irqhrx3a
	movep	p:(r0),x:HTX0 ; NB pas de postclr dans P:
	bra		<irqhrxend
irqhrx3a	
	jf		spi_yf,irqhrx4
	movep	x:(r0),x:HTX0
	jcnf		spi_postclr,irqhrxend
	move		vba,x:(r0)		; VBA vaut toujours 0 dans Fibula
	bra		<irqhrxend
irqhrx4
	movep	y:(r0),x:HTX0
	jcnf		spi_postclr,irqhrxend
	move		vba,y:(r0)
	bra		<irqhrxend

irqhrx5
	move		r0,x0
	ldr0		spi_curad
	jnf		spi_pf,irqhrx5a
	movem	x0,p:(r0)
	bra		irqhrxend
irqhrx5a
	jf		spi_yf,irqhrx6
	move		x0,x:(r0)
	bra		irqhrxend
irqhrx6
	move		x0,y:(r0)
	bra		irqhrxend
irqhrx7
	movep	x:spi_curad,x:dsr_spi
	movep	#HTX0,x:ddr_spi
	movep	r0,x:dco_spi
	jnf		spi_pf,irqhrx7a
	movep	#$8E7252,x:dcr_spi
	bra		irqhrxend
irqhrx7a
	jf		spi_yf,irqhrx8
	movep	#$8E7250,x:dcr_spi
	bra		irqhrxend
irqhrx8		
	movep	#$8E7251,x:dcr_spi
	bra		irqhrxend


blinkerr
 if !@def(led_orm)
led_orm	set	$000040
led_andm	set	$FFFFBF
 endif 
	movep	#0,x:pcrc	; set	val_pcrc0&led_andm
	movep	#led_orm,x:prrc	; set	val_prrc0|led_orm

blinkerr0 
	ledoff	led
	move		#5,r1
blinkerr1
	move		#$FFFFFF,r0
	rep		r0
	nop
	move		(r1)-
	btst		#23,r1
	bcc		blinkerr1
	ledon	led
	move		#$100000,r0
	rep		r0
	nop
	bra		blinkerr0
	endsec


	section	vectors global
	org	p:2
	jsr	blinkerr		; Stack Err
	org	p:4
	jsr	blinkerr		; Illegal
	org	p:6
	jsr	blinkerr		; Debug Req
	org	p:8
	jsr	blinkerr		; TRAP instr

	org	p:$40
	nop			; jsr	irqhtx
	nop
	org	p:$42
	nop
	nop			; jsr	irqhtxe

	org	p:$44
	jsr	irqhrx

	org	p:$48
	jsr	irqhrxefifo

	org	p:$4A
	jsr	irqhrxeovrn

	org	p:$4C
	jsr	irqhbuserr

	endsec

; End of all sections: gives the sections sizes

	section flags		global
	org	y:
endflags
	endsec

	section	vars	global
	org	x:
end_var
	endsec

	section	data	global
	org	y:
end_data
	endsec


	section long	global
	org	l:
end_dbl
	endsec	

	section	irq
	org	p:
endirq
	endsec

	if	@def(curman)	; number of manual entries
nbman	set	curman
	endif


	section	inits
	global	endini
	org	p:
 if core==0
	movep	#val_pcrc0,x:PCRC
	movep	#val_prrc0,x:PRRC
	movep	#val_pdrc0,x:PDRC		

	movep	#val_pcre0,y:PCRE
	movep	#val_prre0,y:PRRE
	movep	#val_pdre0,y:PDRE
	movep	#val_pcrh,x:PCRH
	movep	#val_prrh,x:PRRH
	movep	#val_pdrh,x:PDRH

	movep	#val_pcrg,y:PCRG
	movep	#val_prrg,y:PRRG
	movep	#val_pdrg,y:PDRG

	movep	#val_pcrg1,y:PCRG_1
	movep	#val_prrg1,y:PRRG_1
	movep	#val_pdrg1,y:PDRG_1

	movep	#val_iprc0,x:IPRC
	movep	#val_iprc01,x:IPRC1
	movep	#val_iprp0,x:IPRP
	movep	#val_iprp01,x:IPRP1

	movec	#val_sr0,sr
 	endif
 
 if core==1
	movep	#val_pcrc1,x:PCRC
	movep	#val_prrc1,x:PRRC
	movep	#val_pdrc1,x:PDRC

	movep	#val_pcre1,y:PCRE
	movep	#val_prre1,y:PRRE
	movep	#val_pdre1,y:PDRE


	movep	#val_pcrg,y:PCRG	; double init ncessaire (shared port) 
	movep	#val_prrg,y:PRRG
	movep	#val_pdrg,y:PDRG

	movep	#val_pcrg1,y:PCRG_1
	movep	#val_prrg1,y:PRRG_1
	movep	#val_pdrg1,y:PDRG_1

	movep	#val_pcrh,x:PCRH
	movep	#val_prrh,x:PRRH
	movep	#val_pdrh,x:PDRH


	movep	#val_iprc1,x:IPRC
	movep	#val_iprc11,x:IPRC1
	movep	#val_iprp1,x:IPRP
	movep	#val_iprp11,x:IPRP1

	movec	#val_sr1,sr
 	endif

	nop
	nop
	nop	
	rts
endini	
	endsec

	section	routines
	org	p:
endrtn
	endsec


;	section	exec
	org	p:
	jmp	$0	; If programmer forgot to loop, then go to Debugger
endexec
	endsec

	section debug	global
	org	p:
enddbg
	endsec



;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 30/09/2013

