;; ESAI Core 0 in synchronous slave mode  
;; syntax: tx= enable Tx / rx = enable Rx / gpi= GPIO IN / gpo=GPIO OUT 
;;   

slave_i2s_esai	macro fs,r0t5,r1t4,r2t3,r3t2
actual_fs	set	fs
core0_fs		set	fs
;; TCCR
;; THCKD TFSD TCKD THCKP . TFSP TCKP TFP3 2 . 1 0 TDC4 3 . 2  1  0 TPSR . TPM7 6 5 4 . 3 2 1 0 . 
;;   0    0     0    0   .  1    1     0  0 . 0 0    0 0   0  0  1  0            0         0
;v_tccr	set		$800200         
v_tccr	set		$0C0200         
;; TCR 
;; tlie tie tedie teie . tpr _ padc tfsr . tfsl tsws4 3  2 . 1 0 tmod1 0 . twa tshd te5 te4 . te3 te2 te1 te0 
;;   1   1    0     1  .  R  0   1   1   .  0     1   1  1 . 1 1   0   1 .  0    0   x   x  .  x   x   x   x
v_tcr	set		$D37D00

;; RCCR
;; RHCKD RFSD RCKD RHCKP . RFSP RCKP RFP3 2 . 1 0 RDC4 3 . 2  1  0 RPSR . RPM7 6 5 4 . 3 2 1 0 . 
;;   0    0     0    0   .  1    1     0  0 . 0 0    0 0 . 0  0  1  0   .         0  .      0
v_rccr	set		$0C0200         

;; RCR 
;; rlie rie redie reie . rpr _  _   rfsr . rfsl rsws4 3  2 . 1 0 rmod1 0 . rwa rshd  _   _  . re3 re2 re1 re0 
;;   1   1    0     1  .  R  0  0    1   .  0     1   1  1 . 1 0   0   1 .  0    0   0   0  .  x   x   x   x
v_rcr	set		$D17D00

v_saicr	set		$000040	; SYN mode 


;; PORT C Correspondance   
;; 11    10    9     8     7     6     5     4     3     2     1     0 
;; T0    T1   T2R3  T3R2  T4R1  T5R0  HCKT  FST   SCKT  HCKR  FSR   SCKR
	var	nil,0

val_prrc0	set	val_prrc0|$000018	; SCKT et FST actifs
val_pcrc0	set	val_pcrc0|$000018
; val_pdrc0	set	val_pdrc0|$000100 ; Provoque MUTE !

 if "r3t2"=='SDO2'
v_tcr	set	v_tcr|4
val_prrc0	set	val_prrc0|$200
val_pcrc0	set	val_pcrc0|$200
 else
  if "r3t2"=='SDI3'
v_rcr	set	v_rcr|8
val_prrc0	set	val_prrc0|$200
val_pcrc0	set	val_pcrc0|$200
  else 
   if "r3t2"=='PC9out'
val_prrc0	set	val_prrc0|$200
   else
    if "r3t2"=='PC9in'
val_pcrc0	set	val_pcrc0|$200
    endif 
   endif
  endif  
 endif

 if "r2t3"=='SDO3'
v_tcr	set	v_tcr|8
val_prrc0	set	val_prrc0|$100
val_pcrc0	set	val_pcrc0|$100
 else
  if "r2t3"=='SDI2'
v_rcr	set	v_rcr|4
val_prrc0	set	val_prrc0|$100
val_pcrc0	set	val_pcrc0|$100
  else 
   if "r2t3"=='PC8out'
val_prrc0	set	val_prrc0|$100
   else
   	if "r2t3"=='PC8in'
val_pcrc0	set	val_pcrc0|$100
    endif 
   endif
  endif  
 endif

 if "r1t4"=='SDO4'
v_tcr	set	v_tcr|$10
val_prrc0	set	val_prrc0|$80
val_pcrc0	set	val_pcrc0|$80
 else
  if "r1t4"=='SDI1'
v_rcr	set	v_rcr|2
val_prrc0	set	val_prrc0|$80
val_pcrc0	set	val_pcrc0|$80
  else 
   if "r1t4"=='PC7out'
val_prrc0	set	val_prrc0|$80
   else
   	if "r1t4"=='PC7in'
val_pcrc0	set	val_pcrc0|$80
    endif 
   endif
  endif  
 endif

 if "r0t5"=='SDO5'
v_tcr	set	v_tcr|$20
val_prrc0	set	val_prrc0|$40
val_pcrc0	set	val_pcrc0|$40
 else
  if "r0t5"=='SDI0'
v_rcr	set	v_rcr|1
val_prrc0	set	val_prrc0|$40
val_pcrc0	set	val_pcrc0|$40
  else 
   if "r0t5"=='PC6out'
val_prrc0	set	val_prrc0|$40
   else
    if "r0t5"=='PC6in'
val_pcrc0	set	val_pcrc0|$40
    endif 
   endif
  endif  
 endif


	section	inits
	movep	#$080000,x:TCR 	; Reset
	movep	#$080000,x:RCR 
	
	movep	#v_tccr,x:TCCR
	movep	#v_tcr,x:TCR 
	movep	#v_rccr,x:RCCR 
	movep	#v_rcr,x:RCR 
	movep	#v_saicr,x:SAICR

 if	"r0t5"=='SDO5'
	movep	#0,x:TX5  
 endif
 if	"r1t4"=='SDO4'
	movep	#0,x:TX4 
 endif
 if	"r2t3"=='SDO3'
	movep	#0,x:TX3 
 endif
 if	"r3t2"=='SDO2'
	movep	#0,x:TX2 
 endif

;	movep	#$000100,x:PDRC 	; special: GPIO pour MUTE\

val_iprp0	set	val_iprp0|$000003 ; ESAI has priority 3 
val_sr0	set	val_sr0&$FFFCFF	; irq_mask =0 
	endsec

	section routines
	global	esai_rxd,esai_rxerr,esai_rxlast,esai_txd,esai_txerr,esai_txlast
esai_rxd
	flagtog		right_frame
	bcs			<esai_rxd1
 if	"r0t5"=='SDI0'
	movep	x:RX0,x:in00_l 
 endif
 if	"r1t4"=='SDI1'
	movep	x:RX1,x:in01_l  
 endif
 if	"r2t3"=='SDI2'
	movep	x:RX2,x:in02_l  
 endif
 if	"r3t2"=='SDI3'
	movep	x:RX3,x:in03_l  
 endif
	rti
esai_rxd1
 if	"r0t5"=='SDI0'
	movep	x:RX0,x:in00_r
 endif
 if	"r1t4"=='SDI1'
	movep	x:RX1,x:in01_r 
 endif
 if	"r2t3"=='SDI2'
	movep	x:RX2,x:in02_r 
 endif
 if	"r3t2"=='SDI3'
	movep	x:RX3,x:in03_r 
 endif
	rti

esai_txd
	flagtst 		right_frame
	bcc			<esai_txd1
 if	"r0t5"=='SDO5'
	movep	x:out05_l,x:TX5  
 endif
 if	"r1t4"=='SDO4'
	movep	x:out04_l,x:TX4 
 endif
 if	"r2t3"=='SDO3'
	movep	x:out03_l,x:TX3 
 endif
 if	"r3t2"=='SDO2'
	movep	x:out02_l,x:TX2 
 endif
	rti
esai_txd1
 if	"r0t5"=='SDO5'
	movep	x:out05_r,x:TX5  
 endif
 if	"r1t4"=='SDO4'
	movep	x:out04_r,x:TX4 
 endif
 if	"r2t3"=='SDO3'
	movep	x:out03_r,x:TX3 
 endif
 if	"r3t2"=='SDO2'
	movep	x:out02_r,x:TX2 
 endif
	rti

esai_rxlast
 	flagset	esai_sample
	rti

esai_txlast
	flagclr	right_frame
	rti 

esai_rxerr
	movep	x:SAISR,x:nil
	movep	x:RX0,x:nil
	movep	x:RX1,x:nil
	movep	x:RX2,x:nil
	movep	x:RX3,x:nil
	rti
esai_txerr
	movep	x:SAISR,x:nil
	movep	x:nil,x:TX5 
	movep	x:nil,x:TX4 
	movep	x:nil,x:TX3 
	movep	x:nil,x:TX2 
	rti

	endsec

;; Main loop code
	waicf 	esai_sample		; wait for ESAI data 
	nop					; // test du clignotant
	nop
;	illegal
	nop
	nop

;;	waicf	esai_sample
	

	section	vectors
	org		p:$30	; Rx data
	jsr		esai_rxd

	org		p:$32	; Rx Even
	nop
	nop

	org		p:$34	; Rx Err
	jsr		esai_rxerr

	org		p:$36	; Rx Last
	jsr		esai_rxlast

	org		p:$38	; Tx data
	jsr		esai_txd

	org		p:$3A	; Tx Even
	nop
	nop


	org		p:$3C	; Tx Err
	jsr		esai_txerr

	org		p:$3E	; Tx last
	jsr		esai_txlast

	endsec



	endm


 
 