;; Sample fast AD & DA on DIDALAB ETD410 000
;; Syntax:   ADA Frequency
;; where Frequency is expressed in Hz


ada	macro	fs
hffreq	set	163.84E6  ; freq pll FPGA
fpga_base	set	$040000
ada1	set	fpga_base
ada2	set	fpga_base+1
adast	set	fpga_base+2	; ctrl_status
 if core==1
adafh	set	fpga_base+5	; Freq du synth
adafl	set	fpga_base+6
 else
adafh	set	fpga_base+3	; Freq du synth
adafl	set	fpga_base+4
 endif
hrcntr 	set	fpga_base+5

ada_fract	set	@lfr(2*fs/hffreq) ; fext)

ada_fh	set	ada_fract>>24
ada_fl	set	ada_fract&$000000FFFFFF

ada_fs	set	fs
 if core==0
core0_fs	set	fs
 else
core1_fs	set	fs
 endif
actual_fs	set	fs		

pcrc0	set	$FFFFBF
prrc0	set	$FFFFBE
pdrc0	set	$FFFFBD

	var	ada_savx0

 if !@def(ada_init)
	section	inits
	global	ada_init
	org	p:
ada_init
	clr	a
	move	a1,x:EMC_BRL0
;	move	#$006000,a
;	move	a1,x:EMC_ORL0

	movep	#0,y:PDRA
	movep	#0,y:PDRA_1		; cf chip errata
	movep	#$FFFFFF,y:PCRA
	movep	#$FFFFFF,y:PRRA
	movep	#$000007,y:PCRA_1
	movep	#$000007,y:PRRA_1


	move	#$001801,a1		; $1E01
	move	a1,x:EMC_BRL2		; V=1 zone X, R/w, Valid
	move	#$000010,a1
	move	a1,x:EMC_BRH2   		; adresse de base $40000
	move	#$006010,a1		;#006000 #$000F07,a CSNT=1   
	move	a1,x:EMC_ORL2
	move	#$0003FF,a1			;#$0003FF,a
	move	a1,x:EMC_ORH2     		; masque adesse A23:A14

	move	#$000040,a1		; LCTL LBOE
	move	a1,x:EMC_LBCRH	
	move	#$000500,a1
	move	a1,x:EMC_LBCRL
	move	#$000004,a1		; clkdiv=4
	move	a1,x:EMC_LCRRL
	move	#$000001,a			; $008000,a
	move	a1,x:EMC_LCRRH

	move	#>ada_fh,a1
	move	a1,x:adafh
	move	#>ada_fl,a1
	move	a1,x:adafl

 if core==0
	move	#$000001,a1
	move	a1,x:adast
val_iprc0	set	val_iprc0|$000007 ; IRQA
val_sr0	set	val_sr0&$fffcff
 else

	move	#$000002,a1
	move	a1,x:adast

val_iprc1	set	val_iprc1|$000E00 ; IRQD
val_sr1	set	val_sr1&$fffcff
 endif
	endsec
 endif

	nolist
	nolist
	msg	'>>> ADA Fs=',@cvi(fs),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(fdsp/fs)
	list
	list



	org		p:
waiada	waicf		ada




 if !@def(irq_ada)
	section	vectors	global
 if core==0
	org	p:$10
	jsr	irq_ada	; IRQA
 else
	org	p:$16
	jsr	irq_ada	; IRQD
 endif
	endsec

	section	irq
	global irq_ada

	org	p:
irq_ada
	stx0	ada_savx0
  if @def(ad1)
	move		x:ada1,x0
	stx0		ad1
  endif
  if @def(ad2)
	move		x:ada2,x0
	stx0		ad2
  endif
  if @def(ad_re)
	move		x:ada1,x0
	stx0		ad_re
  endif
  if @def(ad_im)
	move		x:ada2,x0
	stx0		ad_im
  endif
  if @def(da1)
	ldx0		da1
	move		x0,x:ada1
  endif
  if @def(da2)
	ldx0		da2
	move		x0,x:ada2
  endif
  if @def(da_re)
	ldx0		da_re
	move		x0,x:ada1
  endif
  if @def(da_im)  
	ldx0		da_im
	move		x0,x:ada2
  endif
	flagset	ada
	ldx0	ada_savx0
	rti
	endsec
  endif
	endm


;; DSP56300 ASM Code
;; Free software restricted to academic use
;; Last update 15/04/2011

