;; Initialization for DSP56720 card
;; IRQ-HRX spi commands:
;; 0 = NOP  1,a = read   2,a,d = write   4,a,n = read multiple (DMA)
;; 5,a = read-and-clear 
;; 8 (bit 3) = Y-field (Xfield sinon)
;; 16 (bit 4) = Read-clear DSPSTATUS

init	macro
	dmar		spi
	var	spi_savx0
	var	spi_savr0
	var	spi_curcd
	var	spi_curad

	org	p:
;	reset
	move	#0,sp
	nop
	nop
	jsr	init

	section	inits 
	global	init
	org	p:
init
 if core==0
val_iprp0 set	val_iprp0&$fffff3|$00000C
val_sr0	set	val_sr0&$fffcff
 else
val_iprp1 set	val_iprp1&$fffff3|$00000C
val_sr1	set	val_sr1&$fffcff
 endif
	move	#$2B60BF,a1
	move	a1,x:$FFFF7D	; (PTCL)


	movep	#$000001,x:HCKR0	; cpha=1 autorise multiple I/Os avec ss\ actif
	movep	#$001028,x:HCSR0	; (reset)
	movep	#$001029,x:HCSR0	; ena slave 24b Rie-Fifo-not-empty 0001 0000 0010 1001
	clr	a
	sta	dspstatus
	sta	pcstatus
	flagclr	spi_waiad
	flagclr	spi_waidat
	flagclr	spi_wainb

	endsec


	section	irq
	global	irqhrx   ;,irq_dma_spi
	org	p:
irqhrx
	move		r0,x:spi_savr0
	movep		x:HRX0,r0
	jcf		spi_waiad,irqhrx3
	jcf		spi_waidat,irqhrx5
	jcf		spi_wainb,irqhrx7

	brset		#4,r0,irqhrxstat	
	brclr	#0,r0,irqhrx0
	flagset	spi_waiad
	bclr		#2,r0
	bcc		<irqhrx2
	flagset	spi_postclr
	bra		<irqhrx2

irqhrxstat
	movep		y:dspstatus,x:HTX0
	move		#0,r0
	flagtog		statrd
	bcs		irqhrxstat1
	move		#$800000,r0	; Bit 23 clignotant indique comm ok
irqhrxstat1
	move		r0,y:dspstatus
	move		x:spi_savr0,r0
	rti
	
irqhrx0
	brclr		#1,r0,irqhrx1
	flagset	spi_waidat
	flagset	spi_waiad
	bra		<irqhrx2
irqhrx1	
	brclr		#2,r0,irqhrxend
	flagset	spi_wainb
	flagset	spi_waiad
irqhrx2
	flagclr	spi_yf
	brclr		#3,r0,irqhrxend
	flagset	spi_yf
irqhrxend
	move		x:spi_savr0,r0
	rti


irqhrx3
	str0		spi_curad
	jf		spi_wainb,irqhrxend		
	jf		spi_yf,irqhrx4
	movep	x:(r0),x:HTX0
	jcnf		spi_postclr,irqhrxend
	move		vba,x:(r0)		; VBA vaut toujours 0 dans Fibula
	bra		irqhrxend
irqhrx4
	movep	y:(r0),x:HTX0
	jcnf		spi_postclr,irqhrxend
;	movep	x:$FFFFFD,y:(r0)  ; // read 0  cette adresse => RAZ de y:(R0)
	move		vba,y:(r0)
	bra		irqhrxend

irqhrx5
	stx0		spi_savx0
	move		r0,x0
	ldr0		spi_curad

	jf		spi_yf,irqhrx6
	move		x0,x:(r0)
	ldx0		spi_savx0
	bra		irqhrxend
irqhrx6
	move		x0,y:(r0)
	ldx0		spi_savx0
	bra		irqhrxend
irqhrx7
	movep	x:spi_curad,x:dsr_spi
	movep	#HTX0,x:ddr_spi
	movep	r0,x:dco_spi
	jf		spi_yf,irqhrx8
	movep	#$8E7250,x:dcr_spi
	bra		irqhrxend
irqhrx8		
	movep	#$8E7251,x:dcr_spi
	bra		irqhrxend

	endsec


	section	vectors	global

	org	p:$44
	jsr	irqhrx
	endsec


	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 15/09/2011

