;; General application header for FIBULA
;; Inserted at begin of user code


;;	nolist	
	page	255
	opt	nohdr	; no listing header
;	opt	mu	; memory utilization report
	opt	mi	; macros search in include Dir
	opt	nosms	; don't preserve memory space for SET
	opt	noidw	; no stall warnings	
	opt	mc	; display macro calls
	opt	nomd	; don't print macro defs
	opt	nocl	; don't print conditional asm
	opt	mex	; print macro expansions
	opt	nou	; don't print skiped conditional asm
	opt	ur	; show unresolved refs
	opt	dld	; allow directives within do loops
	opt	cex	; expand constants
;	opt	nl	; print nesting level
;	opt	cre	; print symbol cross reference
	opt	so	; print	symbol table

warn_already_def gset	0

pi	gset	3.14159265359
	unused		; none register yet used in critic section
	unresvd		; none HW/SW resource reserved
fext	equ	24576000.	; Oscillator frequency
fdsp	gset	196608000.	; Default DSP frequency

interruptible set 1	; if "1" serial BREAK or overflow stops program
				; if "0" only H/W RESET stops program

ccf		gset	0	; cycle counting disabled
cct		gset	0	; cycle count =0
actual_fs 	gset	0.
fast		set	1
dbgen		set	1
hi_outs	gset	0
es0_gp	gset	0
es0_outs 	gset	0
es1_gp	gset	0
es1_outs 	gset	0
sci_gp	gset	0
sci_outs 	gset	0
debugmode	gset	0

	varin		; default= block inputs are variables (not registers)
	section	long global
	org	l:0
	endsec

	section	vars	global	
	org	x:
	endsec
	section	flags global
	org	y:
flag_cnt	set	0
flags	equ	*
	endsec

	section	data	global	; shdata
	org	y:
	endsec

	section	far	global
	org	x:$3000
	org	y:$3000
	endsec

	section	longfar	global
	org	l:$6000
tempbuf	equ	$8000
	endsec

	section	vectors global
	org	p:0
	jmp	$100	;; restart
	endsec

val_pcrh		gset	0
val_prrh		gset	0
val_pdrh		gset	0

 if core==0
val_pcrc0	gset	0
val_prrc0	gset	0
val_pdrc0	gset	0

val_pcre0	gset	0
val_prre0	gset	0
val_pdre0	gset	0


val_pcrg	gset	$1E1
val_prrg	gset	$1E1
val_pdrg	gset	0

val_pcrg1	gset	0
val_prrg1	gset	0
val_pdrg1	gset	0

val_pcra	gset	0
val_prra	gset	0
val_pdra	gset	0

val_pcra1	gset	0
val_prra1	gset	0
val_pdra1	gset	0

val_iprc0	gset	0
val_iprc01	gset	0
val_iprp0	gset	0
val_iprp01	gset	0

val_sr0	gset	$300
 endif

 if core==1
val_pcrc1	gset	0
val_prrc1	gset	0
val_pdrc1	gset	0

val_pcre1	gset	0
val_prre1	gset	0
val_pdre1	gset	0

val_pcrg	gset	$1E1
val_prrg	gset	$1E1
val_pdrg	gset	0

val_pcrg1	gset	0
val_prrg1	gset	0
val_pdrg1	gset	0

val_iprc1	gset	0
val_iprc11	gset	0
val_iprp1	gset	0
val_iprp11	gset	0

val_sr1	gset	$300
 endif




	section	irq
	org	p:
begin_irq
	endsec

	section	shabs global	; vars systme
	org	y:$03D800
dspstatus		ds	1
scope_busy		equ	1
scope_rdy		equ	2

pcstatus		ds	1
scope_start	equ	0
scope_stop		equ	1
scope_dataread	equ	2
scope_dosync	equ	3
scope_edge		equ	4
tdrq			equ	8
rdrf			equ	9
plotr_acqreq	equ	12

scope_syncw		ds	1	; MSB = Sync level, LSB = Sync chan (0= sw sync)
scope_ptr		ds	1	; position du ptr d'criture au moment de l'envoi
scope_samp		ds	1	; nb d'chantillons (<=chansize)
scope_cnt		ds	1	; nb d'ch restant  acqurir
scope_canx		ds	1	; nb	de canaux
scope_desc		ds	64	; descripteurs des canaux (4 mots par canal)
 
	org	y:$03D850
term_inch		ds	1	; 50
term_outch		ds	1
term_resvd		ds	1

plotter_speed_h	ds	1
plotter_speed_l	ds	1
plotter_y1buf		ds	1	; 55
plotter_y2buf		ds	1
plotter_xbuf		ds	1

filestatus		ds	2	; 58

stepflag			ds	1	; 5A
blocknr			ds	1	; 5B	
blocktime		ds	1	; 5C
dbglevel			ds	1	; 5D


dbg_status 	dc	0	 ; equ	x:$FFFFFC		; dc	0	; 	8A
;; b0=communicating
;; b1=running
;; b2=halted
;; b3=brkpt
;; b4=Step IRQ 
;; b5=Step command
;; b6=STOP command
;; b7=GO command
;; b8=Update Req command


		endsec



	section	exec	global  ; Default section for working in Asm language
cycles	set	0
fdspi	set	@cvi(fdsp)
	msg	'>>> DSP Clock  = ',@cvi(fdsp/1000.),' kHz'

;	org	x:
;	org	y:
;	org	l:
	org	p:$100
restart
	init


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


