;; Installation de la communication par paquets: 
;; Sur Timer event, PC envoie NBRX, PC lit NBTX 
;; PC sends      Receives		DSP
;;     n	   	xxx			RxIRQ -> save n, write m 
;;    rxd0		 m 			DMA HRX  // DMA HTX // RxIRQoff
;;	rxd1		txd0
;;	rxd2		txd1
;;   ......     ........
;;    rxdn		txdn-1 
;;	 0		txdn
;;     0          txdn+1
;;     0        ........
;;     0		txdm 			IRQDMA HTX -> RxIRQon


txrx 	macro
	dmar		rx
	dmar		tx

	section	routines
	global	irqhrx,irqdmatx
	org	p:
irqhrx
	movep	x:HRX0,x:nbrx 
	movep	x:nbtx,x:HTX0    
	movep	#$000029,x:HCSR0	; NO IRQ 
; Rx auto 
	movep	#HRX0,x:dsr_rx	; Source: HRX  
	movep	#rxbuf,x:ddr_rx	; Destin: rxbuf 
	movep	x:nbrx,x:dco_rx	; count = nb_rx
	movep	#$8E72C4,x:dcr_rx	; Ena, Word, Fifo_not_empty, dest_incr,Y, src_fixe,X

; Tx auto 
	movep	#txbuf,x:dsr_tx	; src = Txbuf   
	movep	#HTX0,x:ddr_tx 	; dest = HTX
	movep	x:nbtx,x:dco_tx	; cnt = nbtx
	movep	#$CE6A51,x:dcr_tx	; Ena, IEN, Word, TXempty, dest_fixe,X, src_incr,Y
	rti	

irqdmatx
	bset		#12,x:HCSR0	; Re-enable IRQ
	flagset	txrxdone 
	rti

   
	endsec


	section	inits
	movep	#$000001,x:HCKR0	; cpha=1 autorise multiple I/Os avec ss\ actif
	movep	#$001028,x:HCSR0	; (reset)
	movep	#$001029,x:HCSR0	; ena slave 24b Rie-Fifo-not-empty 0001 0000 0010 1001	
val_iprc0	set	val_iprc0|(1<<diprc_tx)
val_sr0	set	val_sr0&$FFFCFF	
	endsec


	section	vectors	global

	org	p:dmavec_tx
	jsr	irqdmatx

	org	p:$44
	jsr	irqhrx

	endsec

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 13/05/2012

