;; Change the DSP clock frequency at execution
;; Syntax:	clock	frequency  
;; where frequency is expressed in MHz
;; Note:    min = 0.192    max =200.704   (MHz)
;; PLL bypassed if freq <= 24.576MHz
;; JMO      V. 567xx   16/3/2010
;; 

clock	macro	freq
;;fdsp	gset	fext*(ff+1)/((rr+1)*@pow(2,(oo+dd)))
;;  
;;	f = Fin * (ff+1) / (rr+1)*(2^OO)*2^DDD
;;   fmin= 24.576M 
;;	
;; CGPCTL	=  00 plkm RRRRR OO pen pstp DDD FFFFFFFF	
;;		   00  0    rr   oo  1   0    dd    ff

 if freq==196.608
	move	#$2B60BF,a1
 endif

 if freq==200.704
	move	#$2B4061,a1
 endif
 if freq==175.104
	move	#$2B60AA,a1
 endif
 if freq==150.528
	move	#$2B6092,a1
 endif
 if freq==98.304
	move	#$2BA0BF,a1
 endif
 if freq==49.152
	move	#$2BE0BF,a1
 endif
 if freq==24.576
	move	#$1000,a1		; No PLL from here
 endif
 if freq==12.288
	move	#$1100,a1
 endif
 if freq==6.144
	move	#$1200,a1
 endif
 if freq==3.072
	move	#$1300,a1
 endif
 if freq==1.536
	move	#$1400,a1
 endif
 if freq==0.768
	move	#$1500,a1
 endif
 if freq==0.384
	move	#$1600,a1
 endif
 if freq==0.192
	move	#$1700,a1
 endif
	move	a1,x:CGPCTL
fdsp	set	freq*1E6
	nolist
	msg	'>>> New DSP clock: ',@cvi(freq*1000),' kHz'
	list
	dbgw	CLOCK_modified
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 16/03/2010

