;; codec CS4349
;;				
;;		ESAI1_5	FST	PE4_1
;;		ESAI1_3	SCKT	PE3_1	
;; SDIN	PIO7		SDO2_3 PE9_1  TX2		

;;		ESAI1_0	HCKR	PE2_1
;; SCLK	ESAI1_2	SCKR	PE0_1
;; LRCK	ESAI1_4	FSR	PE1_1
;; SDOUT	PIO10		SDI0_3 PE6_1  RX0

;  if core==0
;    fail "must be in core 1"
;  endif

  if !@mac(i2c_fpga)
	include 'i2c_fpga.asm'
;	i2c_fpga
	endif	
	


iq_dac	macro	fs,att

	section	inits
val_pcre1	set	val_pcre1|$000218		;118
val_prre1	set	val_prre1|$000218  	;118

val_att	set	@cvi(2*att)&$0000FF
init_cs4349
  rep   #100
  nop
  move  x:status_pb,a1
  brclr #7,a1,init_cs4349

	movep	#$080000,y:tcr_1		; reset RX

 	movep	#$000040,y:saicr_1		; async

	

 if fs==48
	movep	#$ECc307,y:tccr_1
	movep	#$617D04,y:tcr_1		;617D01
	move	#$960211,r0			;cs4349 single-speed mode
 endif

 if fs==96
	movep	#$EC4307,y:tccr_1
	movep	#$617D04,y:tcr_1
	move	#$960212,r0			;cs4349 double-speed mode
 endif

 if fs==192	
	movep	#$EC4303,y:tccr_1
	movep	#$617D04,y:tcr_1
	move	#$960213,r0			;cs4349 Quad-speed mode
 endif
;;	move	#$960210,a1
	jsr	si_write			; conf mode i2s cs4349
	move	#$960389,r0			; meme niveau sur les 2 sorties
	jsr	si_write
	move	#$960400,r0
 	jsr	si_write
	move	#$960700,r0
	jsr	si_write
	move	#($960500|val_att),r0	; reglage attenuation
	jsr 	si_write
wait_cs4349_cnf:
  move	#100,m0		;; Newfreq
	rep	m0
	nop
  move  x:status_pb,a1
  brclr  #9,a1,wait_cs4349_cnf

val_iprp1 	set	val_iprp1|$000C00
val_sr1	set	val_sr1&$fffcff

core1_fs	set	actual_fs

	nolist
	nolist
	msg	'>>> CODEC Fs=',@cvi(fs*1000),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(0.001*fdsp/fs)
	list
	list

	endsec


	section	vectors global
	org	p:$78				; tx data
	jsr	irqesaitx

	org	p:$7A				; tx even data
	jsr	irqesaitxv
	endsec

	section	irq
	global  irqesaitx,irqesaitxv

irqesaitx
	if	@msp(sdr_tx_in_re)==2
	movep	y:sdr_tx_in_re,y:tx2_1
	else
	movep	x:sdr_tx_in_re,y:tx2_1
	endif
	rti

irqesaitxv
  if	@msp(sdr_tx_in_im)==2
	movep	y:sdr_tx_in_im,y:tx2_1
  else
	movep	x:sdr_tx_in_im,y:tx2_1
  endif
	flagset codecdone
	rti
	endsec

	org	p:
	waicf	codecdone

	endm



