;; Codec through DMA
;; To be used asynchronously to Sampling Frequency 
;; Req Source ESAI_Rx =$0B   ESAI_Tx =$0C
;; Req Source ESAI1_Rx=$15   ESAI1_Tx=$16
;; 

codec_async	macro	fs,input
	dmar	codec_tx	; Reserve 2 DMA channels
	dmar	codec_rx
	dmaor	codec_tx	; Reserve 2 DMA Offset Registers 
	dmaor	codec_rx

pcrc0	set	$FFFFBF
prrc0	set	$FFFFBE
pdrc0	set	$FFFFBD


	var	esai_error
 if !@def(in_l)
	var		in_l,0
 endif
 if !@def(in_r)
	var		in_r,0
 endif
 if !@def(out_l)
	var		out_l,0
 endif
 if !@def(out_r)
	var		out_r,0
 endif

	var	inbufl
	var	inbufr

	var	outbufl
	var	outbufr	

	section	inits

;; Req Source ESAI_Rx =$0B   ESAI_Tx =$0C
;; DCR for Rx  
;; DE  DIE DTM2 1   0  DPR1 0 DCON  DRS4 3 2 1   0 D3D DAM5 4   3  2 1 0 . DDS1 0  DSS1 0
;;  1   0     1 0 . 1     1 1   0  .   0 1 0 1 . 1  0     0 0 . 0  1 0 0 .    0 0     0 0
;;         A              E               5            8            4             0 
;; DSR = RX2            DDR = in_l / mic_l		DCO = 1

	movep	#-1,x:dorreg_codec_rx
	movep	#RX2,x:dsr_codec_rx 
	movep	#inbufl,x:ddr_codec_rx
	movep	#$000001,x:dco_codec_rx
	movep	#$AE5840+(dor_codec_rx<<7),x:dcr_codec_rx

;; DCR for Tx  
;; DE  DIE DTM2 1   0  DPR1 0 DCON  DRS4 3 2 1   0 D3D DAM5 4   3  2 1 0 . DDS1 0  DSS1 0
;;  1   0     1 0 . 1     1 1  0  .   0 1 1 0 .  0  0     1 0 . 0  0 0 0 .    0 0     0 0
;;         A              E               6            2            0             0
;; DSR = out_l         DDR = TX2		DCO = 1

	movep	#-1,x:dorreg_codec_tx
	movep	#outbufl,x:dsr_codec_tx
	movep	#TX2,x:ddr_codec_tx 
	movep	#$000001,x:dco_codec_tx
	movep	#$AE6200+(dor_codec_tx<<4),x:dcr_codec_tx


	movep   #$000007,x:pdrc0	; mettre 1 borne spi codec
val_pdrc0	set val_pdrc0|$000007
	movep	#$000338,x:pcrc0
val_pcrc0	set val_pcrc0|$000338
	movep	#$00033F,x:prrc0	; pins ESAI = 1 et 1
val_prrc0   set val_prrc0|$00033F	
;val_pdrh		set		val_pdrh|$080000	
	
	movep	#$080000,x:tcr		; reset TX
	movep	#$080000,x:rcr		; reset RX
	movep	#$000040,x:saicr		; sync
	
	move	#$001E00,a1			;reset Codec
	bsr	send_spi

	if ("input"=='line')
	move	#$000C22,a1			;power on,clk,out,dac, adc line
	else
	move	#$000C21,a1			;power on,clk,out,dac, adc mi
	endif
	bsr		send_spi

	move	#$000E0A,a1			;I2S format 24 bits
	bsr		send_spi

	move	#$001201,a1			; active digit interface
	bsr		send_spi
	
	move	#$000A01,a1			; DAPC=0
	bsr		send_spi
	
	move	#$0004f9,a1			; LHVP=0
	bsr		send_spi
	
	move	#$0006f9,a1			; RHVP=0 
	bsr		send_spi
	
	move	#$000017,a1			; Left Line input channel
	bsr		send_spi
	
	move	#$000217,a1			; Right Line input channel
	bsr		send_spi

	if ("input"=='line')
	move	#$000812,a1			; Analog Audio Path Control
	else
	move	#$000814,a1			; Analog Audio Path Control
	endif
	bsr		send_spi

 if fs==8
	move	#$00100C,a1		;  SRC=8kHz
	bsr		send_spi
	movep	#$EDC31F,x:tccr   ;  $EEC30F  FEC307
	movep	#$017904,x:tcr
	movep	#$017904,x:rcr
codec_fs	set	8000.
 endif
 if fs==32
	move	#$001018,a1		; SRC=32kHz
	bsr		send_spi
	move	#$000A02,a1			;Deemphasis
	bsr		send_spi
	movep	#$EDC307,x:tccr
	movep	#$017904,x:tcr
	movep	#$017904,x:rcr

codec_fs	set	32000.
 endif
 if fs==48
	move	#$001000,a1		;SRC=48kHz
	bsr		send_spi
	move	#$000E0E,a1			;I2S format 32 bits
	bsr		send_spi
	move	#$000A06,a1			;Deemphasis
	bsr		send_spi

	movep	#$ECC307,x:tccr
	movep	#$417D04,x:tcr
	movep	#$417D04,x:rcr
codec_fs	set	48000.
 endif
 if fs==96
	move	#$00101C,a1		; SRC=96kHz
	bsr		send_spi
	move	#$000E0E,a1			;I2S format 32 bits
	bsr		send_spi
	movep	#$EC4307,x:tccr
	movep	#$EC4307,x:rccr
	movep	#$017D04,x:tcr
	movep	#$017D04,x:rcr

codec_fs	set	96000.
 endif

	movep	#0,x:tx2


	nolist
	nolist
	msg	'>>> CODEC_Fs=',@cvi(fs*1000),'Hz'
	list
	list

	endsec



	section	routines
	global send_spi
	org	p:
	
send_spi
	bclr	#1,x:pdrc0   ;; csn low
send_spi0
	do		#16,fin_spi
	bclr	#0,x:pdrc0		;; clk low
	rep		#5
	nop	
	jclr	#15,a1,send_spi1
	bset	#2,x:pdrc0		;; data low
	jmp		send_spi2
send_spi1
	bclr	#2,x:pdrc0		;; data high
send_spi2
	rep		#5
	nop
	bset	#0,x:pdrc0		;; clk high
	asl		#1,a,a
	rep		#10
	nop
fin_spi
	bset	#1,x:pdrc0  ;; CSN high
	movep	#$000007,x:pdrc0
	rts	
	endsec

;; Mainloop code 
	org	p:
	move	x:inbufl,x0
	move	x:inbufr,x1
 if ("input"=='line') 
	stx0	in_l 
	stx1	in_r
 else
	stx0	mic
 endif 

	ldx0	out_l 
	ldx1	out_r 
	move	x0,x:outbufl
	move	x1,x:outbufr


	u	x 



	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 8/1/2015

