;; Sample fast AD & DA on DIDALAB ETD410 000
;; version pour carte zet410
;; Syntax:   ADA Frequency
;; where Frequency is expressed in Hz


i_ada	macro	fs
hffreq	set	163.84E6  ; freq pll FPGA
fpga_base	set	$040000
adc_base	set fpga_base+$100
adc_ctrl	set fpga_base

adc0		set adc_base+1
adc1		set adc_base+2
dac_base	set fpga_base+$200
dac0		set dac_base
dac1		set dac_base+1
dac2		set dac_base+2
dac3		set dac_base+3

ada1	set	fpga_base
ada2	set	fpga_base+1
adast	set	fpga_base+2	; ctrl_status
 if core==1
adafh	set	fpga_base+5	; Freq du synth
adafl	set	fpga_base+6
 else
adafh	set	fpga_base+3	; Freq du synth
adafl	set	fpga_base+4
 endif
hrcntr 	set	fpga_base+5

ada_fract	set	@lfr(2*fs/hffreq) ; fext)

ada_fh	set	ada_fract>>24
ada_fl	set	ada_fract&$000000FFFFFF

ada_fs	set	fs
 if core==0
core0_fs	set	fs
 else
core1_fs	set	fs
 endif
actual_fs	set	fs		

pcrc0	set	$FFFFBF
prrc0	set	$FFFFBE
pdrc0	set	$FFFFBD

	var	ada_sava2
	var	ada_sava1
	var	ada_sava0

 if !@def(ada_init)
	section	inits
	global	ada_init
	org	p:
ada_init
	clr	a
	move	a1,x:EMC_BRL0
	movep	#0,y:PDRA
	movep	#0,y:PDRA_1		; cf chip errata
	movep	#$FFFFFF,y:PCRA
	movep	#$FFFFFF,y:PRRA
	movep	#$000007,y:PCRA_1
	movep	#$000007,y:PRRA_1


	move	#$001801,a1		; $1E01
	move	a1,x:EMC_BRL2		; V=1 zone X, R/w, Valid
	move	#$000010,a1
	move	a1,x:EMC_BRH2   		; adresse de base $40000
	move	#$006010,a1		;#006000 #$000F07,a CSNT=1   
	move	a1,x:EMC_ORL2
	move	#$0003FF,a1			;#$0003FF,a
	move	a1,x:EMC_ORH2     		; masque adesse A23:A14

	move	#$000040,a1		; LCTL LBOE
	move	a1,x:EMC_LBCRH	
	move	#$000500,a1
	move	a1,x:EMC_LBCRL
	move	#$000004,a1		; clkdiv=4
	move	a1,x:EMC_LCRRL
	move	#$000001,a			; $008000,a
	move	a1,x:EMC_LCRRH

	move	#>ada_fh,a1
	move	a1,x:adafh
	move	#>ada_fl,a1
	move	a1,x:adafl

	move	#$000001,a1
	move	a1,x:adast
	
	;; selection voie 0 et 2
	move	#$000000,a1
	move	a1,x:adc_ctrl

 if @def(ad3)|@def(ad4)
	flagset	i_ada_chan
 else
	flagclr 	i_ada_chan
 endif
	
 if core==0
val_iprc0	set	val_iprc0|$000007 ; IRQA
val_sr0	set	val_sr0&$fffcff
 else
;	move	#$000002,a1
;	move	a1,x:adast

val_iprc1	set	val_iprc1|$000038 ; IRQB              ;$000E00 ; IRQD
val_sr1	set	val_sr1&$fffcff
 endif
	endsec
 endif

	nolist
	nolist
	msg	'>>> ADA Fs=',@cvi(fs),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(fdsp/fs)
	list
	list


 if !@def(irqa)
	section	vectors	global
  if core==0
	org	p:$10
	jsr	irq_ada	; IRQA
  else
	org	p:$12
	jsr	irq_ada	; IRQB
  endif
	endsec



	section	irq
	global irq_ada
;;
	org	p:
irq_ada
	jsr	savrest_save


;	sta2		ada_sava2
;	sta1		ada_sava1
;	sta0		ada_sava0

  if @def(ad3)|@def(ad4)
  jf	i_ada_chan,lire_ad1
  endif

  if @def(ad1)
;;	move		x:ada1,x0
	move		x:adc0,a1
	lsl			#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad1
;;	stx0		ad1
  endif
  if @def(ad2)
;;	move		x:ada2,x0
	move		x:adc1,a1
	lsl			#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad2
;;	stx0		ad2
  endif
  if @def(ad3)|@def(ad4)
	flagset	i_ada_chan
	move		#$000001,a1
	bra		lire_ad2
lire_ad1
   if @def(ad3)
	move		x:adc0,a1
	lsl			#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad3
   endif
   if @def(ad4)
	move		x:adc1,a1
	lsl			#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad4
   endif
	flagclr		i_ada_chan
	clr			a
lire_ad2 
	move		a1,x:adc_ctrl
  endif
  if @def(ad_re)
    move		x:adc0,a1
	lsl		#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad_re
  endif
  if @def(ad_im)
	move		x:adc1,a1
	lsl			#8,a1
	bchg		#23,a1
	neg			a
	sta1		ad_im
  endif
  if @def(da1)
	lda1		da1
	lsr		#12,a1
	bchg		#11,a1
	move		a1,x:dac0
  endif
  if @def(da2)
	lda1		da2
	lsr		#12,a1
	bchg		#11,a1
	move		a1,x:dac1
  endif
  if @def(da3)
	lda1		da3
	lsr		#12,a1
	bchg		#11,a1
	move		a1,x:dac2
  endif
  if @def(da4)
	lda1		da4
	lsr		#12,a1
	bchg		#11,a1
	move		a1,x:dac3
  endif  
  if @def(da_re)
	lda1		da_re
	lsr			#12,a1
	bchg		#11,a1
	move		a1,x:dac0
  endif
  if @def(da_im)  
	lda1		da_im
	lsr		#12,a1
	bchg		#11,a1
	move		a1,x:dac1
  endif
   if @def(ada_b)  
	flagset	ada
  endif
;	lda2		ada_sava2
;	lda1		ada_sava1
;	lda0		ada_sava0
critic	gset		1
	u	a
critic	gset		0
	endsec
 endif
	
	endm

	






;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 07/12/2011

