;; codec CS4349
;;				
;;		ESAI1_5	FST	PE4_1
;;		ESAI1_3	SCKT	PE3_1	
;; SDIN	PIO7		SDO2_3 PE9_1  TX2		

;;		ESAI1_0	HCKR	PE2_1
;; SCLK	ESAI1_2	SCKR	PE0_1
;; LRCK	ESAI1_4	FSR	PE1_1
;; SDOUT	PIO10		SDI0_3 PE6_1  RX0

;  if core==0
;    fail "must be in core 1"
;  endif

;  if !@mac(i2c_fpga)
;	include 'i2c_fpga.asm'
;	i2c_fpga
;	endif	

fpga_base	set	$040000
status_i2c0	set 	fpga_base+$15
ctrl_i2c0	set	fpga_base+$17
tx_i2c0	set   fpga_base+$18	


i_iq_dac	macro	fs,att

	section	inits
val_pcrc0 set  val_pcrc0|$000018         ; SCKT et FST ESAI0
val_prrc0 set  val_prrc0|$000018
  
val_pcre0	set	val_pcre0|$000218		;PE9 SDO2_1
val_prre0	set	val_prre0|$000218  	;

  clr	a
	move	a1,x:EMC_BRL0
	movep	#0,y:PDRA
	movep	#0,y:PDRA_1		; cf chip errata
	movep	#$FFFFFF,y:PCRA
	movep	#$FFFFFF,y:PRRA
	movep	#$000007,y:PCRA_1
	movep	#$000007,y:PRRA_1


	move	#$001801,a1		; $1E01
	move	a1,x:EMC_BRL2		; V=1 zone X, R/w, Valid
	move	#$000010,a1
	move	a1,x:EMC_BRH2   		; adresse de base $40000
	move	#$006010,a1		;#006000 #$000F07,a CSNT=1   
	move	a1,x:EMC_ORL2
	move	#$0003FF,a1			;#$0003FF,a
	move	a1,x:EMC_ORH2     		; masque adesse A23:A14

	move	#$000040,a1		; LCTL LBOE
	move	a1,x:EMC_LBCRH	
	move	#$000500,a1
	move	a1,x:EMC_LBCRL
	move	#$000004,a1		; clkdiv=4
	move	a1,x:EMC_LCRRL
	move	#$000001,a			; $008000,a
	move	a1,x:EMC_LCRRH


val_att	set	@cvi(2*att)&$0000FF
  movep #$000222,y:eiccr    ; esai1 HCKT, sckt ,fst   

  movep #$080000,x:tcr
	movep	#$080000,y:tcr_1		; reset TX

;  movep #$000040,x:saicr
 	movep	#$000040,y:saicr_1		; async	

 if fs==48
  movep #$ECC307,x:tccr
  movep #$017D00,x:tcr
  
	movep	#$0Cc307,y:tccr_1 ; HCKT , SCKT FST Input
	movep	#$617D04,y:tcr_1		; TX2_1 
	move	#($000100|val_att),r0			;cs4349 single-speed mode
 endif

 if fs==96
  movep #$EC4307,x:tccr
  movep #$017D00,x:tcr
 
	movep	#$0C4307,y:tccr_1
	movep	#$617D04,y:tcr_1
	move	#($000200|val_att),r0			;cs4349 double-speed mode
 endif

 if fs==192
  movep #$EC4303,x:tccr
  movep #$017D00,x:tcr
 	
	movep	#$0C4303,y:tccr_1
	movep	#$617D04,y:tcr_1
	move	#($000300|val_att),r0			;cs4349 Quad-speed mode
 endif

	move	#$823344,r1      ; FONCTION D->configuration DAC

	move	r0,a1
	move  a1,x:tx_i2c0
	move  r1,a1
	move 	a1,x:ctrl_i2c0
wait_sdr:
	move	#100,m0		;; Newfreq
	rep	m0
	nop
 	move  x:status_i2c0,a1
	brset	#5,a1,wait_sdr    ;; I2c busy?	
  
  move  #$000100,a1
  move 	a1,x:ctrl_i2c0  

  move #10000000,r0
  rep r0
  nop
	
val_iprp0 	set	val_iprp0|$000C00     ; interruption ESAI1
val_sr0	set	val_sr0&$fffcff

core0_fs	set	actual_fs


	nolist
	nolist
	msg	'>>> CODEC Fs=',@cvi(fs*1000),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(0.001*fdsp/fs)
	list
	list

	endsec


	section	vectors global
	org	p:$78				; tx data
	jsr	irqesaitx

	org	p:$7A				; tx even data
	jsr	irqesaitxv
	endsec

	section	irq
	global  irqesaitx,irqesaitxv

irqesaitx
  if @def(f_tx_in_re)
	if	@msp(f_tx_in_re)==2
	movep	y:f_tx_in_re,y:tx2_1
	else
	movep	x:f_tx_in_re,y:tx2_1
	endif
  else
  clr  a
  move a1,y:tx2_1
	endif
	rti

irqesaitxv
  if @def(f_tx_in_im)
  if	@msp(f_tx_in_im)==2
	movep	y:f_tx_in_im,y:tx2_1
  else
	movep	x:f_tx_in_im,y:tx2_1
  endif
  else
  clr a
  move a1,y:tx2_1
  endif
	flagset codecdone
critic	gset	1
	jsr	savrest_save

;	rti


	endsec


	endm



