;; module sdr_tx_27MHz
;; 

sdr_tx	macro		rf,freq	

fpga_base	set	$040000
status_i2c0	set 	fpga_base+$15
ctrl_i2c0	set	fpga_base+$17
tx_i2c0	set   fpga_base+$18

	section	long global
	org	l:
sdr_tx_coef		dc	@lfr(@cvf($1000000)/30E6)
sdr_tx_ref		dc	@cvi(freq)
sdr_tx_freqm	dc	0
 if !@def(sdr_tx_freq)
sdr_tx_freq		dc	0
 endif 
	endsec

	section 	inits
	move		l:sdr_tx_ref,x
	move		x,l:sdr_tx_freq	
 if	"rf"=='on'
	flagset	sdr_tx_rf_on
 else
	flagclr	sdr_tx_rf_on
 endif
	flagclr	sdr_tx_rfm 
	endsec  


	org	p:
	ldx	sdr_tx_freq
	lda	sdr_tx_freqm		; l'entre freq a-t-elle vari ? 
	sub	x,a
	bne	sdr_tx0

 	jf	sdr_tx_rf_on,sdr_tx0a	; La commande RF_ON a-t-elle chang d'tat ?
	jnf	sdr_tx_rfm,sdr_tx_end
	flagclr sdr_tx_rfm
	bra	sdr_tx0 
sdr_tx0a
	jf	sdr_tx_rfm,sdr_tx_end	; Rien n'a chang: ne rien faire 
	flagset	sdr_tx_rf_on
sdr_tx0	
	jf	sdr_tx_w1,sdr_tx_wf 	; si en attente de cde Freq, lire le status
	jf	sdr_tx_w2,sdr_tx_wrf 	; si en attente de cde RF ON/OFF , lire le status 
 
	stx	sdr_tx_freqm		; Sinon, mmoriser la dernire valeur, calculer nouvelle fraction  

;; Conversion d'un ENTIER LONG (48b) 0 .. 120 000 000 en fractionnaire 0 .. 1.0
;; fraction = (Fr(1.0) >> 24)*freq/freqmax) << 24 
	move		l:sdr_tx_coef,y
	mpyuu		x0,y0,a
	move		a0,b0
	dmacsu 	x1,y0,a
	macsu		y1,x0,a
	move		a0,b1
	dmacss 	x1,y1,a
	asl		#24,a,a
	rnd	b
	move		b1,a0

	asr	a		 	; ligne  supprimer pour une commande fractionnaire NON signe (0 .. FFFFFF)

	rnd	a
  	move  a,x:tx_i2c0

	sta	sdr_tx_test		; provisoire pour vrifier la conversion 
 
 	move 	#$824346,a1
  	move 	a1,x:ctrl_i2c0
	flagset sdr_tx_w1
	bra	sdr_tx_end
sdr_tx_wf  
  	move  x:status_i2c0,a1 	; attente de la cde freq
  	brset	#5,a1,sdr_tx_end	; si status[5] = 1, attendre encore 

	flagclr sdr_tx_w1
  	move  #$000100,a1		; sinon, terminer 
  	move 	a1,x:ctrl_i2c0

	clr	a
	jnf	sdr_tx_rf_on,sdr_tx1
	move	#$01,a1	    
sdr_tx1
  	move  a1,x:tx_i2c0	
  
  	move 	#$82234D,a1
  	move 	a1,x:ctrl_i2c0
	flagset sdr_tx_w2  
	bra	<sdr_tx_end
sdr_tx_wrf
  	move  x:status_i2c0,a1 	
  	brset #5,a1,sdr_tx_end
  
	flagclr sdr_tx_w2
  	move  #$000100,a1
  	move 	a1,x:ctrl_i2c0

sdr_tx_end

	u	a
	u	b
	u	x
	u	y

	endm 


