;; module sdr_rx_ hf
;; sur core 1 I2c1

;;	include 'i2c0.asm'

sdr_rx_hf	macro	band,att,freq

fpga_base	set	$040000
stat_i2c1	set 	fpga_base+$19
ctrl_i2c1	set	fpga_base+$1B
data_i2c1	set   fpga_base+$1C


freq_fract  set @cvf(freq/30.0e6)
f_fract     set @frc(freq_fract)

	section	long global
	org	l:
sdr_rx_hf_coef		dc	@lfr(@cvf($1000000)/30E6)
sdr_rx_hf_ref		dc	@cvi(freq)
sdr_rx_hf_freqm	dc	0
	endsec

	section 	inits
	move		l:sdr_rx_hf_ref,x
	move		x,l:sdr_rx_hf_freq	
 if ("band"=='all')	
  	move    	#$00,a1
 endif
 if ("band"=='27_MHz') 
	move	  	#$01,a1    
 endif 
 if ("band"=='mf')
	move	  	#$02,a1    
 endif
 if ("band"=='lf')
	move	  	#$03,a1    
 endif

 if ("att"=="-10")
  	or    	#$10,a  
 endif
 if ("att"=="-20")
  	or    	#$20,a  
 endif
 if ("att"=="-40")
  	or    	#$30,a  
 endif
 	move  	a1,x:data_i2c1	 
  	move 		#$84234D,a1
  	move 		a1,x:ctrl_i2c1
	flagset	sdr_rx_w  
	endsec  


	org p:
	ldx	sdr_rx_hf_freq
	lda	sdr_rx_hf_freqm	; l'entre freq a-t-elle vari ? 
	sub	x,a 
	beq	sdr_rx_end		; non: ne rien faire 
 					; Oui: 
	jf	sdr_rx_w,sdr_rx_wf ; si en attente de cde, lire le status 
					; sinon 
	stx	sdr_rx_hf_freqm	; mmoriser la dernire valeur  

;; Conversion d'un ENTIER LONG (48b) 0 .. 120 000 000 en fractionnaire 0 .. 1.0 
;; fraction = (Fr(1.0) >> 24)*freq/freqmax) << 24  
	move		l:sdr_rx_hf_coef,y 
	mpyuu		x0,y0,a 
	move		a0,b0 
	dmacsu 	x1,y0,a  
	macsu		y1,x0,a 
	move		a0,b1 
	dmacss 	x1,y1,a 
	asl		#24,a,a 
	rnd		b 
	move		b1,a0 
	asr		a		 ;  supprimer pour une commande fractionnaire NON signe (0 .. FFFFFF) 

	rnd		a 
  	move  	a,x:data_i2c1 
  	move 		#$844346,a1
  	move 		a1,x:ctrl_i2c1

	flagset 	sdr_rx_w 
	bra		sdr_rx_end

sdr_rx_wf  
  	move  x:stat_i2c1,a1 	; attente de l'envoi de la cde 
  	brset	#5,a1,sdr_rx_end	; si status[5] = 1, attendre encore  

	flagclr sdr_rx_w		; sinon, raz flag, terminer
  	move  #$000100,a1		;  
  	move 	a1,x:ctrl_i2c1 
sdr_rx_end

	u	a
	u	b
	u	x
	u	y		

	endm

