;; Module I2C pour communication avec module SDR
;; SDA PC7_1 SCL PC8_1

i2c_sdr	macro
	
	org	p:

	section inits

val_pdrc1	set	val_pdrc1|$000180		; scl=1 sda=1	  
val_prrc1	set 	val_prrc1|$000180  	; scl=output sda output	
val_pcrc1	set 	val_pcrc1&$FFFE7F
	movep   #$000180,x:pdrc
	movep	  #$000180,x:prrc
	movep	  #$000000,x:pcrc

	endsec

	section	routines

i2c_start
	bclr	#7,x:pdrc
	rep	#400
	nop
	bclr	#8,x:pdrc
	rep	#800
	nop
	rts

i2c_stop
	bset	#8,x:pdrc
	rep	#400
	nop
	bset	#7,x:pdrc
	rep	#1400
	nop
	rts

i2c_ackw
	bclr	#7,x:prrc
	bset	#7,x:pcrc
	rep	#400
	nop
	bset	#8,x:pdrc
	rep	#1400
	nop
	bclr	#8,x:pdrc
	rep	#900
	nop
	bclr	#7,x:pcrc
	bset	#7,x:prrc	
	rts

i2c_w	
	do	#8,i2c_wf
	jclr	#15,a1,i2c_w01
	bset	#7,x:pdrc
	jmp	i2c_w00
i2c_w01
	bclr	#7,x:pdrc
i2c_w00
	rep	#200
	nop
	bset	#8,x:pdrc
	rep	#900
	nop
	bclr	#8,x:pdrc
	rep	#900
	nop
	asl		#1,a,a
i2c_wf
	nop
	rts

	global i2c_si_w
i2c_si_w
	do	#8,si_wf
	jclr	#23,a1,si_w1
	bset	#7,x:pdrc
	jmp	si_w0
si_w1
	bclr	#7,x:pdrc
si_w0
	rep	#400
	nop
	bset	#8,x:pdrc
	rep	#1400
	nop
	bclr	#8,x:pdrc
	rep	#1000
	nop
	asl		#1,a,a
si_wf
	nop
	rts

	global	si_write
si_write
;;	LDA	name\w_si
	jsr	i2c_start
	jsr	i2c_si_w
	jsr	i2c_ackw
	jsr	i2c_si_w
	jsr	i2c_ackw
	jsr	i2c_si_w
	jsr	i2c_ackw
	jsr	i2c_stop
	rts

	global	pcf8574_w
pcf8574_w
;;	LDA	name\aff_port
	jsr	i2c_start
	jsr	i2c_w
	jsr	i2c_ackw
	jsr	i2c_w
	jsr	i2c_ackw
	jsr	i2c_stop
	rts


	endsec
	endm
