;; module sdr_tx_27MHz
;; modification rjl du 21/4/2015 gestion tat rf on/off

sdr_tx	macro		rf,freq,speed,atten	

fpga_base	set	$040000
status_i2c0	set 	fpga_base+$15
ctrl_i2c0	set	fpga_base+$17
tx_i2c0	set   fpga_base+$18

sdr_tx_n0	set	@cvi(actual_fs/50.) ; valeur de rechargement du timer 

	section	long global
	org	l:
sdr_tx_coef		dc	@lfr(@cvf($1000000)/30E6)
sdr_tx_ref		dc	@cvi(freq)
sdr_tx_freqm	dc	0
 if !@def(sdr_tx_freq)
sdr_tx_freq		dc	0
 endif 
	endsec

	var		sdr_tx_mstatus,0
	var		sdr_tx_timer,sdr_tx_n0 

	section 	inits
	move		l:sdr_tx_ref,x
	move		x,l:sdr_tx_freq	
 if	"rf"=='on'
	flagset	sdr_tx_rf_on
  flagclr	sdr_tx_rfm
 else
	flagclr	sdr_tx_rf_on
  flagset sdr_tx_rfm
 endif
	 

	move		#>sdr_tx_n0,a
	sta		sdr_tx_timer
	flagset	waiting_ready
;	flagset	req_speed
	endsec  


	org	p: 

	lda	sdr_tx_timer	; Timer 50 Hz 
	sub	#1,a
	sta	sdr_tx_timer
	bgt	sdr_tx_end 
	move	#>sdr_tx_n0,a
	sta	sdr_tx_timer


sdr_tx2 
	ldx	sdr_tx_freq
	lda	sdr_tx_freqm		; l'entre freq a-t-elle vari ?
;	stx	sdr_tx_freqm 
	sub	x,a
	bne	sdr_tx_chg_f		; Si oui, modifierla frquence 

sdr_tx_chg_onoff				; Sinon:
 	jf	sdr_tx_rf_on,sdr_tx0a	; La commande RF_ON a-t-elle chang d'tat ?
	jnf	sdr_tx_rfm,sdr_tx_end	; now OFF mem OFF 
	;flagclr sdr_tx_rfm		; now OFF mem ON --> do OFF 

sdr_tx_do_off
	clr	a
	bra	sdr_tx_do_onoff
sdr_tx0a
	jf	sdr_tx_rfm,sdr_tx_end	; now ON mem ON Rien n'a chang: ne rien faire 
	;flagset	sdr_tx_rfm

;sdr_tx_do_on
	move	#$01,a1
sdr_tx_do_onoff
	move	x:status_i2c0,r0
	brset #5,r0,sdr_tx_end
	move  #$000100,r1
	move  r1,x:ctrl_i2c0
	brclr #6,r0,sdr_tx_end	    
  	move  a1,x:tx_i2c0	 
  	move 	#$82234D,a1
  	move 	a1,x:ctrl_i2c0
  jf sdr_tx_rf_on,sdr_tx_do_on
  flagclr  sdr_tx_rfm
  bra   sdr_tx_end
sdr_tx_do_on  
  flagset  sdr_tx_rfm
;	flagset waiting_busy
;	flagset waiting_ready  
	bra	sdr_tx_end

;; Conversion d'un ENTIER LONG (48b) 0 .. 120 000 000 en fractionnaire 0 .. 1.0
;; fraction = (Fr(1.0) >> 24)*freq/freqmax) << 24 
sdr_tx_chg_f
	move		x:status_i2c0,r0
	brset 	#5,r0,sdr_tx_end
	move  	#$000100,r1
	move  	r1,x:ctrl_i2c0
	brclr 	#6,r0,sdr_tx_end

	move		l:sdr_tx_coef,y	; X1:X0 contient la frqu en Hz  
	mpyuu		x0,y0,a
	move		a0,b0
	dmacsu 	x1,y0,a
	macsu		y1,x0,a
	move		a0,b1
	dmacss 	x1,y1,a
	asl		#24,a,a
	rnd	b
	move		b1,a0

	asr	a		 	; ligne  supprimer pour une commande fractionnaire NON signe (0 .. FFFFFF)

	rnd	a
	stx	sdr_tx_freqm
  	move  a1,x:tx_i2c0
	sta1	sdr_tx_test		; provisoire pour vrifier la conversion 

 	move 	#$824346,a1
  	move 	a1,x:ctrl_i2c0
	flagset waiting_busy
	flagset waiting_ready  
sdr_tx_end 

	u	a
	u	b
	u	x
	u	y

	endm
 



