;; module sdr_rx_ hf
;; sur core 1 I2c1
;; Modifiation 21/4/15  modif i2c non bloquant

;;	include 'i2c0.asm'

sdr_rx_hf	macro	band,att,freq

fpga_base	set	$040000
status_i2c1	set 	fpga_base+$19
ctrl_i2c1	set	fpga_base+$1B
data_i2c1	set   fpga_base+$1C

sdr_rx_hf_n0  set @cvi(actual_fs/50.)

;freq_fract  set @cvf(freq/30.0e6)
;f_fract     set @frc(freq_fract)

	section	long global
	org	l:
sdr_rx_hf_coef		dc	@lfr(@cvf($1000000)/30E6)
sdr_rx_ref		dc	@cvi(freq)
sdr_rx_hf_freqm	dc	0
 if !@def(sdr_rx_hf_freq)
sdr_rx_hf_freq  dc  0
 endif
	endsec

  var   sdr_rx_hf_timer,sdr_rx_hf_n0

	section 	inits
  
  	clr	a
	move	a1,x:EMC_BRL0
;	move	#$006000,a
;	move	a1,x:EMC_ORL0

	movep	#0,y:PDRA
	movep	#0,y:PDRA_1		; cf chip errata
	movep	#$FFFFFF,y:PCRA
	movep	#$FFFFFF,y:PRRA
	movep	#$000007,y:PCRA_1
	movep	#$000007,y:PRRA_1


	move	#$001801,a1		; $1E01
	move	a1,x:EMC_BRL2		; V=1 zone X, R/w, Valid
	move	#$000010,a1
	move	a1,x:EMC_BRH2   		; adresse de base $40000
	move	#$006010,a1		;#006000 #$000F07,a CSNT=1   
	move	a1,x:EMC_ORL2
	move	#$0003FF,a1			;#$0003FF,a
	move	a1,x:EMC_ORH2     		; masque adesse A23:A14

	move	#$000040,a1		; LCTL LBOE
	move	a1,x:EMC_LBCRH	
	move	#$000500,a1
	move	a1,x:EMC_LBCRL
	move	#$000004,a1		; clkdiv=4
	move	a1,x:EMC_LCRRL
	move	#$000001,a			; $008000,a
	move	a1,x:EMC_LCRRH

  
  
  move  #>sdr_rx_hf_n0,a
  sta    sdr_rx_hf_timer
  
  move		l:sdr_rx_ref,x
	move		x,l:sdr_rx_hf_freq	
 if ("band"=='all')	
  	move    	#$00,a1
 endif
 if ("band"=='27_MHz') 
	move	  	#$01,a1    
 endif 
 if ("band"=='mf')
	move	  	#$02,a1    
 endif
 if ("band"=='lf')
	move	  	#$03,a1    
 endif

 if ("att"=="-10")
  	or    	#$10,a  
 endif
 if ("att"=="-20")
  	or    	#$20,a  
 endif
 if ("att"=="-40")
  	or    	#$30,a  
 endif
sdr_rx_hf_wait0
  rep #100
  nop
  move    #$000100,r0
  move    r0,x:ctrl_i2c1
  move    x:status_i2c1,r1
  brclr   #6,r1,sdr_rx_hf_wait0
 	move  	a1,x:data_i2c1	 
  	move 		#$84234D,a1
  	move 		a1,x:ctrl_i2c1
;	flagset	sdr_rx_w  
	endsec  


	org p:
  lda sdr_rx_hf_timer
  sub #1,a
  sta sdr_rx_hf_timer
  bgt sdr_rx_end
  move #>sdr_rx_hf_n0,a
  sta  sdr_rx_hf_timer
  
	ldx	sdr_rx_hf_freq
	lda	sdr_rx_hf_freqm	; l'entre freq a-t-elle vari ? 
	sub	x,a 
	beq	sdr_rx_end		; non: ne rien faire 
  
  move  x:status_i2c1,r0
  brset #5,r0,sdr_rx_end
  move  #$000100,r1
  move  r1,x:ctrl_i2c1
  brclr #6,r0,sdr_rx_end
 					; Oui: 
;;	jf	sdr_rx_w,sdr_rx_wf ; si en attente de cde, lire le status 
					; sinon 
;;	stx	sdr_rx_hf_freqm	; mmoriser la dernire valeur  

;; Conversion d'un ENTIER LONG (48b) 0 .. 120 000 000 en fractionnaire 0 .. 1.0 
;; fraction = (Fr(1.0) >> 24)*freq/freqmax) << 24  
	move		l:sdr_rx_hf_coef,y 
	mpyuu		x0,y0,a 
	move		a0,b0 
	dmacsu 	x1,y0,a  
	macsu		y1,x0,a 
	move		a0,b1 
	dmacss 	x1,y1,a 
	asl		#24,a,a 
	rnd		b 
	move		b1,a0 
	asr		a		 ;  supprimer pour une commande fractionnaire NON signe (0 .. FFFFFF) 

	rnd		a 
  	move  	a,x:data_i2c1 
  	move 		#$844346,a1
  	move 		a1,x:ctrl_i2c1

    stx	sdr_rx_hf_freqm
;	flagset 	sdr_rx_w 
;	bra		sdr_rx_end

;sdr_rx_wf  
;  	move  x:stat_i2c1,a1 	; attente de l'envoi de la cde 
;  	brset	#5,a1,sdr_rx_end	; si status[5] = 1, attendre encore  

;	flagclr sdr_rx_w		; sinon, raz flag, terminer
;  	move  #$000100,a1		;  
;  	move 	a1,x:ctrl_i2c1 
sdr_rx_end

	u	a
	u	b
	u	x
	u	y
  u r0
  u r1	

	endm

