;; Codec tlv320aic23 carte didalab
;; connect sur ESAI1 du processeur 1
;; SCKL = HCKT(pc5)  ;  BCLK = SCKT(pc3) ; LRC = FST pc(4)
;; DIN  = SDO2 (sdi3) pc9
;; DOUT = SDI2 (sdo3) pc8

;; SPI
;; CSN  pc1
;; CLK  pc0
;; SDIN pc2

codec	macro	fs,input
; registres (X:)
; saicr	set	$ffffB4
; saisr	set	$ffffB3
; tccr	set	$ffffB6
; tcr		set	$ffffB5
; rccr	set	$ffffB8
; rcr		set	$ffffB7
; tx2		set	$ffffA2
; rx2		set	$ffffAA
; tsr		set	$ffffA6

pcrc0	set	$FFFFBF
prrc0	set	$FFFFBE
pdrc0	set	$FFFFBD


	var	esai_error
; if !@def(in_l)
;
; endif
 if !@def(in_l)
	var		in_l,0    ;; 
 endif
 if !@def(in_r)
	var		in_r,0    ;; // var bidon pour voie inutilisee en entree micro
 endif
		
	var 		out_l_buf,0
	var 		out_r_buf,0
	
	section	inits
	
	movep   #$000007,x:pdrc0	; mettre 1 borne spi codec
val_pdrc0	set val_pdrc0|$000007
	movep	#$000338,x:pcrc0
val_pcrc0	set val_pcrc0|$000338
	movep	#$00033F,x:prrc0	; pins ESAI = 1 et 1
val_prrc0   set val_prrc0|$00033F	
;val_pdrh		set		val_pdrh|$080000	
	
	movep	#$080000,x:tcr		; reset TX
	movep	#$080000,x:rcr		; reset RX
	movep	#$000040,x:saicr	; sync
	
	move	#$001E00,a1			;reset Codec
	bsr		send_spi

	if ("input"=='line')
	move	#$000C22,a1			;power on,clk,out,dac, adc line
	else
	move	#$000C21,a1			;power on,clk,out,dac, adc mi
	endif
	bsr		send_spi

	move	#$000E0A,a1			;I2S format 24 bits
	bsr		send_spi

	move	#$001201,a1			; active digit interface
	bsr		send_spi
	
	move	#$000A01,a1			; DAPC=0
	bsr		send_spi
	
	move	#$0004f9,a1			; LHVP=0
	bsr		send_spi
	
	move	#$0006f9,a1			; RHVP=0 
	bsr		send_spi
	
	move	#$000017,a1			; Left Line input channel
	bsr		send_spi
	
	move	#$000217,a1			; Right Line input channel
	bsr		send_spi

	if ("input"=='line')
	move	#$000812,a1			; Analog Audio Path Control
	else
	move	#$000814,a1			; Analog Audio Path Control
	endif
	bsr		send_spi

 if fs==8
	move	#$00100C,a1		;  SRC=8kHz
	bsr		send_spi
	movep	#$EDC31F,x:tccr   ;  $EEC30F  FEC307
	movep	#$617904,x:tcr
	movep	#$617904,x:rcr
actual_fs	set	8000.
 endif
 if fs==32
	move	#$001018,a1		; SRC=32kHz
	bsr		send_spi
	move	#$000A02,a1			;Deemphasis
	bsr		send_spi
	movep	#$EDC307,x:tccr
	movep	#$617904,x:tcr
	movep	#$617904,x:rcr

actual_fs	set	32000.
 endif
 if fs==48
	move	#$001000,a1		;SRC=48kHz
	bsr		send_spi
	move	#$000E0E,a1			;I2S format 32 bits
	bsr		send_spi
	move	#$000A06,a1			;Deemphasis
	bsr		send_spi

	movep	#$ECC307,x:tccr
	movep	#$617D04,x:tcr
	movep	#$B17D04,x:rcr
actual_fs	set	48000.
 endif
 if fs==96
	move	#$00101C,a1		; SRC=96kHz
	bsr		send_spi
	move	#$000E0E,a1			;I2S format 32 bits
	bsr		send_spi
	movep	#$EC4307,x:tccr
	movep	#$EC4307,x:rccr
	movep	#$617D04,x:tcr
	movep	#$617D04,x:rcr

actual_fs	set	96000.
 endif

	movep	#0,x:tx2
val_iprp0 	set	val_iprp0|$000003
val_sr0	set	val_sr0&$fffcff

codec_fs	set	actual_fs
 if core==0
core0_fs	set	actual_fs
 else
core1_fs	set	actual_fs
 endif

	nolist
	nolist
	msg	'>>> CODEC Fs=',@cvi(fs*1000),'Hz'
	msg	'>>> Available cycles per sample:',@cvi(fdsp/(fs*1000))
	list
	list

	endsec

	section	vectors global
	org	p:$30				; rx data
  if (@msp(in_r)==2)
	movep	x:rx2,y:in_r
  else 
	movep	x:rx2,x:in_r
  endif 
	org	p:$32				; rx even data
;	jsr	irqesairxv
 if ("input"=='line')
  if (@msp(in_l)==2)
	movep	x:rx2,y:in_l
  else
	movep	x:rx2,x:in_l
  endif
 else
  if (@msp(mic)==2)
	movep	x:rx2,y:mic
  else
	movep	x:rx2,x:mic
  endif	
 endif
	org	p:$34				; rx data with except
	jsr	irqesairxe

	org	p:$36				; rx last slot
	jsr	irqesairxl

	org	p:$38				; tx data
	jsr	irqesaitx

	org	p:$3A				; tx even data
;	jsr	irqesaitxv
	movep	x:out_l_buf,x:tx2

	org	p:$3C				; tx data with except
	jsr	irqesaitxe

	org	p:$3E				; Tx last slot
	jsr	irqesaitxl

	endsec

	section	irq
	global  irqesairxe,irqesairx,irqesairxv,irqesairxl,irqesaitxe,irqesaitx,irqesaitxv,irqesaitxl
irqesairxe
	movep	x:saisr,x:esai_error
	movep	x:rx2,x:esai_error
	rti

irqesairx
 if @msp(in_r)==2
	movep	x:rx2,y:in_r
 else 
	movep	x:rx2,x:in_r
 endif

	rti

irqesairxv
 if ("input"=='line')
  if (@msp(in_l)==2)
	movep	x:rx2,y:in_l
  else
	movep	x:rx2,x:in_l
  endif
 else
  if (@msp(mic)==2)
	movep	x:rx2,y:mic
  else
	movep	x:rx2,x:mic
  endif
 endif

	rti

irqesairxl
 if @msp(in_r)==2
	movep	x:rx2,y:in_r
 else 
	movep	x:rx2,x:in_r
 endif

	rti

irqesaitxe
	movep	x:saisr,x:esai_error
	movep	#0,x:tx2
	rti

irqesaitx
	movep	x:out_r_buf,x:tx2
 	flagset codecdone
	rti

irqesaitxv
	movep	x:out_l_buf,x:tx2
	rti

irqesaitxl
	flagset	codecdone
	rti

	endsec


	org	p:
 if @def(out_l)
	lda	out_l
	neg	a
	sta	out_l_buf
 endif

 if @def(out_r)
	lda	out_r
	neg	a
	sta	out_r_buf
 endif

wait_codec
	jcnf	codecdone,wait_codec


	section	routines
	global send_spi
	org	p:
	
send_spi
	bclr	#1,x:pdrc0   ;; csn low
send_spi0
	do		#16,fin_spi
	bclr	#0,x:pdrc0		;; clk low
	rep		#5
	nop	
	jclr	#15,a1,send_spi1
	bset	#2,x:pdrc0		;; data low
	jmp		send_spi2
send_spi1
	bclr	#2,x:pdrc0		;; data high
send_spi2
	rep		#5
	nop
	bset	#0,x:pdrc0		;; clk high
	asl		#1,a,a
	rep		#10
	nop
fin_spi
	bset	#1,x:pdrc0  ;; CSN high
	movep	#$000007,x:pdrc0
	rts	
	endsec

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 24/09/2013

