;; Complex Argument  y = (1/pi)atan2(z_im,z_re) 
;; Syntax:	  arg	name
;; Arg(complex input) = [-pi..+pi[ => Output = [-1.0 .. +1.0[
;; Input: name_in, complex       Output: name, real
;;


arg	macro	name

	if	!@def(tbl_atan)
	section data global
	org	y:
tbl_atan

atan\_pt	set	0.0

; 0..1 arctg table here
	nolist
	dup	15
	dc	@atn(atan\_pt)/pi
atan\_pt	set	atan\_pt+1./15.
	endm
	dc	0.25
tbl_atan_segmts 	set	15
tbl_atan_size		set	16
	endsec
	list
	endif


	org	p:
	cc_rst
name\_exe

	org	p:
	if	!rgin
	lda	name\_in_re
	ldb	name\_in_im
	endif

	tst	a
	bmi	<name\_2
name\_1	tst	b	
	bmi	<name\_5
name\_6	bsr	<name\_atn
	bra	<name\_end
name\_5	abs	b
	bsr	<name\_atn
	neg	a
	bra	<name\_end
name\_2	abs	a
	tst	b
	bmi	name\_3
name\_4	bsr	<name\_atn
	add	#-1.0,a
	neg	a
	bra	<name\_end
name\_3	abs	b
	bsr	<name\_atn
	add	#-1.0,a
	bra	<name\_end

name\_atn 	cmp	b,a
	bge	<name\_at1
	move	b,x0
	move	a,b
	bsr	<name\_at2
	neg	a
	add	#0.5,a
	rts
name\_at1	move	a,x0
name\_at2	andi	#$fe,ccr
	do	#24,name\_at3
	div	x0,b
name\_at3
	move	b0,a

	regin 
name\_t_accu	set	1
	tblrd	name\_t,tbl_atan,u
	rts

name\_end	sta	name

	u	a
	u	b
	u	r0
	u	x
	varin

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


