;; CNORM Norm a complex variable   z = x / ||x||
;; Syntax:	cnorm	name
;; Transforms a complex signal A(t)*exp(jwt+phi) into exp(jwt+phi) 
;; Input: name_in complex    Output: name complex


cnorm	macro	name

	if	!@def(tab_invsqt)
	section far global
invsqt_points	set	17	; multiple de 8 + 1
	org	y:
tab_invsqt
; Inverse square root
	nolist
	dup	((invsqt_points-1)/8)+1
	dc	$7fffff
	endm
invsqt_dxpos	set	1./@cvf(invsqt_points-1)
invsqt_xpos	set	0.125
	
	dup	(7*(invsqt_points-1)/8)
invsqt_xpos	set	invsqt_xpos+invsqt_dxpos
	dc	@pow(2.,-1.5)/@sqt(invsqt_xpos)
	endm

tab_invsqt_segmts set	invsqt_points-1
tab_invsqt_size   set	invsqt_points
	endsec
	list
	endif


name\_exe
	lda	name\_in_re
	ldb	name\_in_im
	cmpm	b,a
	blt	<name\_1
	clb	a,b
	move	b1,x0
	ldb	name\_in_im
	bra	<name\_2
name\_1
	clb	b,a
	move	a1,x0
	lda	name\_in_re
name\_2
	normf	x0,a
	normf	x0,b
	move	a,x0
	mpy	x0,x0,a		b,y0
	mac	y0,y0,a		x0,r1
	asr	a		y0,n1
	regin
	dbgdisa
name\_t_accu	set	1
	tblrd	name\_t,tab_invsqt,u

	move	a,y0
	move	r1,x0
	mpyr	x0,y0,a
	asl	a
	move	n1,x1
	mpyr	x1,y0,b
	asl	b

	sta	name\_re
	stb	name\_im
	varin	

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


