;; CPLL complex phase locked loop
;; Syntax:	cpll	name,frequency_gain,phase_gain
;; Input: name_in (complex) Outputs: name_vco, name_freq
;; Needs a phase-quadrature complex input signal exp(jwt)
;; Note: a Hilbert block can be used to transform a real signal into complex
;; JMO rev 31/10/2005
;; cpll.bmp

cpll	macro	name,gf,gp

	varc	name\_vco
	varc	name\_m

	cn	name\_in,name\_m_in1
	cn	name\_vco,name\_m_in2
	cn	name\_m,name\_d_in
	cn	name\_d,name\_e_in1
	cn	name\_m_im,name\_e_in2
	cn	name\_e,name\_freq_in
	cn	name\_freq,name\_vco_freq

	dbgdisa
	g_sincos 	name\_vco,0,rel
	mulcc		name\_m
	discri	name\_d
	wsum2		name\_e,gf,gp
	integ		name\_freq,0.99999
	dbgena
	dbgw		CPLL
	dbg		name\_in_re
	dbg		name\_in_im
	dbg		name\_vco_re
	dbg		name\_vco_im
	dbg		name\_freq



	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 31/10/2005

