;; Fixed or variable, real or complex delay 0..N samples       y(k) = x(k-n)  n = 0 .. N
;; Syntax:	delay	name,del,unit        del = constant delay or maximum variable delay 
;; If unit = 'rel', then del is in samples; name_del is an integer and del is an upper boudary    
;; if unit='sec', then del is in seconds, and name_del is a real, 0 .. 1.0 corresponding to 0..del
;; Input: name_in, Output: name, Optional input: name_del (variable delay if optional input connected)



delay	macro	name,del,unit
 if	("unit"=='abs')||("unit"=='sec')
name\_pts set	@cvi(actual_fs*del)
 else
name\_pts set	del
 endif

 if	name\_pts>=2
  if @def(name\_im)
	bufm	name\_buf,l,name\_pts+1
  else
	bufm	name\_buf,y,name\_pts+1
  endif	
 else
  if	@def(name\_im)
	varc	name\_s,0
  else
	var	name\_s,0
  endif
 endif

	org	p:

	section	inits
	clr	a			; Init ncessaire pour apps style Moyenne Glissante rcursive 
	move	#name\_buf,r0
	move	#-1,m0
	move	#name\_pts,n0
	rep	n0
 if	@msp(name\_buf)==3
	move	a,l:(r0)+
 else
	move	a,y:(r0)+
 endif
	endsec




name\_exe
 if	name\_pts==1
  if @def(name\_im)
	lda	name\_in_re
	ldb	name\_in_im
	ldx0	name\_s_re
	ldx1	name\_s_im
	sta	name\_s_re
	move	x0,a
	move	x1,b
	sta	name\_re
	stb	name\_im
	u	a
	u	b
	u	x
  else
	lda	name\_in
	ldx0	name\_s
	sta	name\_s
	move	x0,a
	sta	name
	u	a
	u	x
  endif
 else
	ptr	name,0,name\_buf,name\_pts,,

  if	!@def(name\_del)
   if @def(name\_im)
	lda	name\_in_re
	ldb	name\_in_im
	move	ab,l:(r0)+
	move	l:(r0),ab
	ptru	name
	sta	name\_re
	stb	name\_im
	u	a
	u	b
   else
	lda	name\_in
	move	a,y:(r0)+
	move	y:(r0),a
	ptru	name
	sta	name
	u	a
   endif
  else
   if	("unit"=='abs')||("unit"=='sec')
	ldx0	name\_del
	move	#>name\_pts,x1
	mpyr	-x0,x1,a
	move	a1,n0
   else
	lda	name\_del
	neg	a	ifne
	move	a1,n0
   endif
   if	@def(name\_im)
	lda	name\_in_re
	ldb	name\_in_im
	move	ab,l:(r0)	;
	move	l:(r0+n0),ab	;
	move	(r0)+
	ptru	name
	sta	name\_re
	stb	name\_im
	u	a
	u	b
	u	n0
   else
	lda	name\_in
	move	a,y:(r0)	;
	move	y:(r0+n0),a	;
	move	(r0)+
	ptru	name
	sta	name
	u	a
	u	n0
   endif
  endif
 endif
	endm		
		

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


