;; Derivator	y(k) = g.[x(k) - x(k-1)]   where g is a constant gain
;; Syntax: 	deriv	name,gain    
;; The actual derivate value in units/sec is obtained with g = actual_fs
;; For better noise performance see DERIVATE

deriv	macro	name,gain

 if	@msp(name\_in)==3
	vard	name\_m,0
	org	p:
	lda	name\_in
	ldx	name\_m
	sub	x,a	a,l:name\_m
 else
	var	name\_m,0
	org	p:
	lda	name\_in
	ldx0	name\_m
  if	@msp(name\_m)==1
	sub	x0,a	a,x:name\_m
  else
	sub	x0,a	a,y:name\_m
  endif
 endif

name\_rg set	@cel(@log(@abs(gain))/@log(2.))
name\_fr set	gain/@pow(2.0,name\_rg)

	asl	#@cvi(name\_rg),a,a
	
 if	name\_fr<1.0
	move	a,x0
	if	@msp(name)==3
	mpyi	#name\_fr,x0,a
	else
	mpyri	#name\_fr,x0,a
	endif
 endif
	sta	name

	dbgw	DERIV
	dbg	name\_in
	dbg	name

	u	a
	u	x

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


