;; complex frequency discriminator if x(k)= A.exp(j2pi.k.f/Fs)  then y(k) = A.Sin(2pi f/Fs)
;; Syntax:	discri	name
;; Complex input (sine-cosine); real output
;; signed frequency f magnitude should be <= to Fs/4 for monotonous operation
;; Amplitude amp should be = to 1.0 for best S/N ratio 


discri	macro	name

	varc	name\_inm,0,0,c


	ldx0	name\_in_re
	ldy0	name\_in_im
	ldx1	name\_inm_re
	ldy1	name\_inm_im

	mpy	x1,y0,a
	macr	-x0,y1,a

	stx0	name\_inm_re
	sty0	name\_inm_im
	
	sta	name

	dbgw	DISCRI
	dbg	name\_in_re
	dbg	name\_in_im
	dbg	name

	u	a
	u	x
	u	y

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


