;; Finite Impulse Response filter (convolution)  y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)
;; Syntax: 	fir	name,iresp
;; where 'iresp.asm' is a file containing coeffs h(n) in the form:   DC value,value,...
;; OR iresp and iresp_size are the location and size of an existing coeff table in Y: 
;; Input:	name_in 	Output: name


fir	macro	name,iresp

 if !@def(iresp)
	section	far	global
	org	y:
iresp\_sect set 3 
iresp
	include	"iresp"++'.asm'
iresp\_size set *-iresp
	endsec
 endif

	bufm	name\_states,x,iresp\_size

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,iresp\_size-1,,
	ptr	name\_c,4,iresp,-1,,	

	lda	name\_in
	move	a,x0
	clr	a		a,x:(r0)-	y:(r4)+,y0
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	sta	name

	ptru	name\_s


; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	r4
	endm		
		
		list		
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


