;; FIR filter with half size coefficient table  y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)  
;; Syntax: 	fir1	name,table[,se|so|ae|ao]
;; where 'table.asm' contains coeffs h(n) in the form:   DC value,value,... (left half only if saoe argument)
;; OR table and table_size are the location and size of an existing coeff table in Y:
;; optional argument se, so, ae, ao : s=symmetric a=antisymmetric, o=odd, e=even nb of points
;; Input:	name_in 	Output: name      Note: if "ao", then central coeff "0.0" added at end of table  JMO Rev 31/10/05 


fir1	macro	name,table,saoe

 if !@def(table)
	section	far	global
	org	y:
table
table\_sect	set	3
	include	"table"++'.asm'
table\_size	set	*-table 
	endsec
 endif

name\_size	set	table\_size

  if	"saoe"=='se'
name\_size	set	table\_size*2
  endif
  if	"saoe"=='so'
name\_size	set	table\_size*2-1
  endif
  if	"saoe"=='ae'
name\_size	set	table\_size*2
  endif
  if	"saoe"=='ao'
name\_size	set	table\_size*2+1
  endif

	bufm	name\_states,x,name\_size

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,name\_size-1,,
	ptr	name\_c,4,table,-1,,	
	lda	name\_in
	move	a,x0
	clr	a		x0,x:(r0)-	y:(r4)+,y0


 if	"saoe"=='se'
	do	#(name\_size-4)/2,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0
name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4),y0
	do	#name\_size/2,name\_2
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
name\_2
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	
 else
  if	"saoe"=='so'
	do	#(name\_size-3)/2,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0
name\_1
	do	#(name\_size+1)/2,name\_2
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
name\_2	
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif

  else
   if	"saoe"=='ae'
	do	#(name\_size-4)/2,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0
name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4),y0
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
	do	#(name\_size-2)/2,name\_2
	mac	-x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
name\_2
	if	@msp(name)==3
	mac	-x0,y0,a		(r0)+
	else
	macr	-x0,y0,a		(r0)+
	endif
	
   else
    if	"saoe"=='ao'
	do	#(name\_size-5)/2,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0
name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4),y0
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
	move			x:(r0)-,x0
	do	#(name\_size-3)/2,name\_2
	mac	-x0,y0,a	x:(r0)-,x0	y:(r4)-,y0
name\_2	
	if	@msp(name)==3
	mac	-x0,y0,a		(r0)+
	else
	macr	-x0,y0,a		(r0)+
	endif
    else
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
    endif
   endif
  endif
 endif

	sta	name

	ptru	name\_s

; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	m0
	u	r4
	u	m4
	endm		
		
		list		
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 18/09/2012

