;; Gaussian FIR filter +/- 3*sigma wide
;; Syntax:	firg	name,points
;; Performs h(t-NT/2) = k * exp(-t/2sig)   with k such as Sum(hi) = 1.0
;; Input name\_in	Output: name




firg	macro	name,points


	section	far	global
name\_n 	set -(points-1)/2
name\_s	set	0.
name\_d	set	@cvf(points-1)*@cvf(points-1)/18.

	dup	points
name\_h	set	@xpn(@cvf(-name\_n)*@cvf(name\_n)/name\_d)
name\_n	set	name\_n+1
name\_s	set	name\_s+name\_h
	endm
name\_n 	set -(points-1)/2
	org	y:
name\_coeffs
	dup	points
	dc	(@xpn(@cvf(-name\_n*name\_n)/name\_d))/name\_s
name\_n	set	name\_n+1
	endm
	endsec

	bufm	name\_states,x,points

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,points-1,,
	ptr	name\_c,4,name\_coeffs,-1,,	

	ldx0	name\_in

	clr	a	x0,x:(r0)-	y:(r4)+,y0
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	sta	name

	ptru	name\_s

; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	r4

	endm		
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


