;; Real exponential function           y = 2^(k*x)/2^k   
;; Syntax:	f_exp	name,k,points
;; Caution: y(0) is not 1 but 2^-k; k must be < to 64; points = table length    
;; Input:	name_in		Output:	name
;;

f_exp	macro	name,k,points
	cn	name,name\_t

	if	!@def(exp\points)
	section data global
	org	y:
exp\points\_p	set	0.0

exp\points
; 2^0 .. 2^-1 table here
	nolist
	dc	$7fffff
	dup	points-1
exp\points\_p	set	exp\points\_p-1/@cvf(points-1)
	dc	@pow(2,exp\points\_p)
	endm
exp\points\_segmts set	points-1
exp\points\_size	set	points
	endsec
	list
	endif


	org	p:
	cc_rst
name\_exe

	org	p:
	lda	name\_in
	asr	a	#0.5,x0
	sub	x0,a
	move	#>k/64.,x1
	move	a,x0
	mpy	-x0,x1,a
	asl	#8,a,a	; A = 2k(in-1)
	move	a2,b
	lsr	a	#0,a2
	move	#>points-1,x0
	move	#exp\points,r0
	cc_ac	1
	regin
	dbgdisa
	tblrd	name\_t,exp\points,u
	asr	b1,a,a
	sta	name
	dbgena

	u	a
	u	b
	u	r0
	u	x
	varin

	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


