; Pseudo random generator with uniform density between [-1..+1[  
; Syntax:	g_noise	name
; Algorithm executed: y(k) = [y(k-1) * 1664525 + 30399561] mod 2^32
; Output: name      Note: One single random generator is used for all created g_noise blocks  
;;

g_noise	macro	name

;; Random number generator routine
;; given first, because of internal global symbols

	if	!@def(g_random)	

	coef	random_alphal,$19660D
	coef	random_betah,$000001
	coef	random_betal,$CFDC49
	var	random_lsb,0
	var	random_msb,0	

	section	routines
	global	g_random

g_random
	ldx0		random_lsb
	ldx1		random_msb
	ldy0		random_alphal
	clr		b	#0,y1
	mpyuu		y0,x0,a
	move		a0,b0
	dmacsu 	x1,y0,a
	macsu		y1,x0,a
	move		a0,b1
	asr		b
	ldx1		random_betah
	ldx0		random_betal
	add		x,b
 	and		#$0000FF,b
	move		b0,x:random_lsb	; l
	move		b1,x:random_msb	; h
	rts
	
	endsec
	endif
	
; RT code:
	org	p:

	jsr	g_random
;	cc_add	19
;	lda	random_lsb
	tfr	b,a
	asl	#16,a,a
	move	a1,a
	sta	name

; End RT code

		
; Used registers for execution
	u	x
	u	y
	u	a
	u	b

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


