;; Pulse generator generates single or periodic pulses with amplitude 1.0
;; Syntax:	g_pulse	name,period
;; where period is the pulse repetition period in samples; period=0 generates a single pulse
;; Output: name      Note: with period=0, output is 1 at t=0, and g_pulse execution resets it to 0 


g_pulse	macro	name,period,unit

	section	inits
	move	#>$7FFFFF,a
	sta	name
	endsec

	if	period==0
	clr	a
	sta	name
	else
	org	p:
	timerp	name\_t,period,unit
	clr	a
	jcnf		name\_t,name\_1
	move		#>$7FFFFF,a
name\_1	sta	name
	endif
	u	a
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


