;; Frequency modulable Sawtooth signal generator
;; Syntax: 	g_saw	name,freq,abs|rel   freq is expressed in Hertz if "abs", or in fraction of Fs/2 if "rel"    
;; freq parameter can be overriden by connecting optional FM input [-1 ..+1[ --> [-Fs/2 .. +Fs/2[ 
;; Output: name   Optional FM input: name_freq    Note: Positive/negative frequency => positive/negative slope	 
;; 	 

g_saw	macro	name,freq,unit
	if ("unit"=='Hz')||("unit"=='abs')
name\_fr	set	freq*2.0/actual_fs
	else
name\_fr	set	freq
 endif

	org	p:
name\_exe


	if	!(rgin)

 if	@msp(name)==3
	coefd	name\_freq,name\_fr
 else
  if	(name\_fr<1e-3)
	vard	name\_int,0
	coefd	name\_freq,name\_fr
  else
	coef	name\_freq,name\_fr
  endif
 endif
	lda	name\_freq
	endif
   if  @msp(name)==3	
	ldx	name
	add	x,a
	sta10	name
   else
    if	@msp(name\_freq)==3
	ldx	name\_int
	add	x,a
	sta10	name\_int
    else
	ldx0	name
	add	x0,a
    endif
	sta1	name
   endif


 if	@def(name\_ov_b)
	bec	<name\_end
	flagset name\_ov
 endif
name\_end

	u	a
	u	x
	varin

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


