;; High pass 1st order    y(k) = (1-epsilon)y(k-1) + x(k) - x(k-1)
;; Syntax:	hp1	name,freq,abs|rel
;; freq is expressed in Hertz if "abs", or in fraction of Fs/2 if "rel"
;; Usually employed to suppress DC component
;; Input: name_in  Output: name (single or double precision)

hp1	macro	name,freq,unit
 if freq==0
	lda	name\_in
 else
  if	("unit"=='Hz')||("unit"=='abs')
name\_n set @cvi((-@log(2.*pi*freq/actual_fs)/@log(2.0))+0.5)
  else
name\_n set @cvi((-@log(pi*freq)/@log(2.0))+0.5)
  endif

	var	name\_lastin,0
  if	@msp(name)!=3
	vard	name\_lastout,0

	lda	name\_lastout
  else
	lda	name
  endif	
	asr	#name\_n,a,b
	sub	b,a	x:name\_lastin,b
	sub	b,a	
	ldb	name\_in
	add	b,a	b,x:name\_lastin
  if	@msp(name)!=3
	sta	name\_lastout
  endif
 endif
	sta	name
	u	a
	u	b
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use

