;; 2nd order real IIR section H(z) = (b0 + b1/z + b2/z) / (1 - a1/z -a2/z)
;; Syntax:	iir	name,b0,b1,b2,a1,a2
;; Coefficients absolute values should be < 2
;; Input: name_in     Output: name
;;

iir	macro	name,kb0,kb1,kb2,ka1,ka2


	var	name,0

	section	vars global
	org	x:
name\_states	dc	0,0,0
	endsec


;; H(z) exprime par:
;; ( b0 + b1.z^-1 + b2.z^-2 ) / ( 0,5 - a1.z^-1 - a2.z^-2 )
;;
	section	far global
	org	y:
name\_coefs
	dc	@frc(kb0/2.)		; b0/2
	dc	@frc(kb1/2.)		; b1/2
	dc	@frc(kb2/2.)		; b2/2
	dc	@frc(ka1/2.)		; a1/2
	dc	@frc(ka2/2.)		; a2/2
	endsec

	org	p:
name\_exe	
	cc_rst
	move	#name\_states,r0			; champ x
	move	#-1,m0
	move	#name\_coefs,r4			; champ y
	move	m0,m4
	if	rgin
	move	a,x0
	else
	ldx0	name\_in
	endif
	ldy1	name
	jsr	iir2d
	cc_add	11	
	sta	name
	cc_ac	1
	
	dbgw	IIR
	dbg	name\_in
	dbg	name


	if		!@def(iir2d)
	section		routines
	global		iir2d
		org	p:

iir2d						   			; x0 = input   y1 = prev output
 	move				y:(r4)+,y0		   	; y0= b0	
 	mpy	x0,y0,a		x:(r0),x1	y:(r4)+,y0 	; a=b0.xk  x1 = xk-1 y0=b1
 	mac	y0,x1,a		x0,x:(r0)+		   	; a+=b1.xk-1 , new xk-1
 	move				x:(r0),x0	y:(r4)+,y0 	; x0=xk-2  y0=b2  
 	mac	x0,y0,a		x1,x:(r0)+	y:(r4)+,y0 	; a+= b2.xk-2 , y0=a1, new xk-2
 	mac	y0,y1,a		x:(r0),x0	y:(r4)+,y0 	; a+= a1.yk-1  x0=yk-2 y0=a2
 	mac	x0,y0,a		y1,x:(r0)		   	; a+= a2.yk-2  new yk-2
 	asl	a
 	rts
	endsec
	endif



; Used registers for sample execution
	u	r0
	u	m0
	u	r4
	u	m4
	u	x
	u	y
	u	a

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


