;; Complex 1 pole bandpass filter y(k) = p*y(k-1) + (1-|p|)*x(k)   (p= the pole)
;; Syntax:	iirc1	name,freq,band,abs|rel
;; freq = resonance frequency expressed in Hertz if "abs", or in fraction of Fs/2 if "rel"; band = bandwidth at -3db
;; Input: name_in (complex)   Output: name  (complex)


iirc1	macro	name,freq,band,unit

;	varc	name,0,0,c

	if	("unit"=='Hz')||("unit"=='abs')

name\_ro	set	1.-(2.*band/actual_fs)
name\_alpha	set	freq*2./actual_fs
	else
name\_ro	set	1.-band
name\_alpha	set	freq
	endif

	coefc	name\_a1,name\_ro,name\_alpha,p
	coef	name\_b0,(1.0-name\_ro)

	org	p:

	ldx0	name\_in_re
	ldx1	name\_in_im
	ldy0	name\_b0
	mpy	x0,y0,a				; a = b0*in_re
	mpy	x1,y0,b

	ldx0	name\_re				;  x0=out_re
	ldx1	name\_im
	ldy0	name\_a1_re				; y0= p_re
	ldy1	name\_a1_im

	mac	x0,y0,a				; a+= p_re*out_re
	macr	-x1,y1,a				; a-=p_im*out_im	
	mac	x0,y1,b				; b+= p_re*out_im
	macr	x1,y0,b			
	sta	name\_re	
	stb	name\_im


	u	a
	u	b
	u	x
	u	y
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


