;; LMS adaptive FIR filter  y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)  e(k) = d(k) - y(k) H(k+1)= H(k) + ue(k).X(k) 
;; Syntax: 	lms	name,size,gain
;; name_in = input  name = output  name_desired = desired output
;; name_error = desired - out 
;;


lms	macro	name,size,gain


	var	name,0
	var	name\_error,0
	var	name\_scan_ir,0
	coef	name\_gain,gain

	bufm	name\_states,x,size

	section	far	global
	org	y:
	buffer	m,size+1
name\_coeffs	
	ds	size
	dc	-1.
	endbuf
	endsec

	section	inits
	move	#name\_coeffs,r0
	move	#-1,m0
	move	#size,n0
	clr	a
	rep	n0	
	move	a,y:(r0)+
	endsec


	org	p:
name\_exe
	ptr	name\_s,1,name\_states,size-1,,
	ptr	name\_c,4,name\_coeffs,size-1,2
	ptr	name\_rd,2,name\_coeffs,size,,	

	ldx0	name\_in

	clr	a		x0,x:(r1)-	y:(r4)+,y0
	do	m1,name\_1
	mac	x0,y0,a	x:(r1)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a	
	else
	macr	x0,y0,a	
	endif
	sta	name

	ldb	name\_desired
	sub	a,b
	stb	name\_error
	move	b,x1		; x1 = error
	ldx0	name\_gain
	mpy	x0,x1,a		
	move	a,x1		; x1 = g * error

	move			x:(r1)-,x0	y:(r4)+,a	; x0 = x(k)	a = h(0)   R1->x(k-1)  R4->h1

	do	m1,name\_2	
	macr	x0,x1,a	x:(r1)-,x0	y:(r4)-,y0 	; a+= x(k).e  x0=x(k-1) y0=h1 R1->x(k-2) R4->h0
	tfr	y0,a	 	a,y:(r4)+n4			; a-->h0   a=h1  R4->h2
name\_2
	macr	x0,x1,a		(r1)+
	move	a,y:-(r4)
	move	y:(r2)+,a
	sta	name\_scan_ir


	ptru	name\_s
	ptru	name\_rd	


; Used registers for sample execution
	u	x
	u	y
	u	a
	u	b
	u	r1
	u	r4
	u	r2
	endm		
		
	list		
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


