;; Double precision lowpass filter 1st Order yk = a*yk-1 + b*xk with  b = 2piFc / (1 + 2piFc) and a = 1-b
;; Syntax:	lp1	name,freq,abs|rel
;; Where freq is the cutoff frequency, abs: Fc in Hz  rel: Fc relative to Fs/2 
;; Input: name_in    Output: name
;; Note: cutoff frequency is approximate, precision is excellent. 

lp1	macro	name,fc,unit
	if	("unit"=='Hz')||("unit"=='abs')
name\_n	set	@cvi(@cel(-@log(6.28*fc/actual_fs)/@log(2.0)))
	else
name\_n	set	@cvi(@cel(-@log(6.28*fc)/@log(2.0)))
	endif

	if	@msp(name)!=3
	vard	name\_s,0
	endif

	org	p:
name\_exe
	lda	name\_in

	if	@msp(name)==3
	ldb	name
	else
	ldb	name\_s
	endif

	sub	b,a		; A = in-out
	asr	#name\_n,a,a	; A = (in-out)/2^n
	add	b,a		; A = out + (in-out)/2^n

	if	@msp(name)!=3
 	sta	name\_s
	endif

	sta	name		; out(k+1) = " "

	u	a
	u	b

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


