;; Matrix multiply
;; Syntax:	matmul	name
;; Inputs: name_in1 (m,n), name_in2 (n,p) Output: name (m,p)
;; Result is complex if at least one input matrix has values in L: field 
;; Types FRACT or COMPLEX or mixed

matmul	macro	name
;; Test connections and dimensions
 if @def(name\_in1)
  if @def(name\_in2)
   if @def(name)
    if name\_in1_col==name\_in2_lin
     if name\_lin==name\_in1_lin
      if name\_col==name\_in2_col

;; Everything ok, create exec code  (Nlin,Mcol) x (Mlin,Pcol) --> (Nlin,Pcol)
;; NB: Matrix in memory is      name --> lin0:lin1:..:lin(n-1)
;;
	org	p:
name\_exe
	move	#name\_in1,r0		; r0,r1 --> in_mat1
	move	#name\_in1_col,n0		; n0 = M
	move	#name\_in1_lin,n1		; n1 = N
	move	#name\_in2,n4		; n4,r4,r5 --> in_mat2
	move	#name\_in2_col,n5		; n5 = P
	move	#name,r6			; r6 --> out_mat
	move	#name\_in2_col,n6		; n6 = P

	move	#-1,m0
	move	m0,m1
	move	m0,m4
	move	m0,m5
	move	m0,m6

 if name\_in1_lin>1
	do	n1,name\_3
 endif
		move				r0,r1
		move				n4,r4
 if name\_in2_col>1
		do	n6,name\_2
 endif
			move		r4,r5


 if (@msp(name\_in1)==1)&&(@msp(name\_in2)==1)
			clr	a	x:(r5)+n5,y0
			move		x:(r1)+,x0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y0,a		x:(r1)+,x0
			move				x:(r5)+n5,y0
 endif

 if (@msp(name\_in1)==1)&&(@msp(name\_in2)==2)
			clr	a	y:(r5)+n5,y0
			move		x:(r1)+,x0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y0,a		x:(r1)+,x0	y:(r5)+n5,y0			
 endif

 if (@msp(name\_in1)==2)&&(@msp(name\_in2)==1)
			clr	a	x:(r5)+n5,x0
			move		y:(r1)+,y0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y0,a		x:(r5)+n5,x0		y:(r1)+,y0				
 endif

 if (@msp(name\_in1)==2)&&(@msp(name\_in2)==2)
			clr	a	y:(r5)+n5,y0
			move		y:(r1)+,x0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y0,a		y:(r1)+,x0
			move				y:(r5)+n5,y0
 endif


 if (@msp(name\_in1)==1)&&(@msp(name\_in2)==3)

			clr	a	l:(r5)+n5,y
			clr b	x:(r1)+,x0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y1,a	
			mac	x0,y0,b	x:(r1)+,x0
			move			l:(r5)+n5,y
 endif

 if (@msp(name\_in1)==2)&&(@msp(name\_in2)==3)

			clr	a	l:(r5)+n5,y
			clr b	y:(r1)+,x0
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x0,y1,a	
			mac	x0,y0,b	y:(r1)+,x0
			move			l:(r5)+n5,y
 endif


 if (@msp(name\_in1)==3)&&(@msp(name\_in2)==1)

			clr	a	x:(r5)+n5,y0
			clr b	l:(r1)+,x
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x1,y0,a	
			mac	x0,y0,b	l:(r1)+,x
			move			x:(r5)+n5,y0
 endif

 if (@msp(name\_in1)==3)&&(@msp(name\_in2)==2)

			clr	a	y:(r5)+n5,y0
			clr b	l:(r1)+,x
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x1,y0,a	
			mac	x0,y0,b	l:(r1)+,x
			move			y:(r5)+n5,y0
 endif


 if (@msp(name\_in1)==3)&&(@msp(name\_in2)==3)

			clr	a	l:(r5)+n5,y
			clr b	l:(r1)+,x
 	if name\_in1_col>1
			do	n0,name\_1
 	endif
			mac	x1,y1,a	
			mac	-x0,y0,a
			mac	x0,y1,b
			mac	x1,y0,b	l:(r1)+,x
			move			l:(r5)+n5,y
 endif


name\_1


 if (@msp(name\_in1)==3)||(@msp(name\_in2)==3)
		move		ab,l:(r6)+
 else
  if	 (@msp(name)==1)
		move		a,x:(r6)+
  else
   if  (@msp(name)==2)
		move		a,y:(r6)+
   else
		move		a,l:(r6)+
   endif
  endif
 endif	

		move	r0,r1
		move	(r4)+
name\_2
		move	(r0)+n0
name\_3


	u	r0
	u	n0
	u	r1
	u	n1
	u	r4
	u	r5
	u	n5
	u	r6
	u	n6
	u	a
	u	x
	u	y

	dbgw	MATMUL




;; Else, error messages  
      else
	fail "name",' output columns should be equal to ',"name",'_in2 columns !'
      endif 
     else
	fail "name",' output lines should be equal to ',"name",'_in1 lines !'
     endif 
    else
	fail "name",'_in1 columns should be equal to ',"name",'_in2 lines !'
    endif 
   else
	fail	'Matrix multiply output ',"name",'_in1 is not connected !'
   endif
  else
	fail	'Matrix multiply input 2 ',"name",'_in2 is not connected !'
  endif
 else
	fail	'Matrix multiply input 1 ',"name",'_in1 is not connected !'
 endif


	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


