;; Real polynomial function		y = k0 + k1*x + k2*x^2 + ...
;; Syntax:	poly   name,'filename'   If name_coeffs and name_ord already defined, use '' for 'filename'
;; Coeffs are polynomial coefficients in growing order (1,x,x,..) defined in Y: with DC k0,k1,k2, ...
;; Input: name_in   Output: name   Coefficient table name in Y: name_coeffs Size = name_ord
;; Coefficients may be defined in an external file 

poly	macro	name,file

	org	p:
name\_exe
	move	#name\_coeffs,r0

	ldx0	name\_in					; x0= input "x"

	move			y:(r0)+,a			; a=k0
	mpyr	x0,x0,b		y:(r0)+,y0			; b=x^2		y0=k1
	move	b,y1					; y1=x^2
	do	#name\_coeffs_size-1,name\_1			; p=0 .. 

	mac	x0,y0,a		y:(r0)+,y0			; a=a+x*k(1) 	y0=k2
	mpyr	x0,y1,b		b,x0			; b=x^3		x0=x^2
name\_1
	sta	name

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


