;; Software Single Shot Timer. 
;; Syntax:	timers	name,mode,retrig,duration,unit
;; mode hwb (high while busy) sets a flag on start, clears the flag at TO
;; mode hto (high on Timeout) sets a flag at Time Out
;;
;; JMO rev 21-4-09


timers		macro	name,mode,retrig,time,unit

 if ("unit"=='s')||("unit"=='sec')
	var	name\_cntr,@cvi(time*actual_fs)
	coef	name\_cnt,@cvi(time*actual_fs)	
 endif
 if ("unit"=='ms')||("unit"=='millisec')
	var	name\_cntr,@cvi(0.01*time*actual_fs)
	coef	name\_cnt,@cvi(0.01*time*actual_fs)	
 endif
 if ("unit"=='s')||("unit"=='microsec')
	var	name\_cntr,@cvi(1E-6*time*actual_fs)
	coef	name\_cnt,@cvi(1E-6*time*actual_fs)	
 endif

 if ("unit"=='smp')||("unit"=='samples') 
	var	name\_cntr,time
	coef	name\_cnt,time
 endif



		org	p:
 if "retrig"=='retrig'
		jnot		name\_start,name\_1
  if ("mode"=='hwb'|"mode"=='high_while_busy')
		flagset	name
  else
		flagclr	name
  endif
		lda		name\_cnt
		sta		name\_cntr
		bra		<name\_2
name\_1		
		lda		name\_cntr
		tst		a
		beq		<name\_2
		sub		#1,a
		sta		name\_cntr
		bne		name\_2
  if "mode"=='hwb'
		flagclr		name
  else
		flagset		name
  endif
name\_2



 else
exec_\name	lda		name\_cntr
		tst		a
		beq		name\_0

		sub		#1,a
		sta		name\_cntr
		bgt		<name\_1
  if "mode"=='hwb'
		flagclr	name
  else
		flagset	name
  endif

name\_0	jcnf		name\_start,name\_2
  if "mode"=='hwb'
		flagset	name
  endif
		lda		name\_cnt
name\_1	sta		name\_cntr
name\_2
 endif



		section	inits
		org		p:
		clr		a
		sta		name\_cntr
		flagclr	name
		endsec


		u	a

   endm				

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


