;; Weighted sum of 3 inputs
;; wsum2 name,g1,g2,g3
;; name_in1, name_in2, name_in3 = inputs
;; name = output = g1*name_in1 + g2*name_in2 + g3*name_in3


wsum3 	macro	name,g1,g2,g3	
name\_rg1	set	0
name\_rg2	set	0
name\_rg3	set	0
 if	(@abs(g1)>1.0)
name\_rg1	set		@cvi(@cel(@log(@abs(g1))/@log(2.)))
 endif
 if	(@abs(g2)>1.0)
name\_rg2	set		@cvi(@cel(@log(@abs(g2))/@log(2.)))
 endif
 if	(@abs(g3)>1.0)
name\_rg3	set		@cvi(@cel(@log(@abs(g3))/@log(2.)))
 endif
name\_sh	set	@cvi(@max(name\_rg1,name\_rg2,name\_rg3))

 if (name\_sh>0)
name\_fr1	set   g1/@pow(2.0,name\_sh)
name\_fr2	set   g2/@pow(2.0,name\_sh)
name\_fr3	set   g3/@pow(2.0,name\_sh)
	coef	name\_k1,name\_fr1
	coef	name\_k2,name\_fr2
	coef	name\_k3,name\_fr3

	ldx0	name\_in1
	ldx1	name\_k1
  if	@msp(name\_in2)==2
	mpy	x0,x1,a	y:name\_in2,x0
  else
	mpy	x0,x1,a	x:name\_in2,x0
  endif
	ldx1	name\_k2

  if	@msp(name\_in3)==2
	mac	x0,x1,a	y:name\_in3,x0
  else
	mac	x0,x1,a	x:name\_in3,x0
  endif
	ldx1	name\_k3
	mac	x0,x1,a

  if	name\_sh==1
	asl	a
  else
	asl	#name\_sh,a,a
  endif
 else


	if	@abs(g1)!=1.0
	coef	name\_g1,g1
	endif
	if	@abs(g2)!=1.0
	coef	name\_g2,g2
	endif
	if	@abs(g3)!=1.0
	coef	name\_g3,g3
	endif
	

	org	p:

	if	@abs(g1)==1.0
		lda	name\_in1
		ldx0	name\_in2
		if	g1<0.
			neg	a
		endif
	else
		ldx0	name\_in1	
		ldx1	name\_g1
		mpy	x0,x1,a
		ldx0	name\_in2	
	endif	

	if	g2==1.0
		add	x0,a
		ldx0	name\_in3
	endif
	
	if	g2==-1.0	
		sub	x0,a
		ldx0	name\_in3
	endif
	
	if	@abs(g2)!=1.0
		ldx1	name\_g2
		macr	x0,x1,a
		ldx0	name\_in3
	endif
	
	if	g3==1.0
		add	x0,a
	endif
	
	if	g3==-1.0	
		sub	x0,a
	endif
	
	if	@abs(g3)!=1.0
		ldx1	name\_g3
		macr	x0,x1,a
	endif
 endif	
	sta	name


	u	a
	u	x

	endm
	
	list
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


