;; Repetitive signal accumulate    do N times x(n,k)= x(n,k-1) + (1/N)*in(n)
;; Syntax:	   accum	name,points,nbacc
;; name_in = data input   name_scan = scope ouput (periodic buffer scan with -1 sync pulse)
;; name_sync = true starts one frame accumulation
;; name_start = true resets the buffer and frame counter
;; name_buf is the N points accumulate buffer in L:
;; 

accum	macro	name,points,nbacc

	bufm	name\_buf,l,points+2
	var	name\_cacc,nbacc
	var	name\_cpoints,0

	section inits
	org	p:
	move	#-1.,a
	move	a,l:name\_buf+points
	move	a,l:name\_buf+points+1
	flagset	name\_start
	endsec



name\_exe	
	jcnf	name\_start,name\_0 
	move	#name\_buf,r0
	move	#-1,m0
	move	#nbacc,a1
	sta1	name\_cacc
	clr	a
	move	#>points,x0
	rep	x0
	move	a,l:(r0)+
	flagset	name\_accon
name\_0
	ptr	name\_wp,1,name\_buf,-1,0

	jnot	name\_sync,name\_1
	move	#name\_buf,r1
	move	#points,a1
	sta1	name\_cpoints
	lda	name\_cacc
	sub	#1,a
	sta	name\_cacc
	bne	<name\_1
	flagclr	name\_accon
name\_1
	jnf	name\_accon,name\_3
	lda	name\_cpoints
	tst	a
	beq	<name\_3
	sub	#1,a
	sta	name\_cpoints
name\_2
	ldx0	name\_in
	move	#>1./@cvf(nbacc),x1
	move	l:(r1),a
	mac	x0,x1,a
	move	a,l:(r1)+
	ptru	name\_wp
name\_3
	ptr	name\_rp,2,name\_buf,points+1,0
	move	l:(r2)+,a
	sta	name\_scan
	ptru	name\_rp


	u	a
	u	x
	u	r1
	u	r2

	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


