;; CODR_8_24 Octal Redundant 3 coder 
;; Transforms a 8 bit input to 24 bit output where:
;; bit [i] --> bit[i](k): bit[i](k-delay) : bit[i](k-2*delay)
;; i = 0 .. 7

codr_8_24	macro	name,delay
	bufm	name\_buf,y,2*delay
	jnot	name\_ck,name\_end
	ptr	name\_p,1,name\_buf,2*delay-1,-delay
	move	#>1,x0
	clr	b	y:(r1),a	; A = sym(k-2D) 
	do	#8,name\_1
	lsl	#3,b
	lsl	a
	or	x0,b	ifcs
name\_1
	move	y:(r1+n1),a
	move	#>2,x0
	move	b1,b0
	do	#8,name\_2
	asl	#3,b,b
	lsl	a
	or	x0,b	ifcs
name\_2
	lda	name\_in
	move	a,y:(r1)+
	ptru	name\_p
	move	b1,b0
	move	#>4,x0
	do	#8,name\_3
	asl	#3,b,b
	lsl	a
	or	x0,b	ifcs
name\_3
	stb1	name
name\_end
	u	a
	u	b	
	u	x
	u	r1
	u	n1
	endm 

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


