;; View cross-correlation function:
;; Syntax: correl	name,points,epsi,c|nc
;; if causal ('c'), input in2 should be delayed relative to in1 (0..N)

;; if non causal('nc'): in2 -->[ in2_delay (N/2)]
;; input in2 may be late or early versus in1 (-N/2 .. +N/2)

;; in2 -->[ in2_delay (0..N-1)    ]
;; Corr   [         N pts         ]+ sync
;;
;; Corr(n,k) = (1-epsi)*Corr(n,k-1) + epsi*in1d(k)*in2d(k)[n]
;; Sweep Corr(n,k) n=-N/2 .. N/2-1

correl	macro   name,points,epsi,cnc
	var	name,0
	if	@def(name\_maxpos)+@def(name\_max)
	var	name\_max,-1.
	var	name\_maxpos
	endif

	section far	global
	org	y:
	buffer	m,points+2
name\_corr ds	points
	dc	-1.,-1.	; synchro
	endbuf
name\_corr_size set points
name\_corr_col set 1
	endsec

	bufm	name\_dl2,x,points

	section	inits
	org	p:
	move	#name\_corr,r0
	move	#-1,m0
	clr	a
	rep	#points
	move	a,y:(r0)+

	move	#name\_dl2,r0
	rep	#points
	move	a,x:(r0)+
	endsec

	dbgdisa

	org	p:
name\_exe
	if	("cnc"=='nc')|("cnc"=='non_causal')
	var	name\_dl1
	cn	name\_in2,name\_dl1_in
	delay	name\_dl1,points/2
	ldx0	name\_dl1
	else
	ldx0	name\_in2
	endif

	ptr	name\_dl2,1,name\_dl2,points-1,,
	ldx1	name\_in1
	move	x1,x:-(r1)
	ptru	name\_dl2
	move	#name\_corr,r4
	move	#-1,m4
	move	#>epsi,x1
	move	x:(r1)+,y0

	do	#points,name\_1
	mpyr	x0,y0,a			y:(r4),y0
	sub	y0,a		y0,b
	move			a,y0
	mac	x1,y0,b		x:(r1)+,y0
	move	b,y:(r4)+
name\_1

	ptr	name\_pt,1,name\_corr,points+1,,
	move	y:(r1)+,a
	sta	name\_scan
	move	r1,a
	cmp	#name\_corr,a
	bne	<name\_1a
	flagset	scope_sync
name\_1a
	ptru	name\_pt

	if	@def(name\_maxpos)+@def(name\_max)

	move	#name\_corr,r1
	move	#-1.,a
	move	y:(r1)+,x0
	do	#points,name\_2
	cmp	x0,a
	tlt	x0,a	r1,r0
	move	y:(r1)+,x0
name\_2
	sta	name\_max
	move	r0,a
	sub	#name\_corr+1,a
	sta1	name\_maxpos

	endif

	u	a
	u	b
	u	x
	u	r0
	u	r1

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


