;; Event counter
;; Increments on name_clk TRUE or on each sample if name_clk disconnected
;; Name_end is asserted whenever count reaches maxi (or connected max value if connection exists)
;; Counter will not increment beyond maxi 
;; When name_clr is true, the counter is reset to 0 on next clk

counter	macro	name,maxi
	section	inits
	clr	a
	sta	name
	endsec

 if !@def(name\_max)
	coef	name\_max,maxi
 endif

 if @def(name\_rdy_b)
	flagrst name\_rdy
 endif

 if @def(name\_clr_b)
	jnot	name\_clr,name\_1
	clr	a
	sta1	name
name\_1
 endif
 
  if @def(name\_clk_b)
	jnot	name\_clk,name\_4
  endif	
	lda	name
	add	#1,a
 if @def(name\_sclr_b)
	jnot	name\_sclr,name\_2
	clr	a
name\_2
 endif

	sta1	name

 if @def(name\_end_b)
	flagrst	name\_end
	ldx0	name\_max
	cmp	x0,a
	blt	name\_3	
	flagset name\_end
name\_3 
 endif

 if @def(name\_rdy_b)
	flagset name\_rdy
 endif
name\_4
	u	a
	u	x


	endm

	


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


