;; Decibel/200 function         y = 0.05*Log10(x)
;; Syntax:	decibel	name, range  
;; input:	name_in   (real or double, positive)
;; output:	name      (real, negative)
;;

decibel	macro	name,range,offset	

	if	!@def(lg2coef)
	section	data	global
	org	y:	

;; approx log2(x) par poly dy 5eme ordre MatLab POLYFIT

lg2coef dc	-0.236856,0.631994,-0.875888,0.800231,-0.406756,0.087275

;NB: coeffs de x^0 a x^5    (a multiplier par 16)
	endsec
	endif
	
	org	p:
name\_exec
	cc_rst
	if	!rgin
	lda	name\_in
	endif
 if	@msp(name\_in)==3
	tst	a
 else	
	cmp	#$000001,a
 endif	
	bgt	name\_1
	move	#-1.0,a
	bra	<name\_2
name\_1
;//	jsr	fdecibl
; dB = 10 log(2).lg2(x)
; dB/range = 10 x 0.30103 x lg2(x)/range  = lg2(x)*3.0103/range
name\_rg	set		@cvi(@cel(@log(@abs(64*3.0103/range))/@log(2.)))
name\_fr	set		(64*3.0103/range)/@pow(2.0,name\_rg)

	bsr	flog2
	asr	#6,a,a
	move	a,x0
	move	#>name\_fr,x1
	mpy	x0,x1,a
 if   name\_rg>0
	asl	#name\_rg,a,a
 endif
 if	name\_rg<0
	asr	#name\_rg,a,a
 endif
	
; if @arg(offset)
  if offset!=0
	coefd name\_off,offset/range
	ldx	name\_off
	add	x,a
  endif 
; endif 
name\_2	
	sta	name


	section	routines
	org	p:
	if	!@def(flog2)
	global	flog2
; dB = 10 log(2).lg2(x)
; dB/200 = 10 x 0.30103 x 0.32 lg2(x)/64  = 0.96330 . lg2(x) / 64

;fdecibl	bsr	<flog2
;	asr	#6,a,a		; div /64 pour que |A| < 1
	
;	move	a,x0
;	mpyi	#0.96330,x0,a	; 0dB --> a = 0  -200dB --> a = -1
;	asl	a		; 0..-100 dB
;	rts
;	endif

;	if	!@def(flog2)
	global	flog2
	
flog2	move	#lg2coef,r0
	move	#-1,m0
	clb	a,b
	normf	b1,a
	move	a,x0
	move	b1,n0

	move	y:(r0)+,a			; a = k0
	mpyr	x0,x0,b		y:(r0)+,y1	; b = x^2	y1 = k1	

	mac	x0,y1,a b,x1	y:(r0)+,y1 	; a = a+k1.x  y1 = k2 x1=x^2 
	mpyr	x0,x1,b		b,y0		; b = x^3	y0 = x^2

	mac	y0,y1,a		y:(r0)+,y1	; a = a+k2.x^2  y1 = k3
	mpyr	y0,y0,b		b,x1		; b = x^4	x1 = x^3

	mac	x1,y1,a		y:(r0)+,y1	; a = a+k3.x^3  y1 = k4
	mpyr	x1,y0,b		b,x0		; b = x^5	x0 = x^4
	
	mac	x0,y1,a	b,x0	y:(r0)+,y1	; a = a+k4.x^4  y1 = k5	x0 = x^5
	mac	x0,y1,a		#0,b		; a = a+k5.x^5
	asl	#4,a,a				; a = 16a
	move	n0,b2				; n0 = fact. puissance de 2
	asr	b
	add	b,a	; a = log2(a initial) = -47 ... +8
	rts
	endif
	
	endsec

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


