;; decimation FIR filter with coefficient generation   y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)
;; Syntax:  fir2  name,N,flo,fhi,abs|rel    h(n) = w(n)*{Sin(2*pi*fhi*n)-sin(2*pi*flo*n)}/(pi*n)
;; where: N=number of taps; flo, fhi = bandpass edge freqs; abs= freqs in Hz, rel= freqs in Fs/2 
;; Input: name_in	Output: name
;; 

decimfir	macro	name,points,flo,fhi,ar,rate

	if	("ar"=='abs')|("ar"=='Hz')
fu	set	2*flo/actual_fs
fd	set	2*fhi/actual_fs
	else
fu	set	flo
fd	set	fhi
	endif


;; Coefficient table 
	section	far	global
	org	y:
name\_coeffs

inc1	set	2.0*pi/@cvf(points)
w0	set	0.35875
w1	set	0.48829
w2	set	0.14128
w3	set	0.01168

angle	set	0.0
num	set	(1.-@cvf(points))/2.

	dup	points
w	set	w0-w1*@cos(angle)+w2*@cos(2.0*angle)-w3*@cos(3.0*angle)
angle	set	angle+inc1

	if	num==0.
	dc	w*(fd-fu)
	else
	dc	w*(@Sin(pi*fd*num)-@Sin(pi*fu*num))/(pi*num)
	endif
num	set	num+1.0

	endm
	endsec



	bufm	name\_states,x,points

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,points-1,	
	ptr	name\_c,4,name\_coeffs,-1,	
	ldx0	name\_in
	move	x0,x:(r0)+
	timerp	name\_t,rate
	jcnf	name\_t,name\_2

	clr	a		y:(r4)+,y0
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	sta	name
name\_2
	ptru	name\_s
	

	dbgw	FIR2
	dbg	name\_in
	dbg	name
	

; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	m0
	u	r4
	u	m4

	endm		

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


