;; Linear (n,k) decoder
;; Syntax: 	decode	name,n,k,'h_mat.asm','s_tab.asm'
;; I/O = name_in, name (left justified)
;; input flag, output flag, error flag: name_in, name, name_error

decode	macro	name,n,k,h,s

	vard		name\_detected,0
	vecb		name\_in1,x,n
	vecb		name\_m,x,(n-k)

	cmatbc	name\_h,y,n,"h"
	cmatbl	name\_s,y,n,"s"


	cnm	name\_in1,name\_m_in1
	cnm	name\_h,name\_m_in2


	org	p:
	jnot		name\_ck,name\_2
	lda		name\_in
	lsr		#24-n,a
	sta1		name\_in1
	matmulb		name\_m,r
	ldr0		name\_m
	move		#-1,m0
	move		#name\_s,n0
	ldx0		name\_in1
	move		y:(r0+n0),a
	tst		a
	beq		name\_1
	flagset		name\_error
	ldb		name\_detected
	inc		b
	stb		name\_detected
name\_1
	eor		x0,a
	lsr		#n-k,a
	lsl		#24-k,a
	sta1		name
	flagset		name\_ready
name\_2
	endm



;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


