;; DECODR_24_8 Octal Redundant 3 decoder 
;; Inserts 2D, 1D, and 0 compensation delays 
;; Transforms 24 bit word to 8 bits by applying a vote on triplets 
;; Error optional output is TRUE if resulting triplets differ from 111 or 000

decodr_24_8	macro	name,delay
	bufm	name\_buf,y,2*delay
	section	data global
	org	y:
name\_tab
	dc	$000000,$000001,$000001,$800001,$000001,$800001,$800001,$800000
	endsec
	flagrst	name\_rdy
	jnot	name\_ck,name\_end
	ptr	name\_p,1,name\_buf,2*delay-1,-delay
	move	#>$924924,x0 ; 1001 0010 0100 ..

	move	y:(r1),b
	and	x0,b
	move	y:(r1+n1),a
	move	#>$492492,x0	; 010010010 .. 
	and	x0,a
	move	a1,x0
	or	x0,b 
	lda	name\_in
	move	a,y:(r1)+
	ptru	name\_p
	move	#>$249249,x0	; 001001001001 ...

	and	x0,a
	move	a1,x0
	or	x0,b 	; b1 should be 000 111 000 111 ...  

	move	#0,x0
 	do	#8,name\_1
	move	b1,a1
	and	#7,a
	add	#name\_tab,a
	move	a1,r0
	lsr	#3,b
	move	y:(r0),a
	bclr	#0,a1
	bcc	<name\_0
	flagset	name\_error
name\_0
	or	x0,a
	lsr	a
	move	a1,x0
name\_1
	move	x0,a
	lsl	a
	sta1	name
	flagset	name\_rdy
name\_end 	
	u	a
	u	b
	u	x
	u	r0
	u	r1	
	u	n1
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use




