;; Decimating Root Raised cosine FIR filter with coefficient generation   y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)
;; Syntax:  fir_rrc  name,N,bauds,alpha    
;; where: N=number of taps; bauds = transmission rate; alpha = [0 .. 1] = Rollof factor 0-> BW=Bauds/2 (SINC)  1-> BW=Bauds 
;; Input: name_in	Output: name

dfir_rrc	macro	name,points,decim,bauds,alpha

name\_fc	set	2*bauds/actual_fs


;; Coefficient table 
	section	far	global
	org	y:
name\_coeffs
name\_num	set	(1.-@cvf(points))/2.

	dup	points
name\_k set	name\_num*bauds/actual_fs
	dc	4*alpha*(@cos((1+alpha)*pi*name\_k)+@sin((1-alpha)*pi*name\_k)/(4*alpha*name\_k))/(pi*1.414*(1-(4*alpha*name\_k)*(4*alpha*name\_k)))
name\_num	set	name\_num+1.0
	endm
	endsec

name\_lng	equ	points+decim+1

	bufm	name\_states,x,name\_lng
	var	name\_ptr,name\_states

	section	irq
name\_irq
	ldr0	name\_ptr
	move	#name\_lng-1,m0
	ldx0	name\_in
	move	x0,x:(r0)+
	str0	name\_ptr
	u	r0
	u	x
	endsec 

	org	p:
name\_exe
	ldr0	name\_ptr
	move	#name\_lng-1,m0
	move	#points-1,n0	
	ptr	name\_c,4,name\_coeffs,-1,	
	ldx0	name\_in

	clr	a	x:(r0)-,x0	y:(r4)+,y0
	do	n0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a
	else
	macr	x0,y0,a
	endif
	sta	name

; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	n0
	u	r4
	endm		


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


