;; (Slow) Discrete Fourier Transform
;; X(n) = (1/N)Sigma(x(k)*exp(-j*2*pi*n*k/N)) k=0..N-1
;; Note 1/N calibration included

dft	macro	name
n	set		name\_in_size 	; Note: output size may be bigger to allow zero padding  

dftn		macro	name,n  		;; Embedded mac: astuce pour transformer n en chane
 if	!@def(dft_coeffs\?n)
; Sine-Cosine Table
		section	longfar	global	
angle	set	0.0
incr		set	2*pi/@cvf(n)
		org	l:
		buffer	m,n
dft_coeffs\?n
		dup	n
		dc	@lng(@frc(@cos(angle)),@frc(@sin(angle)))
angle	set	angle+incr
		endm
		endbuf		
		endsec
 endif

 if !@def(tempbuf)
	org	l:
tempbuf	dsm	n
 endif

 if @def(name\_busy_b)
	flagset	name\_busy
 endif
	move		#name\_in,r0	; mult by 1/N
	move		#n-1,m0
	move		#tempbuf,r4
	move		m0,m4
	move		#n,n0
	move		#1/@cvf(n),x0
	move		l:(r0)+,y
	do		n0,name\_0
	mpyr		x0,y1,a
	mpyr		x0,y0,b	l:(r0)+,y
	move				ab,l:(r4)+		
name\_0

;;	move		#dft_coeffs\?n,r4	; dft 
	move		m0,m4
	move		#0,r5
	move		#-1,m5
	move		#name,n5
	do		n0,name\_2
	move		#tempbuf,r0
	clr		a	#dft_coeffs\?n,r4
	clr		b	r5,n4
	move		y:(r4),y1	; y1=Sin Im 
	move		x:(r0),x0	; x0=Re
	move		y:(r0)+,y0	; y0=im
	move		x:(r4)+n4,x1 ; x1=Cos Re  
	do		n0,name\_1
	mac		x0,x1,a		; a=re*cos
	mac		y0,y1,a		; -im*-sin
	mac		-x0,y1,b		x:(r0),x0	y:(r4),y1 ; b=re*-sin
	mac		x1,y0,b		x:(r4)+n4,x1	y:(r0)+,y0 ; +im*cos
name\_1
	move		ab,l:(r5+n5)
	move		(r5)+
name\_2
 if @def(name\_busy_b)
	flagclr	name\_busy
 endif
	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0
	u	r4
	u	n4
	u	r5
	u	n5
	endm

	dftn		name,n

	endm

	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


