;; Sine function by polynomial approximation 
;; 

f_sinus	macro	name
name\_exe
	lda	name\_in
	jsr	fsinpix
	sta	name
	u	a
	u	b
	u	x
	u	y
	u	r0

	if	!@def(fsinpix)
	section far global
	org	y:
fsin_coeffs
 	dc	0.00000722		;x0		
 	dc	0.78509934		;x1
 	dc	0.00289228		;x2
	dc	-0.33391749	;x3
 	dc	0.01841413		;x4
 	dc	0.02751266		;x5
	endsec

	section	routines
	global	fsinpix

	org	p:
fsinpix
	move	#fsin_coeffs,r0			; R0 pointe coeff x0	
	move	#-1,m0				; adressage linaire	
	asl	a	a1,y1				; A=in*2      sauver le signe dans y1 
	move	a1,a					; provoquer dbordement si in>0.5   
	abs	a					; A = Triangle_positif(in)
	move	a,x0	y:(r0)+,a			; x0 =A=angle     Init A=coeff0 
	move	x0,x1					; Init  x1=x0=x   xn = x1
	do	#5,fsinpix1				; faire 5 fois jusque sin1
	mpyr	x0,x1,b	y:(r0)+,y0		; B = x1 * x = xn+1     y0 = coeff[n]
	mac	x1,y0,a	b,x1			; A += xn  * coeff[n]   x1 = B = xn+1
fsinpix1
	asl	a					; A * 2
	btst	#23,y1				; tester le bit de signe dans y1
	neg	a	ifcs				; changer le signe de A si y1<0					
	rts	
	endsec
	endif
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


