;; fft coefficient generation
;; generates a table of N complex coefficients 
;; cos(alpha) and sin(alpha) with alpha between [0 ... -pi[
;; JMO 3-11

fftcoeff	macro	name,n

name\_c	set	0
name\_f	set	pi/@cvf(n)

	org	l:
	buffer	r,n
name
	dup	n
name\_cos	set	@frc(-@cos(name\_f*@cvf(name\_c)))
name\_sin	set	@frc(-@sin(name\_f*@cvf(name\_c)))
	dc	@lng(name\_cos,name\_sin)
name\_c	set	name\_c+1
	endm
	endbuf

name\_size	equ	n
name\_lin	equ	n
name\_col	equ	1
name\_field	equ	3
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


