;; Multi stage cascade IIR
;; file coeffs contains n lines in the form:  DC n0,n1,n2,d1,d2
;; where n0, n1, n2 are the coefficients of z,z,1 in numerator, 1,d1,d2, the coeffs of z z,1 in denominator

filter macro name



	section 	far global

name\_sects equ name\_coeffs_size/5


	org	x:
name\_states
	ds	(name\_sects+1)*2
	endsec
 

	org	p:
	move	#name\_states,r0
	move	#name\_coeffs,r4
	move	#-1,m0
	move	m0,m4
	ori	#8,mr
 	ldx0	name\_in
	
	clr	a	x:(r0),x1	y:(r4)+,y0				; A=0 x1=ind  y0=b0
	mpy	x0,y0,a	x0,x:(r0)+	y:(r4)+,y0				; A = b0*in  in->ind y0=b1
	mac	x1,y0,a	x:(r0),x0	y:(r4)+,y0				; A+= b1*ind x0=indd y0=b2
	mac	x0,y0,a	x1,x:(r0)+	y:(r4)+,y0				; A+= b2*indd ind->indd y0=-a1 R0->outd
	move		x:(r0)+,x0					; x0=outd  R0-->outdd
	mac	-x0,y0,a	x:(r0),x1	y:(r4)+,y0				; A+= -a1*outd    x1=outdd   y0=a2
	macr	-x1,y0,a	x0,x:(r0)-					; A+= -a2*outdd   outd->outdd R0-->outd
	move		a,x:(r0)					; 2A --> outd

 if	name\_sects>1
	do	#name\_sects-1,name\_1
	clr	a	a,x0	y:(r4)+,y0				; A=0   x0=in[2]  y0=b0
	mpy	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0				; A = b0*in  x0=ind y0=b1
	mac	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0				; A+= b1*ind x0=indd y0=b2
	mac	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0				; A+= b2*indd x0=outd y0=-a1 R0->outd

	mac	-x0,y0,a	x:(r0),x1	y:(r4)+,y0				; A+= -a1*outd    x1=outdd   y0=a2
	macr	-x1,y0,a	x0,x:(r0)-					; A+= -a2*outdd   outd->outdd R0-->outd
	move		a,x:(r0)					; A->outd    R0--> states[2]
name\_1
 endif
	sta	name

	andi   #$f7,mr

	u	a
	u	x
	u	y
	u	r0
	u	r4
	endm



;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


