;; Resonant frequencies are regularily spaced in 
;; geometric sequence between Freq_low and Freq_High
;; Number of filters is determined by output array size

filter_bank	macro	name,flow,fhigh,gain
name\_m	set	fhigh/flow
name\_e	set	1./(name\_size-1)
name\_k	set	@pow(name\_m,name\_e)
name\_q	set	@sqt(name\_k)/(name\_k-1.0)
name\_f	set	flow
nmax	set	name\_size-1 

	buf	name\_states,x,3*name\_size

	section far global
	org	y:
name\_coeffs
	dup	name\_size 
name\_omega	set	2*pi*name\_f/actual_fs
name\_eps	set	pi*name\_f/(name\_q*actual_fs)
name\_r	set	1-name\_eps

	dc	0.5*name\_eps*gain 		; =b0 et b2   (b1=0)
	dc	name\_r*@cos(name\_omega) 	; =a1 				NB Coeffs/2 
	dc	-0.5*name\_r*name\_r 		; =a2
name\_f	set	name\_f*name\_k
	endm
	endsec

	org	p:

	move	#name\_states,r0		; champ x
	move	#-1,m0
	move	#name,r1			; output vector 
	move	m0,m1 
	move	#name\_coeffs,r4			; champ y
	move	m0,m4
	do	#name\_size,name\_1
	ldx0	name\_in						; x0 = xk
 if @msp(name)==2
	move	y:(r1),y1
 else 
	move	x:(r1),y1						; y1=yk-1
 endif 	
 	move				y:(r4)+,y0		  	; y0= b0	
 	mpy	x0,y0,a		x:(r0),x1		 	; a=b0.xk  x1 = xk-1 
 	move				x0,x:(r0)+		   	; new xk-1
 	move				x:(r0),x0			; x0=xk-2  y0=-b2  
 	mac	-x0,y0,a		x1,x:(r0)+	y:(r4)+,y0 	; a+= b2.xk-2 , y0=a1, new xk-2
 	mac	y0,y1,a		x:(r0),x0	y:(r4)+,y0 	; a+= a1.yk-1  x0=yk-2 y0=a2
 	mac	x0,y0,a		y1,x:(r0)+		  	; a+= a2.yk-2  new yk-2
 	asl	a
 if @msp(name)==2
	move	a,y:(r1)+
 else 
	move	a,x:(r1)+				
 endif
name\_1  	

	u	a
	u	x
	u	y
	u	r0
	u	r1 
	u	r4
	endm


