;; Root Raised cosine FIR filter with coefficient generation   y(k) = Sum{x(k-n)*h(n)} n = 0..(N-1)
;; Syntax:  fir_rrc  name,N,bauds,alpha    
;; where: N=number of taps; bauds = transmission rate; alpha = [0 .. 1] = Rollof factor 0-> BW=Bauds/2 (SINC)  1-> BW=Bauds 
;; Input: name_in	Output: name

fir_rrc	macro	name,points,bauds,alpha,gain

name\_fc	set	2*bauds/actual_fs


;; Coefficient table 
	section	far	global
	org	y:
name\_coeffs
name\_num	set	(1.-@cvf(points))/2.

	dup	points
name\_k set	name\_num*bauds/actual_fs
	dc	gain*(4*alpha*(@cos((1+alpha)*pi*name\_k)+@sin((1-alpha)*pi*name\_k)/(4*alpha*name\_k))/(pi*1.414*(1-(4*alpha*name\_k)*(4*alpha*name\_k))))
name\_num	set	name\_num+1.0
	endm
	endsec



	bufm	name\_states,x,points

	org	p:
name\_exe
	ptr	name\_s,0,name\_states,points-1,	
	ptr	name\_c,4,name\_coeffs,-1,	
	ldx0	name\_in

	clr	a	x0,x:(r0)-	y:(r4)+,y0
	do	m0,name\_1
	mac	x0,y0,a	x:(r0)-,x0	y:(r4)+,y0	
name\_1
	if	@msp(name)==3
	mac	x0,y0,a		(r0)+
	else
	macr	x0,y0,a		(r0)+
	endif
	sta	name

	ptru	name\_s
	

; Used registers for sample execution
	u	x
	u	y
	u	a
	u	r0
	u	m0
	u	r4
	u	m4

	endm		


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


