;; Stream to packets 
;; Implements one Input FIFO 
;; Needs an interrupt source
;; Stream input is read under IRQ
;; Packet production in mainloop

flowtopak	macro	name,bufsize,paksize
 if @def(name\_in_im)
	bufm	name\_ibuf,l,bufsize	; Complex input FIFO
 else
	bufm	name\_ibuf,y,bufsize	; Fract input FIFO
 endif
	org	p:
	flagrst	name\_rdy
	jcnf		name\_inhaspk,name\_1		; if input fifo has more than 1 packet then extract 1 packet from fifo
	move		#name,r0
	move		#-1,m0
	ptr	name\_ird,2,name\_ibuf,bufsize-1,paksize
 if	@msp(name)==3			; complex: write 0 in Im
	move	#0,x0
 endif
	do	n2,name\_01
 if @def(name\_in_im)
	move	l:(r2)+,x
 else
	move	y:(r2)+,x1
 endif
 if	@msp(name)==3
	move	x,l:(r0)+
 else
  if	@msp(name)==2
	move	x1,y:(r0)+
  else
	move	x1,x:(r0)+
  endif
 endif
name\_01
	ptru		name\_ird
	flagset	name\_got
	flagset	name\_rdy
name\_1


	section		irq
	ptr			name\_iwr,1,name\_ibuf,bufsize-1,
	ptr			name\_inb,3,-paksize,-1,paksize
 if @def(name\_in_im)
	ldx1		name\_in_re
	ldx0		name\_in_im
	move		x,l:(r1)+
 else
	ldx0		name\_in
	move		x0,y:(r1)+
 endif
	move		(r3)+

	jcnf		name\_got,name\_2
	move		(r3)-n3
name\_2

	btst		#23,r3
	bcs		name\_20
	flagset	name\_inhaspk
name\_20
	ptru		name\_iwr
	ptru		name\_inb

	u	r0
	u	r1
	u	r2
	u	r3
	u	x
	endsec


	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


