;; Convert Fractional variable to Decimal String
;; Syntax: 	strd	name[,n[,f]]
;; input = var to convert; addr=begin of data string  
;; n = number of digits (default = 3),
;; f = scaling factor = what to display if in_name = 1.0  (deft=1.0)		


fractostring	macro	input,addr,n,f

_rg	set	@cvi(@flr(@l10(f)))				; rg=0 for 1.23
_coeff	set	@pow(10,(@l10(f)-@flr(@l10(f)))-1.0)

		if	f==1.0
_rg	set	-1
		endif

		if	_rg>=0
_db	set	_rg+1	; digits before dp
_da	set	n-_db	; digits after dp
		else
_za	set	-(_rg+1)	; zeros after dp
_da	set	n+_rg	; digits after zeroes
		endif

		org	p:

		if	f!=1.0
		ldx0	input	
		move	#>_coeff,y0
		mpy	x0,y0,b
		else
		ldb	input
		endif

		move	#addr,r4
		move	#-1,m4

		if	_rg>=0
		move	#_db,n0
		move	#_da,n4
		else
		move	#_za,n0
		move	#_da,n4
		endif

		bsr	fr2asc

		if	_rg>=0
		bsr	fr2asc_gt1	; scaling > 1

		else		
		bsr	fr2asc_lt1	; scaling < 1
		endif

 if		!@def(fr2asc)  

		section	routines
		global	fr2asc,fr2asc_gt1,fr2asc_lt1
		org	p:

; Fractional word to decimal string conversion routine 
; b = value ;

fr2asc	tst	b
		bpl	<fr2asc_1	
		neg	b
		bec	<fr2asc_0	
		dec	b		; case "-1.0"
fr2asc_0	move	#'-',a1
		bra	<fr2asc_2
fr2asc_1	move	#$20,a1
fr2asc_2	move	a1,y:(r4)+
		move	#0,b2
		rts
		
fr2asc_gt1	do	n0,fr2asc_3
		bsr	fr2asc_nxtd
		nop
fr2asc_3
		move	#'.',a1
		move  a1,y:(r4)+
		bra	<fr2asc_4
		
fr2asc_lt1	move	#'0',a1
		move	a1,y:(r4)+
		move	#'.',a1
		move	a1,y:(r4)+
		do	n0,fr2asc_4
		move	#'0',a1
		move	a1,y:(r4)+
		nop
fr2asc_4
		do	n4,fr2asc_5
		bsr	fr2asc_nxtd
		nop
fr2asc_5
		nop
		rts

fr2asc_nxtd	move	b1,x1
		asl	b	b0,x0	; x = 0 .. 1
		asl	b		; b = 4x
		add	x,b		; b = 5x
		asl	b		; b = 10x
		asl	b		; b2= int(10x)

out1d		move	b2,a
		add	#'0',a
		move	a1,y:(r4)+
		move	#0,b2
		asr	b		; b > 0
		rts

	endsec
 endif  


; Used registers for sample execution
	u	n0
	u	r4
	u	n4
	u	m4
	u	x
	u	y
	u	a
	u	b

   endm				

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


