;; Basic Sample rate generator and 2 channel analog I/O for mu.psi card
;; Syntax:	fs_timer  fs	    fs = sample frequency in Hertz (1.0 to 1e6)
;; Installs IRQ-Timer0-Compare at Init.    Execution = wait for a sample.      



fs_timer	macro	fs
	org	p:	;; Waiting loop:

	waicf	fstim


	if	!@def(fstim_vector)	;; 1st occurence = Installation	
fstim_nper	set	@cvi(fdsp/(2.*fs))
fstim_nwdt set	fstim_nper/2

fstim_fs	set	fdsp/(2.*@cvf(fstim_nper))		; @cvi(fdsp/(2.*fs))))
actual_fs gset	fstim_fs
avail_cycles	set	2.*@cvf(fstim_nper)		; @cvi(fdsp/(2.*fs)))


	section	vectors	global
	org	p:$54
fstim_vector jsr	irqtim0
	endsec

	section	irq
	global	irqtim0

	org	p:
	opt	cc
irqtim0
	opt	nocc
avail_cycles	set	avail_cycles-(@ccc()+@ccc()/3)
	opt	cc
	bset	#21,x:TCSR0
 dbgdisa
	flagset	fstim
 dbgena
	rti
	opt	nocc
	nolist
	nolist
	msg	'>>> Fs=',@cvi(fstim_fs),'Hz'
	msg	'>>> Available DSP cycles between samples = ',@cvi(avail_cycles-7-@ccc())  ;
	list
	list
	endsec


	section	inits
	org	p:	


; periode = 2*tcpr/fdsp
; x x tcf tof x x x x pce x do di dir x trm inv tc3..tc0 x tcie toie te
; 0 0  1   1  0 0 0 0  0  0 0  0  0   0  1   0   0111    0  1    0    1
;     3      .   0    .    0     .      2      .   7   .      5

	movep	#0,x:TCSR0 
	movep	#-fstim_nper,x:TLR0
	movep	#0,x:TCPR0
	movep	#$300A75,x:TCSR0
	brclr	#20,x:TCSR0,*	; wait for TOF
	movep	#-fstim_nwdt,x:TCPR0
 if core==0
val_iprp0 set	val_iprp0&$fffcff|$000200
val_sr0	set	val_sr0&$fffcff
 else
val_iprp1 set	val_iprp1&$fffcff|$000200
val_sr1	set	val_sr1&$fffcff
 endif



;------------------------------------------------------
	endsec


	endif
	endm	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


