;; Converts a signal between min and max to a signal between -1 and +1 respectively
;; min and max should be in the FRACT range [-1...+1[ and should be different

 
fullscale	macro	name,min,max
 if min!=max
name\_p	set	2/(max-min)
name\_q	set	(max+min)/(max-min)
name\_l	set	@cel(@log(@abs(name\_p))/@log(2))
name\_p	set	name\_p/@pow(2,name\_l)
name\_q	set	name\_q/@pow(2,name\_l)


	ldx0	name\_in
	move	#>name\_p,x1
	move	#>-name\_q,a
	mac	x0,x1,a
  if	name\_l>0
	asl	#@cvi(name\_l),a,a
  endif
  if	name\_l<0
	asr	#@cvi(name\_l),a,a
  endif
	sta	name
 else
	fail	'FULLSCALE min and max should be different !'
 endif
	u	a
	u	x
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


