;; Gaussian noise generator      y = sigma * sqrt(3)/sqrt(N) * {rand + rand + ..+ rand}
;; Syntax: 	g_gauss	name,sigma[,N]
;; Approximate normal distribution by adding N uniform random sources (sigma= std dev.) 
;; By default, N=4 (enough for noise power calculations; take N>=25 for error rate calc.) 
;; Output: name 
;; Variance sigma = N*G/3  
;; G = sigma*sqrt(3)/sqrt(N)  N=4 by default
;; (if sigma=0, no clculation)
;;
g_gauss	macro	name,sigma,N
 if sigma==0
	clr	a
 else
	if	@arg('N')
name\_gn set	@sqt(3.)*sigma/@sqt(@cvf(N))
 	else
name\_gn set	@sqt(3.)*sigma/2. 
	endif


	var	name\_uni

	org	p:
	dbgdisa
	g_noise	name\_uni

	move	#>name\_gn,x1
	ldx0	name\_uni
	mpy	x0,x1,a
	move	a,r0

	if	@arg('N')
	do	#(N-1),name\_1
	else
	do	#4,name\_1
	endif

	jsr	g_random
	move	#>name\_gn,x1
	ldx0	random_lsb
	move	r0,a
	mac	x0,x1,a
	move	a,r0
name\_1
 endif
	sta	name
	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


