;; Goertzel Algorithm
;; a=n*2pi/N  f0= Fs * n/N    n=Nf0/Fs
;; a=2pi F0/Fs ;  w(0)=0 ; w(-1)=0
;; w(k) = x(k) + 2cos(a)w(k-1)-w(k-2) k=1..N
;; z(n)=w(N) - w(n-1)exp(ja)

goertzel	macro	name,n,f0,unit

 if ("ar"=='abs')|("unit"=='Hz')
name\_a	set	2*pi*f0/actual_fs
 else
name\_a	set	pi*f0
 endif
	var	name\_cnt,n
	var	name\_w,0
	var	name\_wd,0
	coef	name\_cos,@cos(name\_a)
	coef	name\_sin,@sin(name\_a)

	section	inits
	clr	a
	sta	name\_w
	sta	name\_wd
	move	#n,r0
	str0	name\_cnt
	endsec


	ldr0	name\_cnt
	move	#-1,m0
	move	(r0)-
	btst	#23,r0
	bcc	name\_1

 if @def(name\_re)
	lda	name\_w
	ldy0	name\_cos
	ldx0	name\_wd
	mac	-x0,y0,a	y:name\_sin,y1
	sta	name\_re
	mpy	-x0,y1,a		
	sta	name\_im
 endif
 if @def(name\_pow)
	ldx0	name\_w
	mpy	x0,x0,a	y:name\_cos,y0	; a= w
	mpy	x0,y0,b	x:name\_wd,x0	; b= w*cos
	mac	x0,x0,a	b,x1			; a= w+wd  x1=w*cos
	mac	-x0,x1,a
	mac	-x0,x1,a				; a= w+wd-2w*wd*cos = Power
	asl	a
	asl	a					; a=4*power = 0...1
	sta	name\_pow
	u	b
 endif
	clr	a
	sta	name\_w
	sta	name\_wd	
	flagset name\_rdy
	move	#n-1,r0
	str0	name\_cnt
	bra	<name\_2
name\_1
	str0  name\_cnt
	ldx0	name\_in	
	move	#>@frc(1/@cvf(n)),y0
	mpy	x0,y0,a	y:name\_cos,y0
	ldx0	name\_w
	mac	x0,y0,a	x:name\_wd,x1	
	mac	x0,y0,a	x0,x:name\_wd
	sub	x1,a		(r0)-
	sta	name\_w
name\_2

	u	x
	u	y
	u	a

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


