;; 2D histogram 
;; syntax:	histo2D	name,lin,col,epsi
;; epsi = increment ; buffer switching when saturation occurs
;; Inputs name_lin, name_col
;; outputs = name_mat(x: or y: depending on name_yf);   boolean name_new
;;           name_plin, name_pcol = per line and per column marginal probas



histo2d	macro	name,lin,col,epsi
 if 	!@def(name\_mat)
	mat	name\_mat,l,lin,col
 endif
	buf	name\_plin,x,lin
	buf	name\_pcol,x,col
	vard	name\_sum,0

	move	#-1,m0
	move	m0,m1
	move	m0,m2
	move	#>lin,x1
	lda	name\_lin	; line input
	lsr	a
	move	a1,x0	
	mpy	x0,x1,a	; a1=N ligne 

	move	#>col,y1
	ldb	name\_col
	lsr	b
	move	b1,x0
	mpy	x0,y1,b	; b1=N colonne
 
	move	a,x0
	mpy	x0,x1,a
	asl	#23,a,a		; a1=N ligne * col/ligne
	add	b,a	#>epsi,x0	;a1=N cellule

	move	#name\_mat,r0
	move	a1,n0

	jnf	name\_yf,name\_1
	move	x:(r0+n0),a
	add	x0,a
	move	a,x:(r0+n0)
	bra	<name\_2
name\_1
	move	y:(r0+n0),a
	add	x0,a
	move	a,y:(r0+n0)
name\_2
	lda	name\_sum
	add	x0,a
	sta	name\_sum
	bec	<name\_7			; if histo not full, end of job
	clr	a				; otherwise,
	sta	name\_sum			; clear sum
	flagtog name\_yf			; switch active matrix
	bcs	<name\_4
	do	#(lin*col),name\_3	; clear old matrix
	move	a,x:(r0)+
name\_3
	move	#name\_mat,r0		; calculate marginal probas per line
	move	#name\_plin,r1
	move	y:(r0)+,x0
	do	#lin,name\_3a
	clr	a	
	rep	#col
	add	x0,a	y:(r0)+,x0
	move	a,x:(r1)+
name\_3a

	move	#name\_mat,r0		; calculate marginal probas per column
	move	#col,n2
	move	#name\_pcol,r1
	do	#col,name\_3b
	clr	a	r0,r2
	move	y:(r2)+n2,x0
	rep	#lin
	add	x0,a	y:(r2)+n2,x0
	move	(r0)+
	move	a,x:(r1)+
name\_3b

	bra	<name\_6
name\_4
	do	#(lin*col),name\_5
	move	a,y:(r0)+
name\_5
	move	#name\_mat,r0		; calculate marginal probas per line
	move	#name\_plin,r1
	move	x:(r0)+,x0
	do	#lin,name\_5a
	clr	a	
	rep	#col
	add	x0,a	x:(r0)+,x0
	move	a,x:(r1)+
name\_5a

	move	#name\_mat,r0		; calculate marginal probas per column
	move	#col,n2
	move	#name\_pcol,r1
	do	#col,name\_5b
	clr	a	r0,r2
	move	x:(r2)+n2,x0
	rep	#lin
	add	x0,a	x:(r2)+n2,x0
	move	(r0)+
	move	a,x:(r1)+
name\_5b

name\_6
	flagset name\_new	
name\_7

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


