;; INVERSE FFT algorithm	 (Modified version of Motorola library "FFTR2AS" )
;;  Scales input by 1/N  Unscrables mirror binary output
;;
ifft	macro	name
n	set		name\_size

 if	!@def(fft_coeffs)
; Sine-Cosine Table
		section	longfar	global	
angle	set	0.0
incr		set	2*pi/@cvf(n)
		org	l:
		buffer	r,n/2
fft_coeffs
		dup	n/2
		dc	@lng(@frc(-@cos(angle)),@frc(-@sin(angle)))
angle	set	angle+incr
		endm
		endbuf		
		endsec
 endif

	org		p:
 if @def(name\_busy_b)
	flagset	name\_busy
 endif

	move		#name\_in,r0
	move		#-1,m0
	move		#n,n0
	move		#tempbuf,r1
 	move		m0,m1
 if	@msp(name\_in)==1
	move		#0,x0
	do	n0,name\_0
	move		x:(r0)+,x1
 endif
 if	@msp(name\_in)==2
	move		#0,x0
	do	n0,name\_0
	move		y:(r0)+,x1
 endif
 if	@msp(name\_in)==3
	do	n0,name\_0
	move		l:(r0)+,x
 endif
	move		x,l:(r1)+
name\_0
	move		#n/2,n0      ;initialize butterflies per group
	move		#@cvi(@log(name\_size)/@log(2)+0.5),n1
	move		#n/4,n6      ;initialize C pointer offset
	move		#tempbuf,r2	; in place FFT here
	move		#fft_coeffs,r3
	jsr		ifft_routine
	move		#tempbuf,r1
	move		#n/2,n1
	move		#0,m1
	move		#name,r4
	move		#-1,m4
	move		#n,n4
	do		n4,name\_1
	move		l:(r1)+n1,x
	move		x,l:(r4)+
name\_1
 if @def(name\_busy_b)
	flagclr	name\_busy
 endif
		


	if	!@def(ifft_routine)

	section	routines
	org	p: 
	global ifft_routine
	
ifft_routine	
         move    #1,n2             ;initialize groups per pass
         move    #-1,m0            ;initialize A and B address modifiers
         move    m0,m1             ;for linear addressing
         move    m0,m4
         move    m0,m5
         move    #0,m6             ;initialize C address modifier for
                                   ;reverse carry (bit-reversed) addressing
;         andi    #$7F,ccr          ;clear scaling bit
;         ori     #$4,mr            ;set scaling down mode
;
; Perform all FFT passes with triple nested DO loop
;
         do      n1,_end_pass
         move    r2,r0			;initialize A input pointer
         move    r0,r4				;initialize A output pointer
         move    n0,n1				;initialize pointer offsets
         move    n0,n4
         lua     (r0)+n0,r1			;initialize B input pointer
         move    r3,r6		;initialize C input pointer
         move    n0,n5
         lua     (r1)-,r5				;initialize B output pointer

         do      n2,_end_grp
         move    x:(r1),x1  y:(r6),y0	;lookup -sine and -cosine values
         move    x:(r5),a   y:(r0),b      ;preload data
         move          x:(r6)+n6,x0  	;update C pointer
         do      n0,_end_bfy
         mac     -x1,y0,b    y:(r1)+,y1    ;Radix 2 DIT ;butterfly kernel
         macr    -x0,y1,b   a,x:(r5)+  y:(r0),a
         subl    b,a        
	   	move    x:(r0),b   b,y:(r4)
         mac     -x1,x0,b   x:(r0)+,a  a,y:(r5)
         macr    y1,y0,b   x:(r1),x1
         subl    b,a        
	   	move    b,x:(r4)+  y:(r0),b
_end_bfy
         move    a,x:(r5)+n5    y:(r1)+n1,y1   ;update A and B pointers
         move    x:(r0)+n0,x1   y:(r4)+n4,y1
_end_grp
         move    n0,b1
         lsr     b   n2,a1			;divide butterflies per group by two
	   nop
         lsl     a   b1,n0			;multiply groups per pass by two
	   nop
         move    a1,n2
_end_pass
;        andi    #$7f,ccr			;clear scaling bit
;        andi    #$f3,mr			;no scaling
;		nop
		rts

	endsec
	endif

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0
	u	r1
	u	n1
	u	r2
	u	n2
	u	r3
	u	r4
	u	n4
	u	r5
	u	n5
	u	r6
	u	n6

	endm


;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


