;; lp2a P-bas du second ordre analogique: H(p) = w0/(p +2xiw0p +w0) --> (cb0 + cb1*z^-1)/(1-ca1z^-1 -ca2z^-2)
;; Syntax	lp2a  name,w0,xi,gain
;; cb0 = b1  cb1=b0  ca1=-a1  ca2=-a0  (v. cours GB Reg Num I p. 9)
;;



lp2a	macro	name,w0,xi,g
_w0r	set	w0/actual_fs
_wpr	set	_w0r*@sqt(1-xi*xi)
cb0	set	g*(1-(@xpn(-xi*_w0r))*(@cos(_wpr)+xi*@sin(_wpr)/@sqt(1-xi*xi)))
cb1	set	g*(@xpn(-2.*xi*_w0r)+@xpn(-xi*_w0r)*((xi*@sin(_wpr)/@sqt(1-xi*xi))-@cos(_wpr)))
ca1	set	2.*@xpn(-xi*_w0r)*@cos(_wpr)
ca2	set	-@xpn(-2.*xi*_w0r)

	iir	name,cb0,cb1,0,ca1,ca2
	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use

