;; Add 2 Weighted inputs (filter primitive)
;; madd2 name,g1,g2
;; name_in, name_in1, name_in2 = inputs
;; name = output = name_in + g1*name_in1 + g2*name_in2
;; gains g1, g2 may be >1 or <-1, but result must stay between [-1..+1[



madd2 	macro	name,g1,g2	
name\_rg1	set	0
name\_rg2	set	0
 if	(@abs(g1)>1.0)
name\_rg1	set		@cvi(@cel(@log(@abs(g1))/@log(2.)))
 endif
 if	(@abs(g2)>1.0)
name\_rg2	set		@cvi(@cel(@log(@abs(g2))/@log(2.)))
 endif
name\_sh	set	@max(name\_rg1,name\_rg2)
 if (name\_sh>0)
name\_fr1	set   g1/@pow(2.0,name\_sh)
name\_fr2	set   g2/@pow(2.0,name\_sh)
	coef	name\_k1,name\_fr1
	coef	name\_k2,name\_fr2

	ldx0	name\_in1
	ldx1	name\_k1
  if	@msp(name\_in2)==2
	mpy	x0,x1,a	y:name\_in2,x0
  else
	mpy	x0,x1,a	x:name\_in2,x0
  endif
	ldx1	name\_k2
  if	@msp(name\_in)==2
	mac	x0,x1,a	y:name\_in,b
  else
	mac	x0,x1,a	x:name\_in,b
  endif
  if	name\_sh==1
	addl	b,a
  else
	asl	#name\_sh,a,a
	add	b,a
  endif
  u  b
 else
	lda	name\_in
  if	@abs(g1)!=1.0
	coef	name\_g1,g1
  endif
  if	@abs(g2)!=1.0
	coef	name\_g2,g2
  endif

  if	@abs(g1)==1.0
	ldx0	name\_in1
   if g1>0
    if @msp(name\_in2)==2
	add	x0,a		y:name\_in2,x0
    else
	add	x0,a		x:name\_in2,x0
    endif
   else
    if @msp(name\_in2)==2
	sub	x0,a		y:name\_in2,x0
    else
	sub	x0,a		x:name\_in2,x0
    endif
   endif
  else
	ldx0	name\_in1	
	ldx1	name\_g1
    if @msp(name\_in2)==2
	mac	x0,x1,a		y:name\_in2,x0
    else
	mac	x0,x1,a		x:name\_in2,x0
    endif
  endif	

  if	g2==1.0
		add	x0,a
  endif
	
  if	g2==-1.0	
		sub	x0,a
  endif
	
  if	@abs(g2)!=1.0
		ldx1	name\_g2
		macr	x0,x1,a
  endif
 endif
	sta	name
	u	a
	u	x
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


