;; Midi command interpreter
midiplay		macro	name	
midi_maxchans		equ	30
midi_datasize		equ	10
midi_maxtracks	equ	24
midi_trdatsize	equ	6

midi_stat		equ	0
midi_eot			equ	0
midi_dtime		equ	1

midi_timer		equ	1
midi_ptr			equ	2
midi_curword		equ	3
midi_bytepos		equ	4
midi_lastcmd		equ	5


; frquences des notes
; 
	section	far	global
midi_pos	set	0
	org	y:
midi_freqs
	dup	128
	dc	440.*@pow(2.,(@cvf(midi_pos-69)/12.))/actual_fs   ; 69 45
midi_pos	set	midi_pos+1
	endm

; Formes d'ondes

wav0_pts 	set	2
wav0
	dc	0.99,0.99

wav1_pts 	set	35
dang	set	2.*pi/@cvf(wav1_pts-1)
ang	set	0.0

wav1
	dup	wav1_pts
	dc	@sin(ang)
ang	set	ang+dang
	endm

wav2_pts 	set	35
dang	set	2.*pi/@cvf(wav2_pts-1)
ang	set	0.0

wav2
	dup	wav2_pts
	dc	0.5*@sin(ang)+0.3*@sin(3*ang)+0.1*@sin(5*ang)
ang	set	ang+dang
	endm

wav3_pts 	set	35
dang	set	2.*pi/@cvf(wav3_pts-1)
ang	set	0.0

wav3
	dup	wav3_pts
	dc	0.7*@sin(ang)+0.1*@sin(3*ang)+0.05*@sin(5*ang)
ang	set	ang+dang
	endm

wav4_pts 	set	80
dang	set	2.*pi/@cvf(wav4_pts-1)
ang	set	0.0

wav4
	dup	wav4_pts
	dc	0.4*@sin(ang)+0.2*@sin(2*ang)+0.2*@sin(4*ang)+0.2*@sin(6*ang)+0.2*@sin(8*ang)+0.1*@sin(16*ang)
ang	set	ang+dang
	endm
wav5_pts 	set	80
dang	set	2.*pi/@cvf(wav5_pts-1)
ang	set	0.0

wav5
	dup	wav5_pts
	dc	0.8*@sin(ang)+0.1*@sin(3*ang)+0.1*@sin(5*ang) ;+0.05*@sin(7*ang)	
ang	set	ang+dang
	endm

wav6_pts 	set	30
dang	set	2.*pi/@cvf(wav6_pts-1)
ang	set	0.0

wav6
	dup	wav6_pts
	dc	0.1*@sin(ang)+0.2*@sin(2*ang)+0.4*@sin(3*ang)+0.2*@sin(4*ang)+0.4*@sin(5*ang)	; *@sin(ang)*@sin(ang)*@sin(ang)*@sin(ang)
ang	set	ang+dang
	endm
;	dc	0.,0.99,0,-0.7,0,0.5,0,-0.3,0,0.2,0,-0.1,0,0,0	

wav7_pts 	set	8

wav7
;	dup	wav7_pts
	dc	0,-0.9,0.9,-0.5,0.5,0,0,0	; ,-0.6,0.6,-0.5,0.5    ; -0.4,0.4,-0.3,0.3,-0.2,0.2,-0.1,0.1,0
;	endm

wav8_pts 	set	30

wav8
	dup	wav8_pts/2
	dc	@rnd()
	endm

	dup	wav8_pts/2
	dc	-@rnd()
	endm

wav9_pts 	set	80
pos		set	-wav9_pts/2

wav9
	dup	wav9_pts
	dc	@xpn(-0.2*@cvf((pos-7)*(pos-7)))
pos 	set	pos+1
	endm


; Enveloppes
envel1_pts 	set	30
pos		set	0.
envel1
	dup	envel1_pts
	dc	0.1+(0.9*@xpn(-0.2*pos))
pos	set	pos+1.0
	endm

; Enveloppe 2
envel2_pts 	set	30
pos		set	0.

envel2
	dup	envel2_pts
;	dc	0.5*(1.+@xpn(-0.2*pos))
	dc	0.999*@xpn(-0.15*pos)
pos	set	pos+1.0
	endm

; Enveloppe 3
envel3_pts 	set	30
pos		set	0.
envel3
	dup	envel3_pts
	dc	0.5*(1.+@sin(0.5*pos)*@xpn(-0.2*pos))
pos	set	pos+1.0
	endm

; Enveloppe 4

envel4_pts 	set	30
pos		set	0.

	org	y:
envel4
	dup	envel4_pts
;	dc	0.51-0.49*@cos(0.3*pos)*@xpn(-0.2*pos)
	dc	1.-0.99*@xpn(-0.2*pos)
pos	set	pos+1.0
	endm

envel5_pts 	set	30
pos		set	0.
envel5
	dup	envel5_pts
;	dc	(0.7*@xpn(-0.3*pos)+0.3*@xpn(-0.02*pos))
	dc	@xpn(-0.1*pos)
pos	set	pos+1.0
	endm

; Enveloppe 6
envel6_pts 	set	30
pos		set	0.

envel6
	dup	envel6_pts
	dc	1.5*@sin(pos)*@xpn(-0.1*pos)
pos	set	pos+1.0
	endm

	endsec

; Instruments

	section	longfar	global
	org	l:
	ds	9
midi_piano
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.00005),0)				; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel5_pts-1,wav4_pts)			; taille tables  envel:wave
	dc	@lng(envel5,wav4)				; adresses envel:wave
	dc	@lng(@frc(0.0002),@frc(0.03))		; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))			; gains G:D
	dc	0,0						; sorties

midi_vieux_piano
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0002),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel2_pts-1,wav1_pts)	; taille tables  envel:wave
	dc	@lng(envel2,wav1)			; adresses envel:wave
	dc	@lng(@frc(0.00015),@frc(0.03))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_banjo
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0002),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel2_pts-1,wav6_pts)		; taille tables  envel:wave
	dc	@lng(envel2,wav6)				; adresses envel:wave
	dc	@lng(@frc(0.0002),@frc(0.03))		; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_guitar		; 25-32
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.00005),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel5_pts-1,wav4_pts)		; taille tables  envel:wave
	dc	@lng(envel5,wav4)				; adresses envel:wave
	dc	@lng(@frc(0.00005),@frc(0.003))		; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties



midi_orgue
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.00015),0)			; vitesse attaque : frquence
	dc	0							; att : phi
	dc	@lng(envel4_pts-1,wav5_pts)	; taille tables  envel:wave
	dc	@lng(envel4,wav5)				; adresses envel:wave
	dc	@lng(@frc(0.0000),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0							; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0							; sorties

midi_grand_orgue
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.00001),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel4_pts-1,wav4_pts)	; taille tables  envel:wave
	dc	@lng(envel4,wav4)			; adresses envel:wave
	dc	@lng(@frc(0.00001),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties


midi_vieil_orgue
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.002),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel4_pts-1,wav6_pts)	; taille tables  envel:wave
	dc	@lng(envel4,wav6)			; adresses envel:wave
	dc	@lng(@frc(0.0000),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_flute
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.005),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel4_pts-1,wav6_pts)	; taille tables  envel:wave
	dc	@lng(envel4,wav6)			; adresses envel:wave
	dc	@lng(@frc(0.0000),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_hautbois
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.002),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel3_pts-1,wav7_pts)	; taille tables  envel:wave
	dc	@lng(envel3,wav7)			; adresses envel:wave
	dc	@lng(@frc(0.0000),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties


midi_violon
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0003),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel3_pts-1,wav7_pts)	; taille tables  envel:wave
	dc	@lng(envel3,wav7)			; adresses envel:wave
	dc	@lng(@frc(0.00001),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties
midi_basse
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0001),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel3_pts-1,wav2_pts)	; taille tables  envel:wave
	dc	@lng(envel3,wav2)			; adresses envel:wave
	dc	@lng(@frc(0.00001),@frc(0.001))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_perc
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.1),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel6_pts-1,wav0_pts)	; taille tables  envel:wave
	dc	@lng(envel6,wav0)			; adresses envel:wave
	dc	@lng(@frc(0.015),@frc(0.5))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_voix
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0001),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel3_pts-1,wav7_pts)	; taille tables  envel:wave
	dc	@lng(envel3,wav7)			; adresses envel:wave
	dc	@lng(@frc(0.00005),@frc(0.01))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

midi_trompette
	dc	@lng(0,0)					; note : status	
	dc	@lng(@frc(0.0002),0)			; vitesse attaque : frquence
	dc	0						; att : phi
	dc	@lng(envel3_pts-1,wav6_pts)	; taille tables  envel:wave
	dc	@lng(envel3,wav6)			; adresses envel:wave
	dc	@lng(@frc(0.000),@frc(0.01))	; taux dcroissance sustain:stop
	dc	0						; valeur enveloppe:bruit
	dc	@lng(@frc(0.9),@frc(0.9))		; gains G:D
	dc	0,0						; sorties

	endsec

	section	far	global

	org	x:
midi_chaninstr
;	   (1-8        PIANO)          
	dc	midi_piano		      
	dc	midi_piano		
 	dc	midi_piano		      
	dc	midi_piano		
	dc	midi_piano		      
	dc	midi_piano		
 	dc	midi_piano		      
	dc	midi_piano		
	dc	midi_piano		      
	dc	midi_piano		
 	dc	midi_piano		      
	dc	midi_piano		
	dc	midi_piano		      
	dc	midi_piano		
 	dc	midi_piano		      
	dc	midi_piano		
          
	endsec


	var		midi_type,0
	var		midi_tracks,0
	var		midi_tracklng,0
	var		midi_instr,midi_piano
	var		midi_tempo,250000
	var		midi_division,48
	vard		midi_speed,0.01
	vard		midi_ticktimer,0
		
	buf		midi_chandata,l,(midi_maxchans*midi_datasize)
	buf		midi_trackdata,x,(midi_maxtracks*midi_trdatsize)


	var		midi_absbytepos,0
	var		midi_abscurword,0
	var		midi_cmddta,$80


; structure de donnes d'une voie

midi_note_stat	equ	0		; N note / Etat de la voie:
midi_reserved		equ	0		; 0: libre  1: rserve
midi_busy		equ	1		; 0: au repos   1: en activit
midi_noteon		equ	2		; 0: touche lche  1: touche appuye
midi_pedale		equ	3		; 0: normal  1: avec sustain 
midi_damp		equ	4		; 0: normal  1: avec touffoir

midi_speed_freq	equ	1		; vitesse transit / frquence  0=DC ... 1.0=Fs
midi_att_phase	equ	2		; transitoire / dents de scie [0..+1[
midi_tab_sizes	equ	3		; taille des tables transit / timbre
midi_tab_addrs	equ	4		; adresses des tables transit / timbre
midi_sust_stop	equ	5		; valeur dcrement log  sustain:arret 
midi_envel_nois	equ	6		; valeur de l'enveloppe / % bruit
midi_levels		equ	7		; niveaux G/D
midi_outs		equ	8		; sorties son G & D


		section	inits
		move		#midi_chandata,r1
		move		#-1,m1
		move		#midi_datasize,n1
		move		m1,m2
		move		#2,n2
		flagclr		midi_active
		endsec

		jf		fifini,p00
		move		#$0D0000,a1
		putfifo		sndc,256,0	
		move		#$0A0000,a1
		putfifo		sndc,256,0
		flagset	fifini	
p00


; Synth par lecture de tables
; code Temps Rel


	section	irq
		org	p:
chanexe
	jf		midi_pause,no_rt
	move		l:midi_ticktimer,a
	move		l:midi_speed,x
	add		x,a
	move		a10,l:midi_ticktimer
	bec		<notim
	move		#midi_trackdata+midi_timer,r1
	move		#midi_trdatsize,n1
	do		x:midi_tracks,timupd
	move		x:(r1),a
	sub		#>1,a
	bne		<tmupd0
	move		(r1)-
	bset		#midi_dtime,x:(r1)+
tmupd0
	move		a,x:(r1)+n1
timupd
notim
	move		#midi_chandata,r1
	move		#midi_datasize,n1
	move		#2,n2

	do		#midi_maxchans,endchan
	lua		(r1)+,r2						; r2 = *speed_freq
	brclr	#midi_busy,y:(r1),nxtchan		; r1 = *stat
	move					l:(r2)+,a		; a10 = d_att : d_phi   r2= *att_phase
	move					l:(r2)+,x		; x = att : phi		r2 = *tab_sizes
	add		x,a			l:(r2)-,y		; y1 = size(att) y0= size(wave) r2= *att_phase
	bec		<ch1
	bset		#0,y:(r1)
ch1	bclr		#23,a0						; phi >=0
	mpy		x1,y1,b		a,x:(r2)			; b1:b0 = pos tab att	
	mpy		x0,y0,a		a0,y:(r2)+n2		; a1:a0 = pos tab wav   r2 = *tab_addrs
	lsl		a			l:(r2)+,y		; y =  *tab_att:*wave r2 = *sust_declg
	asr		a						; a1:a0 = xxxxxxx:0xxxxxxx
	add		y0,a			a0,x0			; a1 = *(wave + phi)   x0 = fract [0..1[
	lsl		b			a1,r0			; r0 = *(wave + int(phi))
	asr		b			y:(r0)+,y0		; b1:b0 = xxxxxxx:0xxxxxxx  y0 = wave[int(phi)]
	add		y1,b			b0,x1			; b1 = *(tabatt + att)       x1 = fract
	mpy	 	-y0,x0,a		y:(r0),y1		; a = -f*y0    y1= wave[int(phi)+1]
	mac	 	y1,x0,a		b1,r0			; a = f*(y1-y0)  r0 = *(tabatt + att)
	add		y0,a			y:(r0)+,y0		; a = y0+f*(y1-y0)=interp wave  y0 = tabatt[int(att)]
	mpy		-y0,x1,b		y:(r0),y1		; b = -f*y0    y1= tabatt[int(att)+1]   
	mac		y1,x1,b		l:(r2)+,x		; b = f*(y1-y0)   x = sustain:decay rate
	add		y0,b		x:(r2),y1			; b = y0+f*(y1-y0)=enveloppe y0= wave

	btst		#0,y:(r1)					; =1 si attaque termine, alors:
	tcs		y1,b						; alors env(k) = env(k-1)

	mac		-x1,y1,b					; dcroissance ventuelle (x1>0)du sustain

	move		       		b,y1			; x0= dcr pour stop   y1= enveloppe 
	btst		#midi_noteon,y:(r1)				; si note off:
	mac		-x0,y1,b		ifcc			; dcroissance rapide

	clr		a	b,x:(r2)+		a,y0		;
	cmp		#>0.0005,b					; si b<seuil:      y1= enveloppe 
	bgt		<nodecay					; 
	move		a10,l:(r1)					; canal off

nodecay
	mpy		y0,y1,a		l:(r2)+,x		; a = sig*enveloppe  x = Level L:R  r2 = *outs
	move		a,y0						; y0= sig*enveloppe
	mpyr		x0,y0,a					; a = sortie droite		 
	mpyr		x1,y0,b					; b = sortie gauche

	move		ba,l:(r2)    				; mj sorties, voie suivante

nxtchan
	move		(r1)+n1
endchan								; fin du DO

	move		#midi_chandata+8,r1
	clr	a	#>0.2,x0
	clr	b	l:(r1)+n1,y

	do	#midi_maxchans,endout
	mac	x0,y0,a	
	mac	x0,y1,b	l:(r1)+n1,y
endout
	sta	name\_l
	stb	name\_r
no_rt
	nop

sendchar					; A1 = cca000 (8MSB= char; b4-7= couleur)
	lda		term_inch
	move		#>$FFF000,x0	; test si place dispo
	and		x0,a		a,b
	bne		sndch3
	getfifo	sndc,256,0
	bne		sndch1
	flagset	sendch_rdy
	bra		<sndc4
sndch1
	movec 		sr,x1
	ori		#3,mr
	move		a1,b0
	asl		#12,b,b	
	move		b1,a
	and		x0,a
	bne		sndch2
	getfifo		sndc,256,0
	beq		sndch2
	move		a1,b0
	asl		#12,b,b
sndch2	
	stb1		term_inch
	movec		x1,sr
sndch3

	bset		#8,x:dspstatus
sndc4

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r1
	u	n1
	u	r2
	u	n2

	endsec







debut
pp0
	jcf		midi_active,pp1	
	bsr		reset
	bsr		header
	bsr		makepointers
	jsr		msghello
	bsr		multitrack0	; lire 1 deltatime de chaque voie
pp1
	bsr		multitrack1	; on time, command + deltatime




	section routines
	global	reset,stop,go,header,makepointers,multitrack0,multitrack1,msghello

reset	jsr	resetall
	flagclr event
	move		#name\_in,r7
	move	#-1,m7
	clr	a
	sta	midi_absbytepos
	sta	midi_abscurword
	flagclr	pause
	rts

stop
	flagset	midi_pause
	clr	a
	sta	name\_l
	sta	name\_r
	rts

go	flagclr	midi_pause
	rts


header			; 4D 54 68 64 00 00 00 06 ff ff nn nn dd dd 
	do	#10,head1
	bsr	getbyteabs
head1
	sta	midi_type
	bsr	getwordabs
	sta	midi_tracks
	bsr	getwordabs
	sta	midi_division
	rts

makepointers
	clr	a
	move		#midi_trackdata,r0
	move	r0,r5
	move	#midi_trdatsize,n5
	rep	#(midi_maxtracks*midi_trdatsize)
	move	a,x:(r0)+

	do	x:midi_tracks,mpt3
		do	#5,mpt1
		bsr	getbyteabs
		nop
		nop
mpt1	
		bsr		getw24abs
	
		move		r7,x:(r5+midi_ptr)
		ldx0		midi_absbytepos
		move		x0,x:(r5+midi_bytepos)
		ldx0		midi_abscurword
		move		x0,x:(r5+midi_curword)

		move		(r5)+n5
		do		a1,mpt2
		bsr		getbyteabs
		nop
		nop
mpt2
		nop
mpt3
		rts



;		clr	b	(r5)+n5
;mpt4
;		bsr		getbyteabs
;		move		a1,x0
;		lsl		#8,b
;		or		x0,b		#>$FF2F00,x0
;		move		b1,b
;		cmp		x0,b
;		bne		<mpt4
;		nop
;		nop
;mpt6
;	rts


multitrack0
	move		#midi_trackdata,r5
	move		#midi_trdatsize,n5
	do		x:midi_tracks,mtrk0
	bsr		deltatime
	move		(r5)+n5
	nop
mtrk0
	rts

multitrack1

	move		#midi_trackdata,r5
	do		x:midi_tracks,mtrk2
	brset	#midi_eot,x:(r5),mtrk1
	flagset	midi_active
;	bclr		#midi_dtime,x:(r5)
;	bcc		<mtrk1
	move		x:(r5+midi_timer),a
	tst		a
	bgt		<mtrk1
	bsr		command
	brset		#midi_eot,x:(r5),mtrk1
	bsr		deltatime
mtrk1
	move		(r5)+n5
	nop
mtrk2
	rts




deltatime
	bsr	vlq
	move	a1,x:(r5+midi_timer)
	rts


vlq	clr	b
dt1	lsl	#7,b
	jsr	getbyte
	bclr	#7,a1
	bcc	<dt2
	add	a,b
	bra	dt1
dt2	add	b,a	
	rts

command
	jsr		getbyte
	brset		#7,a1,cmd0
	sta1		midi_cmddta
	move		x:(r5+midi_lastcmd),a
	bra		<cmd1
cmd0
	move		a1,x:(r5+midi_lastcmd)
cmd1
	move		a,b
	lsr		#4,a
	bclr		#3,a
	bcc		midi_error
	and		#$0F,b
	move		b1,n3
	move		#midi_chaninstr,r3
	move		a1,n6
	move		#tabcmd,r6
	move		x:(r3+n3),r3
	jmp		(r6+n6)

nocmd
	move		x:(r5+midi_lastcmd),a
	bra		<cmd1





tabcmd
	bra	<spnotoff		; 8x nn vv
	bra	<spnoton		; 9x nn vv
	bra	<spaftertouch	; Ax nn vv
	bra	<spcontrol		; Bx cc uu
	bra	<sppatch		; Cx pp
	bra	<spchanafttch	; Dx cc
	bra	<sppitch		; Ex	bb tt
	bra	<spf

spnotoff		; 8x nn vv
	bsr		<noteident

	jsr		retrievepak
	bne		notoff1
	bsr		getbyte
	bclr		#midi_noteon,y:(r0)
	rts

notoff1
	bra	getbyte

noff2
	move		b,a
;	and		#$7F,a 
	jsr		retrievepak
	bgt		<noff3
	bclr		#midi_noteon,y:(r0)
noff3 
	rts

noteident
	lsl		#8,b
	jsr		getbyte		; nn
	add		a,b
	rts
		
spnoton					; 9x nn vv
	bsr		<noteident
	bsr		getbyte		; vv
	tst	a
	beq		<noff2
;	move		b,a
	jsr		getfreepak	; r0 pointe le paquet
	move		r0,r4
;	move		x:midi_instr,r3
;	move		#-1,m3
;	move		m3,m4
	do		#midi_datasize,spno1
	move		l:(r3)+,x
	move		x,l:(r4)+
spno1
	move		b1,x:(r0)
	and		#$7F,b		; b= N note
 if @def(name\_mulf)||@def(name\_transp)	
	jsr		transform
 endif
	lsl		#16,a			; a= niveau (vlocit)		
	move		b1,n4
	move		#midi_freqs,r4
	move		a,x:(r0+midi_levels)
	move		a,y:(r0+midi_levels)
	move		y:(r4+n4),x0	; freq
	move		x0,y:(r0+1)
;	jsr		getbyte
	bset		#midi_noteon,y:(r0)
	bset		#midi_busy,y:(r0)
	rts


spaftertouch	; Ax nn vv
	bsr	noteident
	bsr	getbyte
	rts

spcontrol		; Bx cc uu
	bsr	getbyte
	bsr	getbyte
	rts

sppatch		; Cx pp
	bsr		getbyte
	move		#midi_chaninstr,r3
	cmp		#>113,a
	blt		<spp1
	move		#midi_piano,a		; #midi_perc,a
spp0	move		a,x:(r3+n3)
	rts
spp1	cmp	#>73,a
	blt	<spp1a
	move	#midi_flute,a
	bra	<spp0
spp1a	cmp	#>65,a
	blt	<spp1b
	move	#midi_hautbois,a
	bra	<spp0
spp1b	cmp	#>57,a
	blt	<spp1c
	move	#midi_trompette,a
	bra	<spp0
spp1c	cmp	#>49,a
	blt	<spp1d
	move	#midi_voix,a
	bra	<spp0
spp1d	cmp	#>41,a
	blt	<spp1e
	move	#midi_violon,a
	bra	<spp0
spp1e	cmp	#>33,a
	blt	<spp3
	move	#midi_basse,a
	bra	<spp0
spp3	cmp	#>25,a
	blt	<spp4  
	move	#midi_guitar,a
	bra	<spp0
spp4	cmp	#>17,a
	blt	<spp5
	move	#midi_orgue,a
	bra	<spp0
spp5	cmp	#>9,a
	blt	<spp6
	move	#midi_banjo,a
	bra	<spp0
spp6	cmp	#>4,a
	blt	<spp7
	move	#midi_vieux_piano,a
	bra	<spp0
spp7	move	#midi_piano,a
	bra	<spp0



spchanafttch	; Dx cc
	bsr	getbyte
	rts

sppitch		; Ex	bb tt
	bsr	getbyte
	bsr	getbyte
	rts

spf			; multiple ...
	move	#tabspf,r6
	move	b1,n6
	jmp	(r6+n6)
tabspf
	bra	<spf0
	bra	<spf1
	bra	<spf2
	bra	<spf3
	bra	<spf4
	bra	<spf5
	bra	<spf6
	bra	<spf7
	bra	<spf8
	bra	<spf9
	bra	<spfa
	bra	<spfb
	bra	<spfc
	bra	<spfd
	bra	<spfe
	bra	<spff

spf0			; system exclusive
	bsr	vlq
	do	a1,spf0a
	bsr	getbyte
	nop
spf0a
	rts

spf1	bra	<midi_error
spf2	bra	<midi_error
spf3	bra	<midi_error
spf4	bra	<midi_error
spf5	bra	<midi_error
spf6	bra	<midi_error

spf7			; system exclusive bis
	bsr	vlq
	do	a1,spf7a
	bsr	getbyte
	nop
spf7a
	rts

spf8			; sync
	rts
spf9	bra	<midi_error
spfa			; start seq
	rts
spfb			; continue
	rts
spfc			; stop
	move	#-1,a1
	sta1		midi_timer
	rts
spfd	bra	<midi_error
spfe	bra	<midi_error

spff	bsr	getbyte	; meta event
;	bsr	vlq
	cmp	#$2F,a
	bne	spff2
	bsr	getbyte
	bset	#midi_eot,x:(r5)
	rts

spff2
	cmp	#$51,a	; FF 51 03 tt tt tt tempo s/q
	bne	<spff3
	bsr	getbyte	; 03
	bsr	getw24	; a=tt tt tt
	move	a,x0		; x0 = tt tt tt s/q
	move	#>(actual_fs/1e6),x1
	mpy	x0,x1,b
	lda	midi_division	; a = dd dd ticks/q
	lsl	a
	move	b,x0		; x0= tt tt tt *Fs/1e6

	andi	#$fe,ccr
	do	#24,div1
	div	x0,a
div1
	sta0		midi_speed
	rts


spff3	cmp	#>7,a
	ble	<text 
	bsr	getbyte
	tst	a
	beq	<spff1
	do	a1,spff0
	bsr	getbyte
	nop
	nop
spff0
spff1 rts

outch
	lsl		#16,a
	putfifo	sndc,256,0	; A1=12b (8char + 4 Attr) en b23..b12
	rts

message
	movem	p:(r0)+,a
	tst		a
	beq		mess1
	bsr		outch
	bra		message
mess1
	rts

	opt	nops
hello
	dc	13,10
	dc	'     /// FIBULA MIDI player V. Beta ///'
	dc	13,10,10,10,0
msghello
	move		#-1,m0
	move		#hello,r0
	bra		message	
	opt	ps

text
	move	#10,a1
	jsr	outch
	move	#13,a1
	jsr	outch
	bsr	getbyte
	tst	a
	beq	<txt1
	do	a1,txt0
	bsr	getbyte
	bsr	outch
	nop
	nop
txt0
txt1 rts




midi_error	jsr	resetall
	bra	debut

;	move	a1,n6		; type
;	move	#tabmeta,r6
;	nop
;	jmp	(r6+n6)

;tabmeta
;	bra	<meta0
;

getbyte
	lda		midi_cmddta
	bset		#7,x:midi_cmddta
	bcs		<gb0
	rts

gb0	move		x:(r5+midi_bytepos),a
	sub		#>8,a
	bpl		<gb1
	move		x:(r5+midi_ptr),r7
	move		#>16,a
 if @msp(name\_in)==1
	move		x:(r7)+,x0
 endif
 if @msp(name\_in)==2
	move		y:(r7)+,x0
 endif
 if @msp(name\_in)==4
	movem	p:(r7)+,x0
 endif
	move		x0,x:(r5+midi_curword)
	move		r7,x:(r5+midi_ptr)
gb1	move		a,x:(r5+midi_bytepos)
	move		a1,x0
	move		x:(r5+midi_curword),a
	beq		<gb2
	lsr		x0,a	
gb2	and		#$ff,a
	move		a1,a
	rts

getword
	bsr		getbyte
	move		a,b
	lsl		#8,b
	bsr		getbyte
	add		b,a
	rts

getw24
	bsr		getbyte
	move		a,b
	lsl		#8,b
	bsr		getbyte
	add		a,b
	lsl		#8,b
	bsr		getbyte
	add		b,a
	rts

getbyteabs
	lda		midi_absbytepos
	sub		#>8,a
	bpl		<gba1
	move		#>16,a
 if @msp(name\_in)==1
	move		x:(r7)+,x0
 endif
 if @msp(name\_in)==2
	move		y:(r7)+,x0
 endif
 if @msp(name\_in)==4
	movem	p:(r7)+,x0
 endif
	stx0		midi_abscurword
gba1
	sta		midi_absbytepos
	move		a1,x0
	lda		midi_abscurword
	beq		<gba2
	lsr		x0,a
gba2
	and		#$ff,a
	move		a1,a
	rts

getwordabs
	bsr		getbyteabs
	move		a,b
	lsl		#8,b
	bsr		getbyteabs
	add		b,a
	rts

getw24abs
	bsr		getbyteabs
	move		a,b
	lsl		#8,b
	bsr		getbyteabs
	add		a,b
	lsl		#8,b
	bsr		getbyteabs
	add		b,a
	rts



getfreepak
	move		#midi_chandata,r0
	move		#midi_datasize,n0
	move		#-1,m0
gfpk1
	move		l:(r0)+n0,x		
	cmp		x1,b
	beq		<gfpk2
	btst		#midi_busy,x0	; y:(r0)+n0
	bcs		gfpk1
gfpk2
	move		(r0)-n0
	rts		

retrievepak
	move		#midi_chandata,r0
	move		#midi_datasize,n0
	move		#-1,m0
	nop
retr0
	move		x:(r0)+n0,x0
	do		#midi_maxchans,retr1
	cmp		x0,b		x:(r0)+n0,x0
	nop
	brkeq
	nop		
	nop
	nop
retr1
	move		(r0)-n0 
	move		(r0)-n0
	rts

resetall
	clr	a	#midi_chandata,r0
	move		#-1,m0
	move		#midi_maxchans*midi_datasize,n0
	move		m0,m4
	rep		n0
	move		a,l:(r0)+
	move		#midi_chaninstr,r3
	move		#0,n3
	move		#-1,m3
	move		#>deft_instr,a
	bsr		spp1	
;	move		#midi_piano,a
	rep		#16
	move		a1,x:(r3)+
	rts


; Transformation de la mlodie
; n = (n div 12)*12 + (n*m mod 12) + d
; n dans b1
transform
	var		savb
 if @def(name\_transp)
	ldx0		name\_transp
	add		x0,b
 endif
 if @def(name\_mulf)
	move		b1,y0		; //x:savb	; = n initial
	move		b1,b
trsf1
	sub		#12,b
	bge		trsf1
	add		#12,b			; b= n mod 12 //; r6 = n div 12
	move		b1,x1			; x1= n mod 12
	move		y0,b
	sub		x1,b				; b1=base(n)		
	ldy0		name\_mulf
	mpy		x1,y0,b	b1,y0	; b0=2 (n mod 12) * m   y0=base
	asr		b	
	move		#>12,x0
	move		#0,x1
trsf2
	sub		x,b
	bge		trsf2
	add		x,b		#0,y1	; b0=n*m mod 12
	add		y,b
	move		b0,b
 endif
	rts
   
	endsec


	endm
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


