;; Channel Mutual Information estimation (calib by 1/64)
;; Syntax:	mutinfo	name,lin,col,epsi
;; Inputs: name_tx, name_rx = both ends of channel


mutinfo	macro	name,lin,col,epsi

		vard	name\_temp,0
		vard	name\_acc,0

		cn	name\_chan_in,name\_h_lin
		cn	name\_chan_out,name\_h_col

		histo2d	name\_h,lin,col,epsi
		
		jcnf		name\_h_new,name\_5

		move		#name\_h_mat,r4
		move		#name\_h_plin,r1
		move		#col,n4
		clr		a
		sta		name\_acc

		do		#lin,name\_4
		move		#name\_h_pcol,r2
		do		#col,name\_3
		jf		name\_h_yf,name\_1
		move		x:(r4)+,a			; a=p(x,y)
		bra		<name\_2
name\_1	move		y:(r4)+,a			; a=p(x,y)
name\_2
		move		a1,n1
		jsr		flog2				; log2(p(x,y))
		asr		#6,a,a
		sta		name\_temp

		move		x:(r1),x0
		move		x:(r2)+,x1
		mpy		x0,x1,a
		jsr		flog2				; log2(p(x).p(y))
		asr		#6,a,a
		ldb		name\_temp
		sub		a,b		n1,x0	
		move		b,x1				; x1 =lg(pxy)-lg(px.py) x0=pxy

		lda		name\_acc
		mac		x0,x1,a
		sta		name\_acc		

name\_3
		move		(r1)+
name\_4
;		asl		#6,a,a
		sta		name
		flagset	name\_rdy
name\_5
	





	if	!@def(lg2coef)
	section	data	global
	org	y:	

;; approx log2(x) par poly du 5eme ordre MatLab POLYFIT

lg2coef dc	-0.236856,0.631994,-0.875888,0.800231,-0.406756,0.087275

;NB: coeffs de x^0 a x^5    (a multiplier par 16)
	endsec
	endif


	section	routines
	org	p:

	if	!@def(flog2)
	global	flog2
	
flog2	move	#lg2coef,r0
	move	#-1,m0
	clb	a,b
	normf	b1,a
	move	a,x0
	move	b1,n0

	move	y:(r0)+,a			; a = k0
	mpyr	x0,x0,b		y:(r0)+,y1	; b = x^2	y1 = k1	

	mac	x0,y1,a b,x1	y:(r0)+,y1 	; a = a+k1.x  y1 = k2 x1=x^2 
	mpyr	x0,x1,b		b,y0		; b = x^3	y0 = x^2

	mac	y0,y1,a		y:(r0)+,y1	; a = a+k2.x^2  y1 = k3
	mpyr	y0,y0,b		b,x1		; b = x^4	x1 = x^3

	mac	x1,y1,a		y:(r0)+,y1	; a = a+k3.x^3  y1 = k4
	mpyr	x1,y0,b		b,x0		; b = x^5	x0 = x^4
	
	mac	x0,y1,a	b,x0	y:(r0)+,y1	; a = a+k4.x^4  y1 = k5	x0 = x^5
	mac	x0,y1,a		#0,b		; a = a+k5.x^5
	asl	#4,a,a				; a = 16a
	move	n0,b2				; n0 = fact. puissance de 2
	asr	b
	add	b,a	; a = log2(a initial) = -47 ... +8
	rts
	endif	
	endsec
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


