;; format conversion   length p at f1 --> length q at f2 = f1 * p/q
;; syntax:	newlng	name,p,q
;; input (p bit) = name_in    output (q bit) = name
;; data left-justified I/O: MSB first
;; input flag: name_ck = input present, cleared by execution 
;; output flag: name_ready = new output ready


newlng	macro		name,p,q

	vard		name\_sr,0
	var		name\_ct,0	
name\_msk	set 	((1<<q)-1)<<(24-q)

name\_exe
	ldb		name\_sr
	jnf		name\_ck,name\_1
	ldx0		name\_ct
	lda		name\_in
	move		#0,a2
	asr		x0,a,a
	add		a,b	x0,a	
	add		#p,a
	sta		name\_ct
name\_1
	lda		name\_ct
	sub		#q,a
	blt		<name\_2
	sta		name\_ct
		
	move		#>name\_msk,a
	move		b1,x0
	and		x0,a
	sta1		name
	asl		#q,b,b
	flagset		name\_rdy
name\_2
	jcnf		name\_sync,name\_3
	clr		b
	stb		name\_ct
	stb		name\_sr
	flagclr 		name\_rdy
name\_3

	move		b10,l:name\_sr

	u	a
	u	b
	u	x

	endm



	
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


