;; Packets to stream conversion
;; Implements one Output FIFO
;; Needs an interrupt source
;; Stream outputs are written under IRQ
;; Packet consumption in mainloop

paktoflow	macro	name,bufsize,paksize

 if	@msp(name\_in)==3
	bufm	name\_obuf,l,bufsize	; Complex output FIFO
 else
	bufm	name\_obuf,y,bufsize	; output FIFO
 endif

	org	p:
	jnot		name\_wrpak,name\_0						; if write_packet flag then put packet to output fifo
	ptr		name\_owr,2,name\_obuf,bufsize-1,paksize	; get write pointer in R2
	move		#name\_in,r0								; get source pointer in R0
	move		#-1,m0
	do		n2,name\_00
 if	@msp(name\_in)==3
	move		l:(r0)+,x
	move		x,l:(r2)+
 endif
 if	@msp(name\_in)==2
	move		y:(r0)+,x0
	move		x0,y:(r2)+
 endif
 if	@msp(name\_in)==1
	move		x:(r0)+,x0
	move		x0,y:(r2)+
 endif
name\_00
	ptru	name\_owr
	flagset	name\_put
name\_0

	section		irq

	ptr		name\_ord,2,name\_obuf,bufsize-1,
	ptr		name\_onb,3,-1,-1,paksize

	jcnf		name\_put,name\_3
	move		(r3)+n3
name\_3
	btst		#23,r3
	bcs		name\_4
 if @msp(name\_obuf)==3
	move		l:(r2)+,x
 else
	move		y:(r2)+,x1
 endif
 if @def(name\_im)
	stx1		name\_re
	stx0		name\_im
 else
  if		@msp(name)==3
	stx		name
  else
	stx1		name
  endif
 endif
	move		(r3)-
name\_4
	
	ptru	name\_ord
	ptru	name\_onb
	u	r0
	u	r1
	u	r2
	u	r3
	u	x
	endsec

	u	r0
	u	r1
	u	r2
	u	r3
	u	x

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


