;; Raised cosine minimum bandwidth pulse shaping
;; Syntax: 	rcpulse	name,baud,alpha,len
;; baud = symbol baud rate in Hz
;; alpha = bandwidth rollof length: 0.0 = Rectangle ... 1.0 = Hann window
;; len = pulse length expressed in symbol periods
;; input: name_in = pulse amplitude; 
;; outputs: name = sum of weighted windowed sinc pulses; name_flag = request new input ; 


rc_pulse	macro	name,bauds,alpha,len 
name\_sps	set	@cvi(actual_fs/bauds)		; samples per symbol
name\_fsps	set	@cvf(name\_sps)

		bufm		name\_fifo,x,@cvi(len)


name\_fc	set	2*bauds/actual_fs


;; Coefficient table 
	section	far	global
	org	y:
name\_coeffs
name\_num	set	(1.-(name\_fsps*len))/2.

	dup	(name\_sps*@cvi(len))
name\_k set	name\_num*bauds/actual_fs
	dc	(@Sin(pi*name\_k)/(pi*name\_k))*@cos(pi*alpha*name\_k)/(1.-4*alpha*alpha*name\_k*name\_k)
name\_num	set	name\_num+1.0
	endm
	endsec



		org	p:
name\_exe
		ptr		name\_ptx,0,name\_fifo,len-1
		ptr		name\_pty,4,name\_coeffs,-1,name\_sps

		jcnf		name\_ck,name\_1
name\_0	lda		name\_in
		move		(r0)-
		move		a,x:(r0)
		move		#name\_coeffs,r4
		ptru		name\_ptx
name\_1
		clr		a		x:(r0)+,x0	y:(r4)+n4,y0
		rep		m0
		mac		x0,y0,a	x:(r0)+,x0	y:(r4)+n4,y0
		macr		x0,y0,a	(r4)+
		ptru		name\_pty
		sta		name


		u	a
		u	x
		u	y
		u	r0
		u	r4
		u	n4
		endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


