;; Function approximation by table read / interpolate
;; Syntax: rdtable	name,su
;; Table may be multi-channel
;; If multichannel (table_col>1) then output is written to a vector 

rdtable	macro	name,su

		org	p:
exe_\name

	lda	name\_in
	move	#-1,m0
	move	#>(name\_table_size/name\_table_col)-1,x0	;; x0=segments

	if	!("su"=='u')
name\_sgn equ	1
	asr	a	#0.5,y1
	add	y1,a			;; a = (x + 1.0) / 2
	endif


	move	a,y0			;; y0= unsigned in
	mpy	x0,y0,a		;; a = u_in*segmts
	lsl	a
	asr	a			;; a1 = int = k ; a0 = pos fract
 if name\_table_col==1
	add	#name\_table,a
	move	a,r0
 else
	move	a1,x0					;; x0 = int(")
	move	#>name\_table_col,y1
	mpy	x0,y1,b	#>name\_table,x0	;; b0 = 2*int*col
	asl	#23,b,b				;; b1 = addr 1st pt in table
	add	x0,b		y1,n0 		;; b1 = 1st pt abs addr,  n0 = col
	move	b1,r0
 endif

	move	a0,x1					;; x1 = fract(")





 if name\_table_col>1
	move	#name,r1
	move	#-1,m1
	do	#name\_table_col,name\_1

	if	@msp(name\_table)==1
	move	x:(r0)+n0,a		;; a  = Yk
	move	x:(r0)-n0,y1	;; y1 = Yk+1
	endif

	if	@msp(name\_table)==2
	move	y:(r0)+n0,a		;; a  = Yk
	move	y:(r0)-n0,y1	;; y1 = Yk+1
	endif

	if	@msp(name\_table)==3
	move	l:(r0)+n0,ab	;; ab  = Yk cplx
	move	l:(r0)-n0,y		;; y   = Yk+1 cplx
	endif

	if	@msp(name\_table)==4
	move	p:(r0)+n0,a		;; a  = Yk
	move	p:(r0)-n0,y1	;; y1 = Yk+1
	endif

      if	@msp(name\_table)==3
	mac	x1,y0,b	b,x0	;; a  = yk +fract*yk+1    	y0=yk
	macr	-x1,x0,b	 	;; a  = yk +fract*(yk+1 -yk)	r0->yk(next chann) 	
	endif
	mac	x1,y1,a	a,y0	;; a  = yk +fract*yk+1    	y0=yk
	macr	-x1,y0,a	(r0)+	;; a  = yk +fract*(yk+1 -yk)	r0->yk(next chann) 	
	
	if	@msp(name)==1
	move	a,x:(r1)+
	endif

	if	@msp(name)==2
	move	a,y:(r1)+
	endif

	if	@msp(name)==3
	move	ab,l:(r1)+
	endif

	if	@msp(name)==4
	move	a,p:(r1)+
	endif
name\_1
 else

  if	@msp(name\_table)==3  	;; COMPLEX
	move	l:(r0)+,ab		;; a  = Yre(k)  b=Yim(k)   
	move	l:(r0),y		;; y1 = Yre(k+1) y0=Yim(k+1)

	mac	x1,y1,a	a,x0	;; a  = yk +fract*yk+1    	y0=yk
	macr	-x1,x0,a		;; a  = yk +fract*(yk+1 -yk)	r0->yk(next chann)

	mac	x1,y0,b	b,x0
	macr	-x1,x0,b	
 	
	sta	name\_re
	stb	name\_im

   else

	if	@msp(name\_table)==1
	move	x:(r0)+,a		;; a  = Yk
	move	x:(r0),y1		;; y1 = Yk+1
	endif

	if	@msp(name\_table)==2
	move	y:(r0)+,a		;; a  = Yk
	move	y:(r0),y1		;; y1 = Yk+1
	endif

	if	@msp(name\_table)==4
	move	p:(r0)+,a		;; a  = Yk
	move	p:(r0),y1		;; y1 = Yk+1
	endif

	mac	x1,y1,a	a,y0	;; a  = yk +fract*yk+1    	y0=yk
	macr	-x1,y0,a		;; a  = yk +fract*(yk+1 -yk)		
	sta	name
  endif
 endif


	u	a
	u	b
	u	x
	u	y
	u	r0
	u	n0
	u	r1

   endm				

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


