;; Virtual Oscilloscope
;; Data coded on 12 bit

scope	macro	decim
chansize	set	512

;; Vars dfinies dans BEGAP
;;	section	abs	global
;	org	y:$03D800
;scopecb
;scope_stat		ds	1
;scope_start	equ	0
;scope_busy		equ	1
;scope_rdy		equ	2
;scope_dosync	equ	3
;scope_edge		equ	4

;scope_syncw	ds	1	; MSB = Sync level, LSB = Sync chan (0= sw sync)
;scope_ptr		ds	1	; position du ptr d'criture au moment de l'envoi
;scope_samp		ds	1	; nb d'chantillons (<=chansize)
;scope_cnt		ds	1	; nb d'ch restant  acqurir
;scope_canx		ds	1	; nb	de canaux
;scope_addr		ds	64	; 4 mots par canal: adresse+champ, bitmask ou adr imag, shift reg 3x8b, sr imag 
;; codage:
;; 0yaaaaaaaaaaaaaaaaaaaaaaaa / 000000000000000000000000 / hhhhhhhhhhhhllllllllllll / xxxxxxxxxxxxxxxxxxxxxxxx    CANAL REEL
;; 0yaaaaaaaaaaaaaaaaaaaaaaaa / 1yaaaaaaaaaaaaaaaaaaaaaa / hhhhhhhhhhhhllllllllllll / hhhhhhhhhhhhllllllllllll    CANAL complexe re / im
;; 1yaaaaaaaaaaaaaaaaaaaaaaaa / 000000001000000000000000 / xxxxxxxxxxxxxxxxxxxxxxxx / xxxxxxxxxxxxxxxxxxxxxxxx    Canal bool adr / bitmask

	section	abs	global
	org	y:$3DE00
scope_bool	ds	chansize		; 0-24 canaux boolens
scope_buf0	ds	chansize		; 0-16 canaux fract
scope_buf1	ds	chansize		;   ...
scope_buf2	ds	chansize
scope_buf3	ds	chansize
scope_buf4	ds	chansize
scope_buf5	ds	chansize
scope_buf6	ds	chansize
scope_buf7	ds	chansize

scope_buf8	ds	chansize
scope_buf9	ds	chansize
scope_bufa	ds	chansize
scope_bufb	ds	chansize
scope_bufc	ds	chansize
scope_bufd	ds	chansize
scope_bufe	ds	chansize
scope_buff	ds	chansize
	endsec


	var 	scope_last
	var	scope_bmask
	var	scope_bool_hi,1
	var	decimcntr,1

	section	inits
	clr	a
	move		a,y:dspstatus
	move		a,y:pcstatus
	move		#scope_bool,a	
	move		a1,y:scope_ptr
	move		#1,a1
	move		a1,y:scope_syncw
	sta1		decimcntr
	move		#chansize,a1
	move		a1,y:scope_samp
	flagset	scope_lo	;; si =0, stocker 12b dans les MSB, sinon OR avec LSB	

	endsec


	org	p:
scope_entry
	jnf		scope_busy,scope14
scope00
 if	@arg('decim')
  if	(decim!=1)
	lda		decimcntr
	sub		#1,a
	beq		<scope0
	sta		decimcntr
	bra		scope_end
scope0
	move		#decim,a1
	sta1		decimcntr
  endif
 endif
scope_0 	
	flagtog	scope_lo
	bset		#scope_busy,y:dspstatus
	move		#scope_desc,r0
	move		#-1,m0
	move		m0,m3
	move		#chansize-1,m2
	move		#chansize,n3	
	move		y:scope_ptr,r2
	move		r2,r3
	move		(r3)+n3		; R3 --> dans buf0 puis buf1 ...
	move		y:scope_canx,x0
	move		#0,y1
	move		#1,a1
	sta1		scope_bmask

	do		x0,scope10
	flagclr	scope_bool
	move		y:(r0)+,r1	; R1= 0yaaa...aaa ou 1yaaa...aaa
	move		y:(r0)+,r4	; R4= 1yaaa...aaa ou 0000..01000 ou 0xxxxxxxxxx

	bclr		#23,r1		;  
	bcc		<scope1		; si msb=1: bool
	flagset	scope_bool
scope1
	bclr		#22,r1		; si Y:
	bcs	<scope1a
scope1c
	move		x:(r1),a
	bra	<scope1b
scope1a
	bclr		#21,r1
	bcs	<scope1c
	move		y:(r1),a
scope1b
	jf		scope_bool,scope6

	jf		scope_lo,scope2
	and		#>$FFF000,a
	move		a,y:(r0)+
	bra		<scope3
scope2
	move		y:(r0)+,x0
	lsr		#12,a
	or		x0,a
	move		a1,y:(r3)+n3

scope3
	bclr		#23,r4
	bcs		scope4
	move		(r0)+
	bra		scope9

scope4
	bclr		#22,r4		; si c=1: complex
	nop
	move		l:(r4),x		;
	tcs		x0,a
	tcc		x1,a			; partie Im

	jf		scope_lo,scope5
	and		#>$FFF000,a
	move		a,y:(r0)+
	bra		<scope9
scope5
	move		y:(r0)+,x0
	lsr		#12,a
	or		x0,a
	move		a1,y:(r3)+n3
	bra		scope9

scope6
	move		r4,x0						;; 2me mot = masque du bit
	and		x0,a		x:scope_bmask,b	;; Test du bit ici,
	beq		scope7
	or		y1,b	(r0)+
	bra		<scope8
scope7
	not		b	(r0)+
	and		y1,b
scope8
	move		b1,y1
	lda		scope_bmask	;                              bch0
	lsl		a	(r0)+	; bits masque =  << 000000001011 
	sta1		scope_bmask
scope9
	nop
	nop
scope10

	jf		scope_lo,scope11
	move		y1,a
	lsl		#12,a
	sta		scope_bool_hi
	bra		<scope_end
scope11	
	lda		scope_bool_hi
	or		y1,a

scope12	move		a1,y:(r2)+		; mot bool dans buf Scope_bool

scope13
	move		r2,y:scope_ptr
	move		y:scope_cnt,a
	sub		#1,a


	move		a1,y:scope_cnt
	bne		scope_end

; Fin d'acquisition:
	bset		#scope_rdy,y:dspstatus
	bclr		#scope_busy,y:dspstatus
	flagclr	scope_busy
	flagclr	scope_sync
	bra		scope_end

scope14
	move		y:pcstatus,y0
	brclr		#scope_start,y0,scope_end
	brclr		#scope_dosync,y0,scope15

	jnf		scope_waitingsync,scope14a
	jcf		scope_sync,scope15
	move		y:scope_syncw,a
	move		a1,x0
	and		#$0F,a
	bne		<scope16
	bra		scope_end	; sync chan 0 = S/W sync  

scope14a
	brclr		#scope_start,y0,scope_end
	flagclr	scope_sync
	flagset	scope_waitingsync
	bra		scope_end 

scope15
	flagclr	scope_waitingsync
	bclr		#scope_start,y:pcstatus
	move		#scope_bool,r0			; Acquisition start
	move		r0,y:scope_ptr
	move		y:scope_samp,r0
	move		r0,y:scope_cnt
	flagset	scope_busy
	flagset	scope_lo
	bra		scope_0

; HW sync
scope16						;; A = Chan Nr   X0 = Sync level 
	sub		#1,a
	asl		a
	asl		a
	add		#scope_desc,a		;; A = Addr of 4-word descriptor 			
	move		a1,r5
	move		#-1,m5
	move		y:(r5)+,r1			;; R1 = bool Y  aaa..aaa 
	bclr		#23,r1
	bcc		scope16a 
							;; Bool channel 
	bclr		#22,r1			;; Y?
	bcs		<scope161
	move		x:(r1),a
	bra		<scope16b
scope161
	bclr		#21,r1
	bcs		<scope162
	move		y:(r1),a			; a=address
	bra		<scope16b
scope162
	move		l:(r1),a


scope16b
	move		y:(r5),x0			; X0 = Bool mask = 0000.. 1.. 000
	and		x0,a			x:scope_last,x0
	beq		<scope16c			; bool = 0
							; bool = 1
	eor		x0,a			a1,x:scope_last    ; changed ? 
	beq		<scope_end
;	brset	#scope_edge,y0,scope15  			; Yes:
	brclr		#scope_edge,y0,scope_end    		; if edge = up, do sync  
	bra		scope15
;	flagset	scope_sync	;;///
;	bra		 <scope_end

scope16c						; Bool=0
	eor		x0,a			a1,x:scope_last	; Changed ?
	beq		<scope_end
;	brclr	#scope_edge,y0,scope15
	brset		#scope_edge,y0,scope_end		; if edge=down, do sync
	bra	scope15
;	flagset	scope_sync
;	bra		<scope_end

scope16a						; FRACT channel
	bclr		#22,r1			; Y: ?
	bcs		<scope163
	move		x:(r1),a
	bra		<scope17
scope163
	bclr		#21,r1			; L: ?
	bcs		<scope164
	move		y:(r1),a			; a=signal qui synchronise
	bra		<scope17
scope164
	move		l:(r1),a
scope17				
	sub		x0,a		x:scope_last,x0
	move		a,x1				; x1= signal-syncw
	bgt		scope18
	mpy		x0,x1,a		x1,x:scope_last	; Sync on neg edge
	bpl		scope_end
;	brclr	#scope_edge,y0,scope15
	brset		#scope_edge,y0,scope_end
	bra		scope15
	flagset	scope_sync
	bra		scope_end
scope18
	mpy		x0,x1,a	x1,x:scope_last	; Sync on pos edge
	bpl		scope_end
;	brset	#scope_edge,y0,scope15
	brclr		#scope_edge,y0,scope_end
	bra		scope15
;	flagset	scope_sync
scope_end

	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r1
	u	r2
	u	r3
	u	n3
	u	r4
	u	r5
	u	r6
	endm
		
	
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


