
sdram	macro

sdram_base	set	$0  ; zone Y

;	section	inits
	move	#$2bE0BF,a1   ;;;#$2860C2,a   ;;#$2B60BF,a1
	move	a1,x:$FFFF7D	; (PTCL)

	movep		#0,y:PDRA
	movep		#0,y:PDRA_1		; cf chip errata
	movep		#$FFFFFF,y:PCRA
	movep		#$FFFFFF,y:PRRA
	movep		#$000007,y:PCRA_1
	movep		#$000007,y:PRRA_1

	move		#$000000,a1
	move		a1,x:EMC_BRH1   ; adresse de base y:$000000
	move		#$000000,a1			;#$0003FF,a
	move		a1,x:EMC_ORH1     ; masque adresse A23:A14

	move		#$000900,a1		; ROWs=13 COLs=9
	move		a1,x:EMC_ORL1

	move		#>$2061,a1		; mode 24 bit zone Y sdram
	move		a1,x:EMC_BRL1

	move 		#$0,a1
	move		a1,x:EMC_MRTPRL 
	move		#>$2000,a1
	move		a1,x:EMC_MRTPRH 
	move		#>$2522,a1
	move		a1,x:EMC_LSDMRL
	move		#>$4002,a1
	move		a1,x:EMC_LSDMRH
	move 		#$0,a1
	move		a1,x:>$FFFE52
	move		#>$6400,a1
	move		a1,x:>$FFFE53
	move		#$2,a1
	move		a1,x:EMC_LCRRL
	move		#>$0000,a1
	move		a1,x:EMC_LCRRH		; enable PLL

	move		#20000,r0
	bsr		delay_10ns
	
	
;; Initialization sequence

    ;;Issue a PRECHARGE-ALL-BANKS command
	move #>$2522,r4
	move r4,x:EMC_LSDMRL
	move #>$6c02,r4
	move r4,x:EMC_LSDMRH
	move #>$123456,r4
	move r4,x:>$200000

;;wait tRP = 18ns
	move #$2,r0
	bsr delay_10ns

;;Issue eight AUTO-REFRESH commands
	do #8,loop_refresh
	move #>$2522,r4
	move r4,x:EMC_LSDMRL
	move #>$4c02,r4
	move r4,x:EMC_LSDMRH
	move #>$123456,r4
	move r4,x:>$200000
;;wait tRFC = 60ns
	move #6,r0
    	bsr  delay_10ns	
loop_refresh

	
;;Issue a MODE-SET command to initialize the mode register
	move #>$2522,r4
	move r4,x:EMC_LSDMRL
	move #>$5c02,r4
	move r4,x:EMC_LSDMRH
	move #>$123456,r4
	move r4,x:>$200000
;;wait tMRD = 2tCK (20ns)
	move #$2,r0
	bsr  delay_10ns

;;Issue a Normal Operation command to get off initalization
   ;WR_IMM x,M_LBIU_LSDMRL,LSDMR_DATA_LOW
	move #>$2522,r4
	move r4,x:EMC_LSDMRL
    ;WR_IMM x,M_LBIU_LSDMRH,(LSDMR_DATA_HI|LSDMR_OP_NO)
	move #>$4002,r4
	move r4,x:EMC_LSDMRH

	bclr	#23,y:CHIP_CFG_EMBC 
    bset    #22,y:CHIP_CFG_EMBC					; External P memory Burst enable

	
	
;	endsec

	org	p:

	nop
	
	section	routines
	global delay_10ns
	org	p:
delay_10ns
	do		r0,delay_10ns_loop
	nop
	nop
delay_10ns_loop
	rts	
	endsec
	endm



