;; Small inverse FFT

sffti	macro		name,size

	bufr		name\_buf,l,size		


 if !@def(twid_\?size)
	section	long	global
name\_inc	set	2.*pi/@cvf(size)
	org		l:	
 
	buffer		r,size/2

name\_angle	set	0
twid_\?size	
	dup	size/2
	dc	@lng(@frc(-@cos(name\_angle)),@frc(-@sin(name\_angle)))
name\_angle set name\_angle+name\_inc
	endm
	endbuf
	endsec
 endif
	org		p:


name\_exe
	move		#size/2,n0		;initialize butterflies per group
	move		#1,n2			;initialize groups per pass
	move		#size/4,n6		;initialize C pointer offset
	move		#-1,m0			;initialize A and B address modifiers
	move		m0,m1			;for linear addressing
	move		m0,m4
	move		m0,m5
	move		#0,m6			;initialize C address modifier for reverse carry (bit-reversed) addressing
; Perform all FFT passes with triple nested DO loop

	do		#@cvi(@log(size)/@log(2)+0.5),name\_end_pass
	move		#name\_buf,r0		;initialize A input pointer
	move		r0,r4			;initialize A output pointer
	move		n0,n1			;initialize pointer offsets
	move		n0,n4
	lua		(r0)+n0,r1		;initialize B input pointer
	move		#twid_\?size,r6	;initialize C input pointer
	move		n0,n5
	lua		(r1)-,r5        	;initialize B output pointer
	do		n2,name\_end_grp
	move	x:(r1),x1	y:(r6),y0	;lookup -sine and -cosine values
	move	x:(r5),a	y:(r0),b	;preload data
	move	x:(r6)+n6,x0			;update C pointer
	do		n0,name\_end_bfy
	mac	-x1,y0,b	y:(r1)+,y1	;Radix 2 DIT butterfly kernel
	macr	-x0,y1,b 	a,x:(r5)+	y:(r0),a
	nop
	subl	b,a	x:(r0),b	b,y:(r4)
	mac	-x1,x0,b	x:(r1),x1
	macr	y1,y0,b	x:(r0)+,a   a,y:(r5)
	subl	b,a        
	move	b,x:(r4)+	y:(r0),b
name\_end_bfy
	move	a,x:(r5)+n5	y:(r1)+n1,y1   ;update A and B pointers
	move	x:(r0)+n0,x1	y:(r4)+n4,y1	
name\_end_grp
	move	n0,b1
	lsr	b	n2,a1			;divide butterflies per group by two
	nop
	lsl	a	b1,n0			;multiply groups per pass by two
	nop
	move	a1,n2
name\_end_pass
	u	a
	u	b
	u	x
	u	y
	u	r0
	u	r1
	u	r4
	u	r5
	u	r6
	u	n0
	u	n1
	u	n2
	u	n4
	u	n5
	u	n6
	endm


