;; Create Sinc table
;; Syntax: sinc	full,points,k,window,calibrate
;; y(n)=w(n).Sin(k.pi.(n-n0))/(k.pi.(n-n0)) n=0..size-1 Full: n0=(size-1)/2  Half: n0=0
;; window= rectangle or blackman_harris
;; calibrate = off or <value>. If <value> given, sum of y(n) = value

sinc	macro name,hf,points,k,win,cal
;;	section	far	global
 if !("win"=='rectangle')
name\_w0	set	0.35875
name\_w1	set	0.48829
name\_w2	set	0.14128
name\_w3	set	0.01168
 endif

 if "hf"=='full'
name\_num	set	(1.-@cvf(points))/2.
name\_angle	set	0.0
name\_inc	set	2.0*pi/@cvf(points)
 else
name\_num	set	0
name\_angle	set	pi
name\_inc	set	pi/@cvf(points)
 endif

 if "cal"=='off'
name\_s	set	1.0
 else
name\_s	set	0.
	dup	points
  if ("win"=='rectangle')
name\_w	set	1.0
  else
name\_w	set	name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle)
name\_angle	set	name\_angle+name\_inc
  endif
  if	name\_num==0.
name\_s	set	name\_s+name\_w
  else
name\_s	set	name\_s+name\_w*(@Sin(k*pi*name\_num))/(k*pi*name\_num)
  endif
name\_num	set	name\_num+1.0
	endm
 endif

 if !("win"=='rectangle')
name\_angle	set	0.0
 endif

 if "hf"=='full'
name\_num	set	(1.-@cvf(points))/2.
name\_angle	set	0.0
name\_inc	set	2.0*pi/@cvf(points)
 else
name\_num	set	0
name\_angle	set	pi
name\_inc	set	pi/@cvf(points)
 endif

	org	y:
name
	dup	points
  if ("win"=='rectangle')
name\_w	set	1.0/name\_s
  else
name\_w	set	(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle))/name\_s
name\_angle	set	name\_angle+name\_inc
  endif
  if	name\_num==0.
		dc	name\_w
  else
		dc	name\_w*(@Sin(k*pi*name\_num))/(k*pi*name\_num)
  endif
name\_num	set	name\_num+1.0
	endm

name\_size	set	points
name\_lin	set	points
name\_col	set	1
name\_field	set	2
;;	endsec

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


