;; Create Sine-Cosine table
;; syntax	sincos	name,points,phi_start,phi_end,unit
;; y_re(n) = cos(phi0 + n*(phi1-phi0)/(points-1)
;; y_im(n) = sin(phi0 + n*(phi1-phi0)/(points-1)
;; Unit can be deg, rad, or half_turns

sincos	macro	name,points,phi0,phi1,unit,align
 if "unit"=='deg'
name\_k	set	pi/180.
 else
  if "unit"=='half_turns'
name\_k	set	pi
  else
name\_k	set	1.0
  endif
 endif
name\_phi	set	phi0*name\_k
name\_delta	set	(phi1-phi0)*name\_k/@cvf(points-1)
	org	l:
 if "align"=='modulo'
	buffer	m,points
 else
  if "align"=='fft'
	buffer	r,points
  endif
 endif
name
;;name\_re	set	@cvs(x,name)
;;name\_im	set	@cvs(y,name)
	dup	points
	dc	@lng(@frc(@cos(name\_phi)),@frc(@sin(name\_phi)))
name\_phi	set	name\_phi+name\_delta
	endm
 if ("align"=='modulo')|("align"=='fft')
	endbuf
 endif
name\_size	equ	points
name\_lin	equ	points
name\_col	equ	1
name\_field	equ	3
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


