;; Create Sine table
;; syntax	sinus	name,points,phi_start,phi_end,unit
;; y(n) = sin(phi0 + n*(phi1-phi0)/(points-1)
;; Unit can be deg, rad, or half_turns

sinus	macro	name,points,phi0,phi1,unit
;;	section far global
 if "unit"=='deg'
name\_k	set	pi/180.
 else
  if "unit"=='half_turns'
name\_k	set	pi
  else
name\_k	set	1.0
  endif
 endif
name\_phi	set	phi0*name\_k
name\_delta	set	(phi1-phi0)*name\_k/@cvf(points-1)
	org	y:
name
	dup	points
	dc	@sin(name\_phi)
name\_phi	set	name\_phi+name\_delta
	endm
name\_size	equ	points
name\_lin	equ	points
name\_col	equ	1
name\_field	equ	2

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


