; Toc Timer stop and display time
; Utility for H/W measuring effective execution time
; Tic = start 
; Toc = stop and display result  

toc	macro	timer,occurences,singref

	if	timer==0 
tcsrx	set	tcsr0
tlrx	set	tlr0
tcrx	set	tcr0
	endif

	if	timer==1 
tcsrx	set	tcsr1
tlrx	set	tlr1
tcrx	set	tcr1
	endif

	if	timer==2 
tcsrx	set	tcsr2
tlrx	set	tlr2
tcrx	set	tcr2
	endif

	var	tictoc_cnt,0
	var	tictoc_max,0
	var	tictoc_min,$7FFFFF
	vard	tictoc_sigma,0

	section	inits
	move	#$7FFFFF,a1
	sta1	tictoc_min
	clr	a
	sta	tictoc_max
	endsec


	org	p:
	nop
	nop
	move	x:tcrx,a

 if "singref"=='single'
	jf	tocdone,tictoc_4
 endif
tictoc_0
	ldx0		tic_time
	sub		x0,a		x:tictoc_max,x1
	move		a1,a
	asl		a		x:tictoc_min,x0	;; a1=delta_T x0=min 
	sub		#6,a
 if @def(toc_sample)
	sta		toc_sample
 endif 
	cmp		x1,a		#>occurences,x1
	ble		<tictoc_1
	sta1 	tictoc_max			;; si a>max, max=a
tictoc_1
	cmp		x0,a		x:tictoc_cnt,b
	bge		<tictoc_2
	sta1		tictoc_min			;; si a<min, min=a
tictoc_2
	asr		#24,a,a
	move		l:tictoc_sigma,y
	add		y,a
	sta		tictoc_sigma

	add	#1,b
	stb1	tictoc_cnt
	cmp	x1,b
	blt	<tictoc_3
 if "singref"=='single'
	flagset	tocdone
 endif 
 if @def(toc_max)
	lda	tictoc_max
	sta	toc_max
 endif 
 if @def(toc_min)
	lda	tictoc_min
	sta	toc_min
 endif
 if @def(toc_average)
	ldx	tictoc_sigma
	move	#>1/@cvf(occurences),y1
	mpysu	y1,x0,a
	dmacss	x1,y1,a
	asl		#24,a,a
	and		#$7FFFFF,a
	sta1		toc_average
 endif
	clr	a
	sta	tictoc_max
	sta	tictoc_cnt
	sta	tictoc_sigma
	move	#1.0,a
	sta	tictoc_min
tictoc_3
 if	@def(tic_irq_masked) 
	move	x:tic_sr,sr
	nop
 endif
tictoc_4 

	u	a
	u	b
	u	x
	u	y
	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


