;; Create window in memory
;; 	window w0,hann,256,1.0
;; if gn=1 then window has original values
;; if gn=1/N then sum of window values will be 1.0 
;; if gn=1/8 then sum of window values will be size/8     

window	macro	name,win,size,gn

name\_size	set	size
name\_col	set	1
name\_lin	set	size
name\_field	set	2

	org	y:

  if "win"=='Triangle'
name\_n	set	0	
name\_s	set	0
	dup	size
name\_s	set name\_s+2.*(0.5*@cvf(size)-@abs(name\_n-0.5*@cvf(size-1)))/@cvf(size)
name\_n	set	name\_n+1
	endm
  endif

  if "win"=='Hann'
name\_n	set	0
name\_s	set	0
	dup	size
name\_s	set	name\_s+0.5*(1.0-@cos(2.*pi*@cvf(name\_n)/@cvf(size-1)))
name\_n	set	name\_n+1
	endm

  endif

  if "win"=='Hamming'
name\_n	set	0
name\_s	set	0
	dup	size
name\_s	set	name\_s+0.54-0.46*@cos(2.*pi*@cvf(name\_n)/@cvf(size-1))
name\_n	set	name\_n+1
	endm
  endif


  if "win"=='Gauss'
name\_sigma	set	0.21
name\_n	set	0
name\_s	set	0
	dup	size
name\_p set	@cvf(name\_n)-@cvf(size-1)/2.
name\_q	set	name\_sigma*@cvf(size-1)/2.
name\_s	set	name\_s+@xpn(-0.5*name\_p*name\_p/(name\_q*name\_q))
name\_n	set	name\_n+1
	endm
  endif



  if "win"=='Blackman_Harris'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	0.35875
name\_w1	set	0.48829
name\_w2	set	0.14128
name\_w3	set	0.01168

name\_angle	set	0.0
name\_s	set	0
	dup	size
name\_s	set	name\_s+(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif


  if "win"=='Nuttall'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	0.3635819
name\_w1	set	0.4891775
name\_w2	set	0.1365995
name\_w3	set	0.0106411

name\_angle	set	0.0
name\_s	set	0
	dup	size
name\_s	set	name\_s+(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif

  if "win"=='Flat_Top'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	1.0
name\_w1	set	1.93
name\_w2	set	1.29
name\_w3	set	0.388
name\_w4	set	0.032

name\_angle	set	0.0
name\_s	set	0
	dup	size
name\_s	set	name\_s+(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle)+name\_w4*@cos(4.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif

 if	"gn"=='1/8'
name\_g	set	@cvf(size)/(8.0*name\_s)
 else
  if	"gn"=='1/N'
name\_g	set	1.0/name\_s
  else
name\_g	set	1.0
  endif
 endif

name\_mean	set	name\_s/@cvf(size)

	org	y:

  if "win"=='Triangle'
name\_n	set	0	
name
	dup	size
	dc	name\_g*2.*(0.5*@cvf(size)-@abs(name\_n-0.5*@cvf(size-1)))/@cvf(size)
name\_n	set	name\_n+1
	endm
  endif

  if "win"=='Hann'
name
name\_n	set	0
	dup	size
	dc	name\_g*0.5*(1.0-@cos(2.*pi*@cvf(name\_n)/@cvf(size-1)))
name\_n	set	name\_n+1
	endm

  endif

  if "win"=='Hamming'
name
name\_n	set	0
	dup	size
	dc	name\_g*(0.54-0.46*@cos(2.*pi*@cvf(name\_n)/@cvf(size-1)))
name\_n	set	name\_n+1
	endm
  endif


  if "win"=='Gauss'
name\_sigma	set	0.21
name
name\_n	set	0
	dup	size
name\_p set	@cvf(name\_n)-@cvf(size-1)/2.
name\_q	set	name\_sigma*@cvf(size-1)/2.
	dc	name\_g*@xpn(-0.5*name\_p*name\_p/(name\_q*name\_q))
name\_n	set	name\_n+1
	endm
  endif



  if "win"=='Blackman_Harris'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	0.35875
name\_w1	set	0.48829
name\_w2	set	0.14128
name\_w3	set	0.01168

name
name\_angle	set	0.0
	dup	size
	dc	name\_g*(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif


  if "win"=='Nuttall'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	0.3635819
name\_w1	set	0.4891775
name\_w2	set	0.1365995
name\_w3	set	0.0106411

name
name\_angle	set	0.0
	dup	size
	dc	name\_g*(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif

  if "win"=='Flat_Top'
name\_inc1	set	2.0*pi/@cvf(size-1)
name\_w0	set	1.0
name\_w1	set	1.93
name\_w2	set	1.29
name\_w3	set	0.388
name\_w4	set	0.032

name
name\_angle	set	0.0
	dup	size
	dc	name\_g*(name\_w0-name\_w1*@cos(name\_angle)+name\_w2*@cos(2.0*name\_angle)-name\_w3*@cos(3.0*name\_angle)+name\_w4*@cos(4.0*name\_angle))
name\_angle	set	name\_angle+name\_inc1
	endm
  endif

	endm

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use


