;; Convert a vector of long "source" into a vector "name" expressed in dB
;;  0dB-->+1 ... -200dB--> -1

dbvec	macro	name,source,size

	if	!@def(name)
	section data global
	org	y:
name	ds	size
	endsec
	endif
	
;	section exec
	org	p:
	move	#-1,m1
	move	#source,r1
	move	#name,r4
	move	m1,m4
	do	#size,_db1
	move	l:(r1)+,a
	jsr	decibel
	move	a,y:(r4)+
	nop
_db1
	nop

;	endsec

;; DECIBEL function in_name = 1..1E-10 (0..-200dB) --> out_\name = 0..-1 
;; approx log2(x) par poly dy 5eme ordre MatLab POLYFIT

	
	if	!@def(decibel)
	section	routines
	global	decibel
	
;; dB = 10 log(2).lg2(x)
;; dB/200 = 10 x 0.30103 x 0.32 lg2(x)/64  = 0.96330 . lg2(x) / 64
	org	p:
decibel	tst	a
	bgt	<_db0
	move	#-1.0,a
	rts
_db0	bsr	flog2	; a = log2(x) [-47 ... +8[
	asr	#6,a,a	; div /64 pour que |A| < 1
	
	move	a,x0
	mpyi	#0.96330,x0,a	; 0dB --> a = 0  -200dB --> a = -1
;	asl	a		; 0..-100 dB
	
;	add	#0.5,a	
;	asl	a		; 0dB --> a = 1  -100dB -> a=0   -200dB -> a=-1
	rts
	endsec
	endif

	if	!@def(flog2)

	section	data	local
	org	y:	
lg2coef dc	-0.236856,0.631994,-0.875888,0.800231,-0.406756,0.087275
;NB: coeffs de x^0 a x^5    (a multiplier par 16)
	endsec

	section	routines
	global	flog2

	org	p:
flog2	move	#lg2coef,r0
	move	#-1,m0
	clb	a,b
	normf	b1,a
	move	a,x0
	move	b1,n0

	move	y:(r0)+,a			; a = k0
	mpyr	x0,x0,b		y:(r0)+,y1	; b = x^2	y1 = k1	

	mac	x0,y1,a b,x1	y:(r0)+,y1 	; a = a+k1.x  y1 = k2 x1=x^2 
	mpyr	x0,x1,b		b,y0		; b = x^3	y0 = x^2

	mac	y0,y1,a		y:(r0)+,y1	; a = a+k2.x^2  y1 = k3
	mpyr	y0,y0,b		b,x1		; b = x^4	x1 = x^3

	mac	x1,y1,a		y:(r0)+,y1	; a = a+k3.x^3  y1 = k4
	mpyr	x1,y0,b		b,x0		; b = x^5	x0 = x^4
	
	mac	x0,y1,a	b,x0	y:(r0)+,y1	; a = a+k4.x^4  y1 = k5	x0 = x^5
	mac	x0,y1,a		#0,b		; a = a+k5.x^5
	asl	#4,a,a				; a = 16a
	move	n0,b2				; n0 = fact. puissance de 2
	asr	b
	add	b,a	; a = log2(a initial) = -47 ... +8
	rts
	endsec
	endif	; not def flog2
	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 07/05/2001

