;; First-in first-out queue of multiple data
;; Syntax:	fifo	name,field,size,chan
;; field = x,y, or p  size= buffer size of each channel, chan= number of channels
;; Fifo control flags: name_ie = input enable (cleared when fifo full)
;; name_rdy = data available at output; must be cleared by data consumer
;; Inputs: name_in; boolean name_reset;    Output: name
;;


mfifo	macro	name,field,size,chans
	var	name\_count,0
	bufm	name\_buf,field,(size*chans)


	section	inits
	clr	a
	sta	name\_count
	endsec


name\_exe
	ptr	name\_wp,1,name\_buf,size*chans-1
	ptr	name\_rp,2,name\_buf,size*chans-1

	jcnf	name\_reset,name\_1
	move	#name\_buf,r1
	move	r1,r2
	clr	a
	sta	name\_count
	flagclr name\_rdy
	bra	name\_4
name\_1
	lda	name\_count
	jnf	name\_ie,name\_2


	dupf	num,1,chans
	ldx0	name\_in\?num
	move	x0,field:(r1)+
	endm


;	ptru	name\_wp
	add	#1,a
	cmp	#size,a
	blt	<name\_2
	flagclr name\_ie

name\_2

	jf name\_rdy,name\_3
	tst	a
	ble	<name\_3


	dupf	num,1,chans
	move	field:(r2)+,x0
	stx0	name\?num
	endm
;	ptru	name\_rp

	sub	#1,a
	flagset name\_rdy
name\_3
	sta	name\_count
name\_4
	ptru	name\_wp
	ptru	name\_rp
	

	u	a
	u	x
	u	r1
	u	r2

	dbgw	MFIFO
	dbgf	name\_ie
	dbg	name\_in1
	dbgf	name\_rdy
	dbg	name\1

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 22/05/2008

