;; Non linear function by table reading
;; Version for externaly defined table

;; Linear interpolation is performed between points  
;; 

;; Signed input: tabrd  name,table_address,segments,s
;; Values are given for equally spaced inputs  x(k) = -1.+2k/(n-1) k=0..(n-1) 
;; The first table value is the nl output for in = -1.0
;; The last table value is the nl output for in = +1.0 (never reached)

;; Unsigned input: tabrd  name,table_address,u
;; Values are given for equally spaced inputs  x(k) = k/(n-1) k=0..(n-1) 
;; The first table value is the nl output for in = 0.0
;; The last table value is the nl output for in = +1.0 (never reached)


tabrd	macro	name,tad,tlng,su

	var	name,0
		org	p:
	cc_rst
exe_\name
	if	!rgin
	lda	name\_in
	move	#tad,r0
	move	#>tlng-1,x0
	endif

	move	#-1,m0

	if	!("su"=='u')
	asr	a	#0.5,y1
	add	y1,a			; a = (x + 1.0) / 2
	endif

	jsr	<tbrd
	cc_add	14
	sta	name
	cc_ac	1

	if	!@def(tbrd)
	section	routines
	global	tbrd

	org	p:
tbrd	move	a,y0			; y0= unsigned in
	mpy	x0,y0,a			; a = u_in*segmts
	lsl	a
	asr	a			; a1 = int = k ; a0 = pos fract
	move	a1,n0			; n0 = int(")	
	move	a0,x1			; x1 = fract(")
	move	(r0)+n0			; r0 = absc(yk)
	move	y:(r0)+,a		; a  = Yk
	move	y:(r0),y1		; y1 = Yk+1
	mac	x1,y1,a		a,y0	; a  = yk +fract*yk+1    y0=yk
	macr	-x1,y0,a		; a  = yk +fract*(yk+1 -yk)		
	rts
	
	endsec
	endif
	u	a
	u	x
	u	y
	u	r0
	u	n0
	u	m0

	varin
   endm				

;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 04/05/2001

