;; val	name,string[,max]
;; Convert decimal string to fractionnal value
;; name = block name
;; s = input string address
;; lng_s = string length
;; f = scaling factor: what input converts to 1.0
;; Note: value of s must be < to f
;; name = fractionnal output

; s = [sgn] d1 d2 .. dp . d(p+1)..dn
; val = (d1*0.1 + d2*0.01 + .. + dn*10^-n) * (10^p/f) * [-1.0] 

; val = 0.1 * (d1 + 0.1*(d2 + 0.1*(d3 + ... + 0.1*(dn)))))) * .. 



val	macro	name,str,max
	if	@cnt()==2
	val	name,str,1.0
	else

name\_exe
	move	#str,r0
	jsr	valxpn
	jnf	valok,name\_ex1
	move	#str,r0
	jsr	valmant

;; if a scaling factor max is given, 
;; so that f= coeff*10^rg with coeff = [1..10[
;; then do 
;; a = a/coef  r4 = r4-rg

	if	max!=1.0
rg	set	@cvi(@flr(@l10(max)))			; rg=0 for 1.xxx
coeff	set	@pow(10.0,(@l10(max)-@flr(@l10(max))))	; max = coeff*10^rg
	move	#1./coeff,x1
	move	#-rg,n4
	jsr	valf
	else
	jsr	valrg
	endif

	sta	name
name\_ex1
; -----------



	if	!@def(valxpn)
	section routines
	global	valxpn,valmant,valf,valrg

valxpn	move	#-1,m0
	clr	a
	move	#1,r4
	flagclr	neg
	flagclr	nul
	flagset	valok
; Get exponent of s:

; Search the first significant digit or decimal point
_val0	move	y:(r0)+,b
	cmp	#$20,b
	bgt	<_val0b
	flagclr	valok
	rts
_val0b	cmp	#'-',b
	bne	<_val0a
	flagset	neg		; if '-' sign encountered, set flag
_val0a	cmp	#'0',b		; scan string for a digit > '0'
	bgt	<_val2
	cmp	#'.',b		; or a '.'
	beq	<_val1
	cmp	#$20,b		; until end of string
	bgt	<_val0
	flagset	nul		; if none found, result is 0
	rts

_val1	move	y:(r0)+,b	; if '.' found first, search 1st digit > 0
	move	(r4)-		; while decounting digits
	cmp	#'0',b
	bgt	<_valr
	cmp	#$20,b
	bgt	<_val1
	flagset	nul		; result 0
	rts


_val2	move	y:(r0)+,b	; if M significant digit found first
	cmp	#'.',b		; search for '.'
	beq	<_valr
	move	(r4)+		; while counting digits
	cmp	#$20,b
	bgt	<_val2		; until end of string
	move	(r4)-			; in = 10^r4 * 0.xxxx
_valr	rts



; get mantissa of s


valmant	move	#>0.1,x1
	
_val3	move	y:(r0)+,b
	cmp	#'0',b
	ble	<_val3	; search first significant digit
	bra	<_val5

_val4	move	y:(r0)+,b
	cmp	#$20,b
	ble	<_val6
_val5	sub	#'0',b
	bmi	<_val4
	asl	#19,b,b		; b  = 0xxx x000 ..0  = 0 .. 9/16
	move	b,x0
	mac	x0,x1,a		; a  = a + (0.1)^n * digit/16
	mpyr	#>0.1,x1,b	; make new power of 10
	move	b,x1		; in x1
	bra	<_val4
_val6	asl	#4,a,a		; a = 0.xxxxx
	rts

valf	move	a,x0
	mpyr	x0,x1,a
	move	(r4)+n4
valrg
; do a = a * 10^r4

_val7	move	r4,b
	tst	b
	beq	<_val9
	bmi	<_val8
	move	a1,x1
	move	a0,x0
	asl	#2,a,a
	add	x,a
	asl	a
	move	(r4)-
	bra	<_val7

_val8	move	a,x0
	mpyri	#>0.1,x0,a
	move	(r4)+
	bra	<_val7

; change sign if '-'

_val9	brclr   #neg_b,y:neg_w,_val10
	neg	a
_val10	rts
	endsec
	endif	

	endif

	endm
;; DSP56300 ASM Code
;; Written by Jean-Marie ORY
;; Free software restricted to academic use
;; Last update 18/10/2005

