;------------------------------------------------------------------------------- 
; file:         "app1.asm"
; revision:     961105
; target file:  app1.cld
; description:  main file for "app1" application; demonstrates multifile
;               assembly coding techniques
;------------------------------------------------------------------------------- 

;...............................................................................
        section app1_vec

        xref    start           ; reference to external symbol 

        org     p:0             ; beginning of exception "vector" table 
        jmp     start

        ds      $fe             ; define storage block (available for 
                                ; remainder of vector table)

        endsec

;...............................................................................
        section app1_main

        include 'equates.asm'   ; allows "nested equates"

        xdef    start           ; symbol declaration for external usage
        xref    a1_sub1,cf1_sub,cf2_sub,data1,data2

        org     p:START         ; absolute origin (linker cannot relocate)
 
start   move    #>VAL1,a1       ; move immediate value to reg, rt justified             
        jsr     a1_sub1         ; jump to (external) subroutine
        jsr     cf1_sub
        jsr     cf2_sub
        move    y1,x:data1
        jmp     start

        endsec

;...............................................................................
        section app1_data

        xdef    data1,data2

        org     x:      
 
data1   ds      1                       
data2   ds      1

        endsec

;...............................................................................
